# -*- coding: UTF-8 -*-
# author: dameng


"""
unicode 转码表
"""
from dataclasses import asdict

from termcc.core import *

__all__ = ['TERMCC_UNICODE', 'TERMCC_UNICODE_REVERSE_KV']

#thanks for the project emoji
TERMCC_UNICODE = {
    '1st_place_medal': u'\U0001F947',
    '2nd_place_medal': u'\U0001F948',
    '3rd_place_medal': u'\U0001F949',
    'AB_button_(blood_type)': u'\U0001F18E',
    'ATM_sign': u'\U0001F3E7',
    'A_button_(blood_type)': u'\U0001F170',
    'Afghanistan': u'\U0001F1E6\U0001F1EB',
    'Albania': u'\U0001F1E6\U0001F1F1',
    'Algeria': u'\U0001F1E9\U0001F1FF',
    'American_Samoa': u'\U0001F1E6\U0001F1F8',
    'Andorra': u'\U0001F1E6\U0001F1E9',
    'Angola': u'\U0001F1E6\U0001F1F4',
    'Anguilla': u'\U0001F1E6\U0001F1EE',
    'Antarctica': u'\U0001F1E6\U0001F1F6',
    'Antigua_&_Barbuda': u'\U0001F1E6\U0001F1EC',
    'Aquarius': u'\U00002652',
    'Argentina': u'\U0001F1E6\U0001F1F7',
    'Aries': u'\U00002648',
    'Armenia': u'\U0001F1E6\U0001F1F2',
    'Aruba': u'\U0001F1E6\U0001F1FC',
    'Ascension_Island': u'\U0001F1E6\U0001F1E8',
    'Australia': u'\U0001F1E6\U0001F1FA',
    'Austria': u'\U0001F1E6\U0001F1F9',
    'Azerbaijan': u'\U0001F1E6\U0001F1FF',
    'BACK_arrow': u'\U0001F519',
    'B_button_(blood_type)': u'\U0001F171',
    'Bahamas': u'\U0001F1E7\U0001F1F8',
    'Bahrain': u'\U0001F1E7\U0001F1ED',
    'Bangladesh': u'\U0001F1E7\U0001F1E9',
    'Barbados': u'\U0001F1E7\U0001F1E7',
    'Belarus': u'\U0001F1E7\U0001F1FE',
    'Belgium': u'\U0001F1E7\U0001F1EA',
    'Belize': u'\U0001F1E7\U0001F1FF',
    'Benin': u'\U0001F1E7\U0001F1EF',
    'Bermuda': u'\U0001F1E7\U0001F1F2',
    'Bhutan': u'\U0001F1E7\U0001F1F9',
    'Bolivia': u'\U0001F1E7\U0001F1F4',
    'Bosnia_&_Herzegovina': u'\U0001F1E7\U0001F1E6',
    'Botswana': u'\U0001F1E7\U0001F1FC',
    'Bouvet_Island': u'\U0001F1E7\U0001F1FB',
    'Brazil': u'\U0001F1E7\U0001F1F7',
    'British_Indian_Ocean_Territory': u'\U0001F1EE\U0001F1F4',
    'British_Virgin_Islands': u'\U0001F1FB\U0001F1EC',
    'Brunei': u'\U0001F1E7\U0001F1F3',
    'Bulgaria': u'\U0001F1E7\U0001F1EC',
    'Burkina_Faso': u'\U0001F1E7\U0001F1EB',
    'Burundi': u'\U0001F1E7\U0001F1EE',
    'CL_button': u'\U0001F191',
    'COOL_button': u'\U0001F192',
    'Cambodia': u'\U0001F1F0\U0001F1ED',
    'Cameroon': u'\U0001F1E8\U0001F1F2',
    'Canada': u'\U0001F1E8\U0001F1E6',
    'Canary_Islands': u'\U0001F1EE\U0001F1E8',
    'Cancer': u'\U0000264B',
    'Cape_Verde': u'\U0001F1E8\U0001F1FB',
    'Capricorn': u'\U00002651',
    'Caribbean_Netherlands': u'\U0001F1E7\U0001F1F6',
    'Cayman_Islands': u'\U0001F1F0\U0001F1FE',
    'Central_African_Republic': u'\U0001F1E8\U0001F1EB',
    'Ceuta_&_Melilla': u'\U0001F1EA\U0001F1E6',
    'Chad': u'\U0001F1F9\U0001F1E9',
    'Chile': u'\U0001F1E8\U0001F1F1',
    'China': u'\U0001F1E8\U0001F1F3',
    'Christmas_Island': u'\U0001F1E8\U0001F1FD',
    'Christmas_tree': u'\U0001F384',
    'Clipperton_Island': u'\U0001F1E8\U0001F1F5',
    'Cocos_(Keeling)_Islands': u'\U0001F1E8\U0001F1E8',
    'Colombia': u'\U0001F1E8\U0001F1F4',
    'Comoros': u'\U0001F1F0\U0001F1F2',
    'Congo_-_Brazzaville': u'\U0001F1E8\U0001F1EC',
    'Congo_-_Kinshasa': u'\U0001F1E8\U0001F1E9',
    'Cook_Islands': u'\U0001F1E8\U0001F1F0',
    'Costa_Rica': u'\U0001F1E8\U0001F1F7',
    'Croatia': u'\U0001F1ED\U0001F1F7',
    'Cuba': u'\U0001F1E8\U0001F1FA',
    'Curaçao': u'\U0001F1E8\U0001F1FC',
    'Cyprus': u'\U0001F1E8\U0001F1FE',
    'Czechia': u'\U0001F1E8\U0001F1FF',
    'Côte_d’Ivoire': u'\U0001F1E8\U0001F1EE',
    'Denmark': u'\U0001F1E9\U0001F1F0',
    'Diego_Garcia': u'\U0001F1E9\U0001F1EC',
    'Djibouti': u'\U0001F1E9\U0001F1EF',
    'Dominica': u'\U0001F1E9\U0001F1F2',
    'Dominican_Republic': u'\U0001F1E9\U0001F1F4',
    'END_arrow': u'\U0001F51A',
    'Ecuador': u'\U0001F1EA\U0001F1E8',
    'Egypt': u'\U0001F1EA\U0001F1EC',
    'El_Salvador': u'\U0001F1F8\U0001F1FB',
    'England': u'\U0001F3F4\U000E0067\U000E0062\U000E0065\U000E006E\U000E0067\U000E007F',
    'Equatorial_Guinea': u'\U0001F1EC\U0001F1F6',
    'Eritrea': u'\U0001F1EA\U0001F1F7',
    'Estonia': u'\U0001F1EA\U0001F1EA',
    'Ethiopia': u'\U0001F1EA\U0001F1F9',
    'European_Union': u'\U0001F1EA\U0001F1FA',
    'FREE_button': u'\U0001F193',
    'Falkland_Islands': u'\U0001F1EB\U0001F1F0',
    'Faroe_Islands': u'\U0001F1EB\U0001F1F4',
    'Fiji': u'\U0001F1EB\U0001F1EF',
    'Finland': u'\U0001F1EB\U0001F1EE',
    'France': u'\U0001F1EB\U0001F1F7',
    'French_Guiana': u'\U0001F1EC\U0001F1EB',
    'French_Polynesia': u'\U0001F1F5\U0001F1EB',
    'French_Southern_Territories': u'\U0001F1F9\U0001F1EB',
    'Gabon': u'\U0001F1EC\U0001F1E6',
    'Gambia': u'\U0001F1EC\U0001F1F2',
    'Gemini': u'\U0000264A',
    'Georgia': u'\U0001F1EC\U0001F1EA',
    'Germany': u'\U0001F1E9\U0001F1EA',
    'Ghana': u'\U0001F1EC\U0001F1ED',
    'Gibraltar': u'\U0001F1EC\U0001F1EE',
    'Greece': u'\U0001F1EC\U0001F1F7',
    'Greenland': u'\U0001F1EC\U0001F1F1',
    'Grenada': u'\U0001F1EC\U0001F1E9',
    'Guadeloupe': u'\U0001F1EC\U0001F1F5',
    'Guam': u'\U0001F1EC\U0001F1FA',
    'Guatemala': u'\U0001F1EC\U0001F1F9',
    'Guernsey': u'\U0001F1EC\U0001F1EC',
    'Guinea': u'\U0001F1EC\U0001F1F3',
    'Guinea-Bissau': u'\U0001F1EC\U0001F1FC',
    'Guyana': u'\U0001F1EC\U0001F1FE',
    'Haiti': u'\U0001F1ED\U0001F1F9',
    'Heard_&_McDonald_Islands': u'\U0001F1ED\U0001F1F2',
    'Honduras': u'\U0001F1ED\U0001F1F3',
    'Hong_Kong_SAR_China': u'\U0001F1ED\U0001F1F0',
    'Hungary': u'\U0001F1ED\U0001F1FA',
    'ID_button': u'\U0001F194',
    'Iceland': u'\U0001F1EE\U0001F1F8',
    'India': u'\U0001F1EE\U0001F1F3',
    'Indonesia': u'\U0001F1EE\U0001F1E9',
    'Iran': u'\U0001F1EE\U0001F1F7',
    'Iraq': u'\U0001F1EE\U0001F1F6',
    'Ireland': u'\U0001F1EE\U0001F1EA',
    'Isle_of_Man': u'\U0001F1EE\U0001F1F2',
    'Israel': u'\U0001F1EE\U0001F1F1',
    'Italy': u'\U0001F1EE\U0001F1F9',
    'Jamaica': u'\U0001F1EF\U0001F1F2',
    'Japan': u'\U0001F1EF\U0001F1F5',
    'Japanese_acceptable_button': u'\U0001F251',
    'Japanese_application_button': u'\U0001F238',
    'Japanese_bargain_button': u'\U0001F250',
    'Japanese_castle': u'\U0001F3EF',
    'Japanese_congratulations_button': u'\U00003297',
    'Japanese_discount_button': u'\U0001F239',
    'Japanese_dolls': u'\U0001F38E',
    'Japanese_free_of_charge_button': u'\U0001F21A',
    'Japanese_here_button': u'\U0001F201',
    'Japanese_monthly_amount_button': u'\U0001F237',
    'Japanese_no_vacancy_button': u'\U0001F235',
    'Japanese_not_free_of_charge_button': u'\U0001F236',
    'Japanese_open_for_business_button': u'\U0001F23A',
    'Japanese_passing_grade_button': u'\U0001F234',
    'Japanese_post_office': u'\U0001F3E3',
    'Japanese_prohibited_button': u'\U0001F232',
    'Japanese_reserved_button': u'\U0001F22F',
    'Japanese_secret_button': u'\U00003299',
    'Japanese_service_charge_button': u'\U0001F202',
    'Japanese_symbol_for_beginner': u'\U0001F530',
    'Japanese_vacancy_button': u'\U0001F233',
    'Jersey': u'\U0001F1EF\U0001F1EA',
    'Jordan': u'\U0001F1EF\U0001F1F4',
    'Kazakhstan': u'\U0001F1F0\U0001F1FF',
    'Kenya': u'\U0001F1F0\U0001F1EA',
    'Kiribati': u'\U0001F1F0\U0001F1EE',
    'Kosovo': u'\U0001F1FD\U0001F1F0',
    'Kuwait': u'\U0001F1F0\U0001F1FC',
    'Kyrgyzstan': u'\U0001F1F0\U0001F1EC',
    'Laos': u'\U0001F1F1\U0001F1E6',
    'Latvia': u'\U0001F1F1\U0001F1FB',
    'Lebanon': u'\U0001F1F1\U0001F1E7',
    'Leo': u'\U0000264C',
    'Lesotho': u'\U0001F1F1\U0001F1F8',
    'Liberia': u'\U0001F1F1\U0001F1F7',
    'Libra': u'\U0000264E',
    'Libya': u'\U0001F1F1\U0001F1FE',
    'Liechtenstein': u'\U0001F1F1\U0001F1EE',
    'Lithuania': u'\U0001F1F1\U0001F1F9',
    'Luxembourg': u'\U0001F1F1\U0001F1FA',
    'Macau_SAR_China': u'\U0001F1F2\U0001F1F4',
    'Macedonia': u'\U0001F1F2\U0001F1F0',
    'Madagascar': u'\U0001F1F2\U0001F1EC',
    'Malawi': u'\U0001F1F2\U0001F1FC',
    'Malaysia': u'\U0001F1F2\U0001F1FE',
    'Maldives': u'\U0001F1F2\U0001F1FB',
    'Mali': u'\U0001F1F2\U0001F1F1',
    'Malta': u'\U0001F1F2\U0001F1F9',
    'Marshall_Islands': u'\U0001F1F2\U0001F1ED',
    'Martinique': u'\U0001F1F2\U0001F1F6',
    'Mauritania': u'\U0001F1F2\U0001F1F7',
    'Mauritius': u'\U0001F1F2\U0001F1FA',
    'Mayotte': u'\U0001F1FE\U0001F1F9',
    'Mexico': u'\U0001F1F2\U0001F1FD',
    'Micronesia': u'\U0001F1EB\U0001F1F2',
    'Moldova': u'\U0001F1F2\U0001F1E9',
    'Monaco': u'\U0001F1F2\U0001F1E8',
    'Mongolia': u'\U0001F1F2\U0001F1F3',
    'Montenegro': u'\U0001F1F2\U0001F1EA',
    'Montserrat': u'\U0001F1F2\U0001F1F8',
    'Morocco': u'\U0001F1F2\U0001F1E6',
    'Mozambique': u'\U0001F1F2\U0001F1FF',
    'Mrs._Claus': u'\U0001F936',
    'Mrs._Claus_dark_skin_tone': u'\U0001F936\U0001F3FF',
    'Mrs._Claus_light_skin_tone': u'\U0001F936\U0001F3FB',
    'Mrs._Claus_medium-dark_skin_tone': u'\U0001F936\U0001F3FE',
    'Mrs._Claus_medium-light_skin_tone': u'\U0001F936\U0001F3FC',
    'Mrs._Claus_medium_skin_tone': u'\U0001F936\U0001F3FD',
    'Myanmar_(Burma)': u'\U0001F1F2\U0001F1F2',
    'NEW_button': u'\U0001F195',
    'NG_button': u'\U0001F196',
    'Namibia': u'\U0001F1F3\U0001F1E6',
    'Nauru': u'\U0001F1F3\U0001F1F7',
    'Nepal': u'\U0001F1F3\U0001F1F5',
    'Netherlands': u'\U0001F1F3\U0001F1F1',
    'New_Caledonia': u'\U0001F1F3\U0001F1E8',
    'New_Zealand': u'\U0001F1F3\U0001F1FF',
    'Nicaragua': u'\U0001F1F3\U0001F1EE',
    'Niger': u'\U0001F1F3\U0001F1EA',
    'Nigeria': u'\U0001F1F3\U0001F1EC',
    'Niue': u'\U0001F1F3\U0001F1FA',
    'Norfolk_Island': u'\U0001F1F3\U0001F1EB',
    'North_Korea': u'\U0001F1F0\U0001F1F5',
    'Northern_Mariana_Islands': u'\U0001F1F2\U0001F1F5',
    'Norway': u'\U0001F1F3\U0001F1F4',
    'OK_button': u'\U0001F197',
    'OK_hand': u'\U0001F44C',
    'OK_hand_dark_skin_tone': u'\U0001F44C\U0001F3FF',
    'OK_hand_light_skin_tone': u'\U0001F44C\U0001F3FB',
    'OK_hand_medium-dark_skin_tone': u'\U0001F44C\U0001F3FE',
    'OK_hand_medium-light_skin_tone': u'\U0001F44C\U0001F3FC',
    'OK_hand_medium_skin_tone': u'\U0001F44C\U0001F3FD',
    'ON!_arrow': u'\U0001F51B',
    'O_button_(blood_type)': u'\U0001F17E',
    'Oman': u'\U0001F1F4\U0001F1F2',
    'Ophiuchus': u'\U000026CE',
    'P_button': u'\U0001F17F',
    'Pakistan': u'\U0001F1F5\U0001F1F0',
    'Palau': u'\U0001F1F5\U0001F1FC',
    'Palestinian_Territories': u'\U0001F1F5\U0001F1F8',
    'Panama': u'\U0001F1F5\U0001F1E6',
    'Papua_New_Guinea': u'\U0001F1F5\U0001F1EC',
    'Paraguay': u'\U0001F1F5\U0001F1FE',
    'Peru': u'\U0001F1F5\U0001F1EA',
    'Philippines': u'\U0001F1F5\U0001F1ED',
    'Pisces': u'\U00002653',
    'Pitcairn_Islands': u'\U0001F1F5\U0001F1F3',
    'Poland': u'\U0001F1F5\U0001F1F1',
    'Portugal': u'\U0001F1F5\U0001F1F9',
    'Puerto_Rico': u'\U0001F1F5\U0001F1F7',
    'Qatar': u'\U0001F1F6\U0001F1E6',
    'Romania': u'\U0001F1F7\U0001F1F4',
    'Russia': u'\U0001F1F7\U0001F1FA',
    'Rwanda': u'\U0001F1F7\U0001F1FC',
    'Réunion': u'\U0001F1F7\U0001F1EA',
    'SOON_arrow': u'\U0001F51C',
    'SOS_button': u'\U0001F198',
    'Sagittarius': u'\U00002650',
    'Samoa': u'\U0001F1FC\U0001F1F8',
    'San_Marino': u'\U0001F1F8\U0001F1F2',
    'Santa_Claus': u'\U0001F385',
    'Santa_Claus_dark_skin_tone': u'\U0001F385\U0001F3FF',
    'Santa_Claus_light_skin_tone': u'\U0001F385\U0001F3FB',
    'Santa_Claus_medium-dark_skin_tone': u'\U0001F385\U0001F3FE',
    'Santa_Claus_medium-light_skin_tone': u'\U0001F385\U0001F3FC',
    'Santa_Claus_medium_skin_tone': u'\U0001F385\U0001F3FD',
    'Saudi_Arabia': u'\U0001F1F8\U0001F1E6',
    'Scorpio': u'\U0000264F',
    'Scotland': u'\U0001F3F4\U000E0067\U000E0062\U000E0073\U000E0063\U000E0074\U000E007F',
    'Senegal': u'\U0001F1F8\U0001F1F3',
    'Serbia': u'\U0001F1F7\U0001F1F8',
    'Seychelles': u'\U0001F1F8\U0001F1E8',
    'Sierra_Leone': u'\U0001F1F8\U0001F1F1',
    'Singapore': u'\U0001F1F8\U0001F1EC',
    'Sint_Maarten': u'\U0001F1F8\U0001F1FD',
    'Slovakia': u'\U0001F1F8\U0001F1F0',
    'Slovenia': u'\U0001F1F8\U0001F1EE',
    'Solomon_Islands': u'\U0001F1F8\U0001F1E7',
    'Somalia': u'\U0001F1F8\U0001F1F4',
    'South_Africa': u'\U0001F1FF\U0001F1E6',
    'South_Georgia_&_South_Sandwich_Islands': u'\U0001F1EC\U0001F1F8',
    'South_Korea': u'\U0001F1F0\U0001F1F7',
    'South_Sudan': u'\U0001F1F8\U0001F1F8',
    'Spain': u'\U0001F1EA\U0001F1F8',
    'Sri_Lanka': u'\U0001F1F1\U0001F1F0',
    'St._Barthélemy': u'\U0001F1E7\U0001F1F1',
    'St._Helena': u'\U0001F1F8\U0001F1ED',
    'St._Kitts_&_Nevis': u'\U0001F1F0\U0001F1F3',
    'St._Lucia': u'\U0001F1F1\U0001F1E8',
    'St._Martin': u'\U0001F1F2\U0001F1EB',
    'St._Pierre_&_Miquelon': u'\U0001F1F5\U0001F1F2',
    'St._Vincent_&_Grenadines': u'\U0001F1FB\U0001F1E8',
    'Statue_of_Liberty': u'\U0001F5FD',
    'Sudan': u'\U0001F1F8\U0001F1E9',
    'Suriname': u'\U0001F1F8\U0001F1F7',
    'Svalbard_&_Jan_Mayen': u'\U0001F1F8\U0001F1EF',
    'Swaziland': u'\U0001F1F8\U0001F1FF',
    'Sweden': u'\U0001F1F8\U0001F1EA',
    'Switzerland': u'\U0001F1E8\U0001F1ED',
    'Syria': u'\U0001F1F8\U0001F1FE',
    'São_Tomé_&_Príncipe': u'\U0001F1F8\U0001F1F9',
    'T-Rex': u'\U0001F996',
    'TOP_arrow': u'\U0001F51D',
    'Taiwan': u'\U0001F1F9\U0001F1FC',
    'Tajikistan': u'\U0001F1F9\U0001F1EF',
    'Tanzania': u'\U0001F1F9\U0001F1FF',
    'Taurus': u'\U00002649',
    'Thailand': u'\U0001F1F9\U0001F1ED',
    'Timor-Leste': u'\U0001F1F9\U0001F1F1',
    'Togo': u'\U0001F1F9\U0001F1EC',
    'Tokelau': u'\U0001F1F9\U0001F1F0',
    'Tokyo_tower': u'\U0001F5FC',
    'Tonga': u'\U0001F1F9\U0001F1F4',
    'Trinidad_&_Tobago': u'\U0001F1F9\U0001F1F9',
    'Tristan_da_Cunha': u'\U0001F1F9\U0001F1E6',
    'Tunisia': u'\U0001F1F9\U0001F1F3',
    'Turkey': u'\U0001F1F9\U0001F1F7',
    'Turkmenistan': u'\U0001F1F9\U0001F1F2',
    'Turks_&_Caicos_Islands': u'\U0001F1F9\U0001F1E8',
    'Tuvalu': u'\U0001F1F9\U0001F1FB',
    'U.S._Outlying_Islands': u'\U0001F1FA\U0001F1F2',
    'U.S._Virgin_Islands': u'\U0001F1FB\U0001F1EE',
    'UP!_button': u'\U0001F199',
    'Uganda': u'\U0001F1FA\U0001F1EC',
    'Ukraine': u'\U0001F1FA\U0001F1E6',
    'United_Arab_Emirates': u'\U0001F1E6\U0001F1EA',
    'United_Kingdom': u'\U0001F1EC\U0001F1E7',
    'United_Nations': u'\U0001F1FA\U0001F1F3',
    'United_States': u'\U0001F1FA\U0001F1F8',
    'Uruguay': u'\U0001F1FA\U0001F1FE',
    'Uzbekistan': u'\U0001F1FA\U0001F1FF',
    'VS_button': u'\U0001F19A',
    'Vanuatu': u'\U0001F1FB\U0001F1FA',
    'Vatican_City': u'\U0001F1FB\U0001F1E6',
    'Venezuela': u'\U0001F1FB\U0001F1EA',
    'Vietnam': u'\U0001F1FB\U0001F1F3',
    'Virgo': u'\U0000264D',
    'Wales': u'\U0001F3F4\U000E0067\U000E0062\U000E0077\U000E006C\U000E0073\U000E007F',
    'Wallis_&_Futuna': u'\U0001F1FC\U0001F1EB',
    'Western_Sahara': u'\U0001F1EA\U0001F1ED',
    'Yemen': u'\U0001F1FE\U0001F1EA',
    'Zambia': u'\U0001F1FF\U0001F1F2',
    'Zimbabwe': u'\U0001F1FF\U0001F1FC',
    'abacus': u'\U0001F9EE',
    'admission_tickets': u'\U0001F39F',
    'adult': u'\U0001F9D1',
    'adult_dark_skin_tone': u'\U0001F9D1\U0001F3FF',
    'adult_light_skin_tone': u'\U0001F9D1\U0001F3FB',
    'adult_medium-dark_skin_tone': u'\U0001F9D1\U0001F3FE',
    'adult_medium-light_skin_tone': u'\U0001F9D1\U0001F3FC',
    'adult_medium_skin_tone': u'\U0001F9D1\U0001F3FD',
    'aerial_tramway': u'\U0001F6A1',
    'airplane': u'\U00002708',
    'airplane_arrival': u'\U0001F6EC',
    'airplane_departure': u'\U0001F6EB',
    'alarm_clock': u'\U000023F0',
    'alembic': u'\U00002697',
    'alien': u'\U0001F47D',
    'alien_monster': u'\U0001F47E',
    'ambulance': u'\U0001F691',
    'american_football': u'\U0001F3C8',
    'amphora': u'\U0001F3FA',
    'anchor': u'\U00002693',
    'anger_symbol': u'\U0001F4A2',
    'angry_face': u'\U0001F620',
    'angry_face_with_horns': u'\U0001F47F',
    'anguished_face': u'\U0001F627',
    'ant': u'\U0001F41C',
    'antenna_bars': u'\U0001F4F6',
    'anxious_face_with_sweat': u'\U0001F630',
    'articulated_lorry': u'\U0001F69B',
    'artist_palette': u'\U0001F3A8',
    'astonished_face': u'\U0001F632',
    'atom_symbol': u'\U0000269B',
    'automobile': u'\U0001F697',
    'avocado': u'\U0001F951',
    'baby': u'\U0001F476',
    'baby_angel': u'\U0001F47C',
    'baby_angel_dark_skin_tone': u'\U0001F47C\U0001F3FF',
    'baby_angel_light_skin_tone': u'\U0001F47C\U0001F3FB',
    'baby_angel_medium-dark_skin_tone': u'\U0001F47C\U0001F3FE',
    'baby_angel_medium-light_skin_tone': u'\U0001F47C\U0001F3FC',
    'baby_angel_medium_skin_tone': u'\U0001F47C\U0001F3FD',
    'baby_bottle': u'\U0001F37C',
    'baby_chick': u'\U0001F424',
    'baby_dark_skin_tone': u'\U0001F476\U0001F3FF',
    'baby_light_skin_tone': u'\U0001F476\U0001F3FB',
    'baby_medium-dark_skin_tone': u'\U0001F476\U0001F3FE',
    'baby_medium-light_skin_tone': u'\U0001F476\U0001F3FC',
    'baby_medium_skin_tone': u'\U0001F476\U0001F3FD',
    'baby_symbol': u'\U0001F6BC',
    'backhand_index_pointing_down': u'\U0001F447',
    'backhand_index_pointing_down_dark_skin_tone': u'\U0001F447\U0001F3FF',
    'backhand_index_pointing_down_light_skin_tone': u'\U0001F447\U0001F3FB',
    'backhand_index_pointing_down_medium-dark_skin_tone': u'\U0001F447\U0001F3FE',
    'backhand_index_pointing_down_medium-light_skin_tone': u'\U0001F447\U0001F3FC',
    'backhand_index_pointing_down_medium_skin_tone': u'\U0001F447\U0001F3FD',
    'backhand_index_pointing_left': u'\U0001F448',
    'backhand_index_pointing_left_dark_skin_tone': u'\U0001F448\U0001F3FF',
    'backhand_index_pointing_left_light_skin_tone': u'\U0001F448\U0001F3FB',
    'backhand_index_pointing_left_medium-dark_skin_tone': u'\U0001F448\U0001F3FE',
    'backhand_index_pointing_left_medium-light_skin_tone': u'\U0001F448\U0001F3FC',
    'backhand_index_pointing_left_medium_skin_tone': u'\U0001F448\U0001F3FD',
    'backhand_index_pointing_right': u'\U0001F449',
    'backhand_index_pointing_right_dark_skin_tone': u'\U0001F449\U0001F3FF',
    'backhand_index_pointing_right_light_skin_tone': u'\U0001F449\U0001F3FB',
    'backhand_index_pointing_right_medium-dark_skin_tone': u'\U0001F449\U0001F3FE',
    'backhand_index_pointing_right_medium-light_skin_tone': u'\U0001F449\U0001F3FC',
    'backhand_index_pointing_right_medium_skin_tone': u'\U0001F449\U0001F3FD',
    'backhand_index_pointing_up': u'\U0001F446',
    'backhand_index_pointing_up_dark_skin_tone': u'\U0001F446\U0001F3FF',
    'backhand_index_pointing_up_light_skin_tone': u'\U0001F446\U0001F3FB',
    'backhand_index_pointing_up_medium-dark_skin_tone': u'\U0001F446\U0001F3FE',
    'backhand_index_pointing_up_medium-light_skin_tone': u'\U0001F446\U0001F3FC',
    'backhand_index_pointing_up_medium_skin_tone': u'\U0001F446\U0001F3FD',
    'bacon': u'\U0001F953',
    'badger': u'\U0001F9A1',
    'badminton': u'\U0001F3F8',
    'bagel': u'\U0001F96F',
    'baggage_claim': u'\U0001F6C4',
    'baguette_bread': u'\U0001F956',
    'balance_scale': u'\U00002696',
    'bald': u'\U0001F9B2',
    'bald_man': u'\U0001F468\U0000200D\U0001F9B2',
    'bald_woman': u'\U0001F469\U0000200D\U0001F9B2',
    'balloon': u'\U0001F388',
    'ballot_box_with_ballot': u'\U0001F5F3',
    'ballot_box_with_check': u'\U00002611',
    'banana': u'\U0001F34C',
    'bank': u'\U0001F3E6',
    'bar_chart': u'\U0001F4CA',
    'barber_pole': u'\U0001F488',
    'baseball': u'\U000026BE',
    'basket': u'\U0001F9FA',
    'basketball': u'\U0001F3C0',
    'bat': u'\U0001F987',
    'bathtub': u'\U0001F6C1',
    'battery': u'\U0001F50B',
    'beach_with_umbrella': u'\U0001F3D6',
    'beaming_face_with_smiling_eyes': u'\U0001F601',
    'bear_face': u'\U0001F43B',
    'bearded_person': u'\U0001F9D4',
    'bearded_person_dark_skin_tone': u'\U0001F9D4\U0001F3FF',
    'bearded_person_light_skin_tone': u'\U0001F9D4\U0001F3FB',
    'bearded_person_medium-dark_skin_tone': u'\U0001F9D4\U0001F3FE',
    'bearded_person_medium-light_skin_tone': u'\U0001F9D4\U0001F3FC',
    'bearded_person_medium_skin_tone': u'\U0001F9D4\U0001F3FD',
    'beating_heart': u'\U0001F493',
    'bed': u'\U0001F6CF',
    'beer_mug': u'\U0001F37A',
    'bell': u'\U0001F514',
    'bell_with_slash': u'\U0001F515',
    'bellhop_bell': u'\U0001F6CE',
    'bento_box': u'\U0001F371',
    'bicycle': u'\U0001F6B2',
    'bikini': u'\U0001F459',
    'billed_cap': u'\U0001F9E2',
    'biohazard': u'\U00002623',
    'bird': u'\U0001F426',
    'birthday_cake': u'\U0001F382',
    'black_circle': u'\U000026AB',
    'black_flag': u'\U0001F3F4',
    'black_heart': u'\U0001F5A4',
    'black_large_square': u'\U00002B1B',
    'black_medium-small_square': u'\U000025FE',
    'black_medium_square': u'\U000025FC',
    'black_nib': u'\U00002712',
    'black_small_square': u'\U000025AA',
    'black_square_button': u'\U0001F532',
    'blond-haired_man': u'\U0001F471\U0000200D\U00002642\U0000FE0F',
    'blond-haired_man_dark_skin_tone': u'\U0001F471\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'blond-haired_man_light_skin_tone': u'\U0001F471\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'blond-haired_man_medium-dark_skin_tone': u'\U0001F471\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'blond-haired_man_medium-light_skin_tone': u'\U0001F471\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'blond-haired_man_medium_skin_tone': u'\U0001F471\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'blond-haired_person': u'\U0001F471',
    'blond-haired_person_dark_skin_tone': u'\U0001F471\U0001F3FF',
    'blond-haired_person_light_skin_tone': u'\U0001F471\U0001F3FB',
    'blond-haired_person_medium-dark_skin_tone': u'\U0001F471\U0001F3FE',
    'blond-haired_person_medium-light_skin_tone': u'\U0001F471\U0001F3FC',
    'blond-haired_person_medium_skin_tone': u'\U0001F471\U0001F3FD',
    'blond-haired_woman': u'\U0001F471\U0000200D\U00002640\U0000FE0F',
    'blond-haired_woman_dark_skin_tone': u'\U0001F471\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'blond-haired_woman_light_skin_tone': u'\U0001F471\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'blond-haired_woman_medium-dark_skin_tone': u'\U0001F471\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'blond-haired_woman_medium-light_skin_tone': u'\U0001F471\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'blond-haired_woman_medium_skin_tone': u'\U0001F471\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'blossom': u'\U0001F33C',
    'blowfish': u'\U0001F421',
    'blue_book': u'\U0001F4D8',
    'blue_circle': u'\U0001F535',
    'blue_heart': u'\U0001F499',
    'boar': u'\U0001F417',
    'bomb': u'\U0001F4A3',
    'bone': u'\U0001F9B4',
    'bookmark': u'\U0001F516',
    'bookmark_tabs': u'\U0001F4D1',
    'books': u'\U0001F4DA',
    'bottle_with_popping_cork': u'\U0001F37E',
    'bouquet': u'\U0001F490',
    'bow_and_arrow': u'\U0001F3F9',
    'bowl_with_spoon': u'\U0001F963',
    'bowling': u'\U0001F3B3',
    'boxing_glove': u'\U0001F94A',
    'boy': u'\U0001F466',
    'boy_dark_skin_tone': u'\U0001F466\U0001F3FF',
    'boy_light_skin_tone': u'\U0001F466\U0001F3FB',
    'boy_medium-dark_skin_tone': u'\U0001F466\U0001F3FE',
    'boy_medium-light_skin_tone': u'\U0001F466\U0001F3FC',
    'boy_medium_skin_tone': u'\U0001F466\U0001F3FD',
    'brain': u'\U0001F9E0',
    'bread': u'\U0001F35E',
    'breast-feeding': u'\U0001F931',
    'breast-feeding_dark_skin_tone': u'\U0001F931\U0001F3FF',
    'breast-feeding_light_skin_tone': u'\U0001F931\U0001F3FB',
    'breast-feeding_medium-dark_skin_tone': u'\U0001F931\U0001F3FE',
    'breast-feeding_medium-light_skin_tone': u'\U0001F931\U0001F3FC',
    'breast-feeding_medium_skin_tone': u'\U0001F931\U0001F3FD',
    'brick': u'\U0001F9F1',
    'bride_with_veil': u'\U0001F470',
    'bride_with_veil_dark_skin_tone': u'\U0001F470\U0001F3FF',
    'bride_with_veil_light_skin_tone': u'\U0001F470\U0001F3FB',
    'bride_with_veil_medium-dark_skin_tone': u'\U0001F470\U0001F3FE',
    'bride_with_veil_medium-light_skin_tone': u'\U0001F470\U0001F3FC',
    'bride_with_veil_medium_skin_tone': u'\U0001F470\U0001F3FD',
    'bridge_at_night': u'\U0001F309',
    'briefcase': u'\U0001F4BC',
    'bright_button': u'\U0001F506',
    'broccoli': u'\U0001F966',
    'broken_heart': u'\U0001F494',
    'broom': u'\U0001F9F9',
    'bug': u'\U0001F41B',
    'building_construction': u'\U0001F3D7',
    'bullet_train': u'\U0001F685',
    'burrito': u'\U0001F32F',
    'bus': u'\U0001F68C',
    'bus_stop': u'\U0001F68F',
    'bust_in_silhouette': u'\U0001F464',
    'busts_in_silhouette': u'\U0001F465',
    'butterfly': u'\U0001F98B',
    'cactus': u'\U0001F335',
    'calendar': u'\U0001F4C5',
    'call_me_hand': u'\U0001F919',
    'call_me_hand_dark_skin_tone': u'\U0001F919\U0001F3FF',
    'call_me_hand_light_skin_tone': u'\U0001F919\U0001F3FB',
    'call_me_hand_medium-dark_skin_tone': u'\U0001F919\U0001F3FE',
    'call_me_hand_medium-light_skin_tone': u'\U0001F919\U0001F3FC',
    'call_me_hand_medium_skin_tone': u'\U0001F919\U0001F3FD',
    'camel': u'\U0001F42A',
    'camera': u'\U0001F4F7',
    'camera_with_flash': u'\U0001F4F8',
    'camping': u'\U0001F3D5',
    'candle': u'\U0001F56F',
    'candy': u'\U0001F36C',
    'canned_food': u'\U0001F96B',
    'canoe': u'\U0001F6F6',
    'card_file_box': u'\U0001F5C3',
    'card_index': u'\U0001F4C7',
    'card_index_dividers': u'\U0001F5C2',
    'carousel_horse': u'\U0001F3A0',
    'carp_streamer': u'\U0001F38F',
    'carrot': u'\U0001F955',
    'castle': u'\U0001F3F0',
    'cat': u'\U0001F408',
    'cat_face': u'\U0001F431',
    'cat_face_with_tears_of_joy': u'\U0001F639',
    'cat_face_with_wry_smile': u'\U0001F63C',
    'chains': u'\U000026D3',
    'chart_decreasing': u'\U0001F4C9',
    'chart_increasing': u'\U0001F4C8',
    'chart_increasing_with_yen': u'\U0001F4B9',
    'cheese_wedge': u'\U0001F9C0',
    'chequered_flag': u'\U0001F3C1',
    'cherries': u'\U0001F352',
    'cherry_blossom': u'\U0001F338',
    'chess_pawn': u'\U0000265F',
    'chestnut': u'\U0001F330',
    'chicken': u'\U0001F414',
    'child': u'\U0001F9D2',
    'child_dark_skin_tone': u'\U0001F9D2\U0001F3FF',
    'child_light_skin_tone': u'\U0001F9D2\U0001F3FB',
    'child_medium-dark_skin_tone': u'\U0001F9D2\U0001F3FE',
    'child_medium-light_skin_tone': u'\U0001F9D2\U0001F3FC',
    'child_medium_skin_tone': u'\U0001F9D2\U0001F3FD',
    'children_crossing': u'\U0001F6B8',
    'chipmunk': u'\U0001F43F',
    'chocolate_bar': u'\U0001F36B',
    'chopsticks': u'\U0001F962',
    'church': u'\U000026EA',
    'cigarette': u'\U0001F6AC',
    'cinema': u'\U0001F3A6',
    'circled_M': u'\U000024C2',
    'circus_tent': u'\U0001F3AA',
    'cityscape': u'\U0001F3D9',
    'cityscape_at_dusk': u'\U0001F306',
    'clamp': u'\U0001F5DC',
    'clapper_board': u'\U0001F3AC',
    'clapping_hands': u'\U0001F44F',
    'clapping_hands_dark_skin_tone': u'\U0001F44F\U0001F3FF',
    'clapping_hands_light_skin_tone': u'\U0001F44F\U0001F3FB',
    'clapping_hands_medium-dark_skin_tone': u'\U0001F44F\U0001F3FE',
    'clapping_hands_medium-light_skin_tone': u'\U0001F44F\U0001F3FC',
    'clapping_hands_medium_skin_tone': u'\U0001F44F\U0001F3FD',
    'classical_building': u'\U0001F3DB',
    'clinking_beer_mugs': u'\U0001F37B',
    'clinking_glasses': u'\U0001F942',
    'clipboard': u'\U0001F4CB',
    'clockwise_vertical_arrows': u'\U0001F503',
    'closed_book': u'\U0001F4D5',
    'closed_mailbox_with_lowered_flag': u'\U0001F4EA',
    'closed_mailbox_with_raised_flag': u'\U0001F4EB',
    'closed_umbrella': u'\U0001F302',
    'cloud': u'\U00002601',
    'cloud_with_lightning': u'\U0001F329',
    'cloud_with_lightning_and_rain': u'\U000026C8',
    'cloud_with_rain': u'\U0001F327',
    'cloud_with_snow': u'\U0001F328',
    'clown_face': u'\U0001F921',
    'club_suit': u'\U00002663',
    'clutch_bag': u'\U0001F45D',
    'coat': u'\U0001F9E5',
    'cocktail_glass': u'\U0001F378',
    'coconut': u'\U0001F965',
    'coffin': u'\U000026B0',
    'cold_face': u'\U0001F976',
    'collision': u'\U0001F4A5',
    'comet': u'\U00002604',
    'compass': u'\U0001F9ED',
    'computer_disk': u'\U0001F4BD',
    'computer_mouse': u'\U0001F5B1',
    'confetti_ball': u'\U0001F38A',
    'confounded_face': u'\U0001F616',
    'confused_face': u'\U0001F615',
    'construction': u'\U0001F6A7',
    'construction_worker': u'\U0001F477',
    'construction_worker_dark_skin_tone': u'\U0001F477\U0001F3FF',
    'construction_worker_light_skin_tone': u'\U0001F477\U0001F3FB',
    'construction_worker_medium-dark_skin_tone': u'\U0001F477\U0001F3FE',
    'construction_worker_medium-light_skin_tone': u'\U0001F477\U0001F3FC',
    'construction_worker_medium_skin_tone': u'\U0001F477\U0001F3FD',
    'control_knobs': u'\U0001F39B',
    'convenience_store': u'\U0001F3EA',
    'cooked_rice': u'\U0001F35A',
    'cookie': u'\U0001F36A',
    'cooking': u'\U0001F373',
    'copyright': u'\U000000A9',
    'couch_and_lamp': u'\U0001F6CB',
    'counterclockwise_arrows_button': u'\U0001F504',
    'couple_with_heart': u'\U0001F491',
    'couple_with_heart_man_man': u'\U0001F468\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468',
    'couple_with_heart_woman_man': u'\U0001F469\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468',
    'couple_with_heart_woman_woman': u'\U0001F469\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469',
    'cow': u'\U0001F404',
    'cow_face': u'\U0001F42E',
    'cowboy_hat_face': u'\U0001F920',
    'crab': u'\U0001F980',
    'crayon': u'\U0001F58D',
    'credit_card': u'\U0001F4B3',
    'crescent_moon': u'\U0001F319',
    'cricket': u'\U0001F997',
    'cricket_game': u'\U0001F3CF',
    'crocodile': u'\U0001F40A',
    'croissant': u'\U0001F950',
    'cross_mark': u'\U0000274C',
    'cross_mark_button': u'\U0000274E',
    'crossed_fingers': u'\U0001F91E',
    'crossed_fingers_dark_skin_tone': u'\U0001F91E\U0001F3FF',
    'crossed_fingers_light_skin_tone': u'\U0001F91E\U0001F3FB',
    'crossed_fingers_medium-dark_skin_tone': u'\U0001F91E\U0001F3FE',
    'crossed_fingers_medium-light_skin_tone': u'\U0001F91E\U0001F3FC',
    'crossed_fingers_medium_skin_tone': u'\U0001F91E\U0001F3FD',
    'crossed_flags': u'\U0001F38C',
    'crossed_swords': u'\U00002694',
    'crown': u'\U0001F451',
    'crying_cat_face': u'\U0001F63F',
    'crying_face': u'\U0001F622',
    'crystal_ball': u'\U0001F52E',
    'cucumber': u'\U0001F952',
    'cupcake': u'\U0001F9C1',
    'cup_with_straw': u'\U0001F964',
    'curling_stone': u'\U0001F94C',
    'curly_hair': u'\U0001F9B1',
    'curly-haired_man': u'\U0001F468\U0000200D\U0001F9B1',
    'curly-haired_woman': u'\U0001F469\U0000200D\U0001F9B1',
    'curly_loop': u'\U000027B0',
    'currency_exchange': u'\U0001F4B1',
    'curry_rice': u'\U0001F35B',
    'custard': u'\U0001F36E',
    'customs': u'\U0001F6C3',
    'cut_of_meat': u'\U0001F969',
    'cyclone': u'\U0001F300',
    'dagger': u'\U0001F5E1',
    'dango': u'\U0001F361',
    'dashing_away': u'\U0001F4A8',
    'deciduous_tree': u'\U0001F333',
    'deer': u'\U0001F98C',
    'delivery_truck': u'\U0001F69A',
    'department_store': u'\U0001F3EC',
    'derelict_house': u'\U0001F3DA',
    'desert': u'\U0001F3DC',
    'desert_island': u'\U0001F3DD',
    'desktop_computer': u'\U0001F5A5',
    'detective': u'\U0001F575',
    'detective_dark_skin_tone': u'\U0001F575\U0001F3FF',
    'detective_light_skin_tone': u'\U0001F575\U0001F3FB',
    'detective_medium-dark_skin_tone': u'\U0001F575\U0001F3FE',
    'detective_medium-light_skin_tone': u'\U0001F575\U0001F3FC',
    'detective_medium_skin_tone': u'\U0001F575\U0001F3FD',
    'diamond_suit': u'\U00002666',
    'diamond_with_a_dot': u'\U0001F4A0',
    'dim_button': u'\U0001F505',
    'direct_hit': u'\U0001F3AF',
    'disappointed_face': u'\U0001F61E',
    'dizzy': u'\U0001F4AB',
    'dizzy_face': u'\U0001F635',
    'dna': u'\U0001F9EC',
    'dog': u'\U0001F415',
    'dog_face': u'\U0001F436',
    'dollar_banknote': u'\U0001F4B5',
    'dolphin': u'\U0001F42C',
    'door': u'\U0001F6AA',
    'dotted_six-pointed_star': u'\U0001F52F',
    'double_curly_loop': u'\U000027BF',
    'double_exclamation_mark': u'\U0000203C',
    'doughnut': u'\U0001F369',
    'dove': u'\U0001F54A',
    'down-left_arrow': u'\U00002199',
    'down-right_arrow': u'\U00002198',
    'down_arrow': u'\U00002B07',
    'downcast_face_with_sweat': u'\U0001F613',
    'downwards_button': u'\U0001F53D',
    'dragon': u'\U0001F409',
    'dragon_face': u'\U0001F432',
    'dress': u'\U0001F457',
    'drooling_face': u'\U0001F924',
    'droplet': u'\U0001F4A7',
    'drum': u'\U0001F941',
    'duck': u'\U0001F986',
    'dumpling': u'\U0001F95F',
    'dvd': u'\U0001F4C0',
    'e-mail': u'\U0001F4E7',
    'eagle': u'\U0001F985',
    'ear': u'\U0001F442',
    'ear_dark_skin_tone': u'\U0001F442\U0001F3FF',
    'ear_light_skin_tone': u'\U0001F442\U0001F3FB',
    'ear_medium-dark_skin_tone': u'\U0001F442\U0001F3FE',
    'ear_medium-light_skin_tone': u'\U0001F442\U0001F3FC',
    'ear_medium_skin_tone': u'\U0001F442\U0001F3FD',
    'ear_of_corn': u'\U0001F33D',
    'egg': u'\U0001F95A',
    'eggplant': u'\U0001F346',
    'eight-pointed_star': u'\U00002734',
    'eight-spoked_asterisk': u'\U00002733',
    'eight-thirty': u'\U0001F563',
    'eight_o’clock': u'\U0001F557',
    'eject_button': u'\U000023CF',
    'electric_plug': u'\U0001F50C',
    'elephant': u'\U0001F418',
    'eleven-thirty': u'\U0001F566',
    'eleven_o’clock': u'\U0001F55A',
    'elf': u'\U0001F9DD',
    'elf_dark_skin_tone': u'\U0001F9DD\U0001F3FF',
    'elf_light_skin_tone': u'\U0001F9DD\U0001F3FB',
    'elf_medium-dark_skin_tone': u'\U0001F9DD\U0001F3FE',
    'elf_medium-light_skin_tone': u'\U0001F9DD\U0001F3FC',
    'elf_medium_skin_tone': u'\U0001F9DD\U0001F3FD',
    'envelope': u'\U00002709',
    'envelope_with_arrow': u'\U0001F4E9',
    'euro_banknote': u'\U0001F4B6',
    'evergreen_tree': u'\U0001F332',
    'ewe': u'\U0001F411',
    'exclamation_mark': u'\U00002757',
    'exclamation_question_mark': u'\U00002049',
    'exploding_head': u'\U0001F92F',
    'expressionless_face': u'\U0001F611',
    'eye': u'\U0001F441',
    'eye_in_speech_bubble': u'\U0001F441\U0000FE0F\U0000200D\U0001F5E8\U0000FE0F',
    'eyes': u'\U0001F440',
    'face_blowing_a_kiss': u'\U0001F618',
    'face_savoring_food': u'\U0001F60B',
    'face_screaming_in_fear': u'\U0001F631',
    'face_vomiting': u'\U0001F92E',
    'face_with_hand_over_mouth': u'\U0001F92D',
    'face_with_head-bandage': u'\U0001F915',
    'face_with_medical_mask': u'\U0001F637',
    'face_with_monocle': u'\U0001F9D0',
    'face_with_open_mouth': u'\U0001F62E',
    'face_with_raised_eyebrow': u'\U0001F928',
    'face_with_rolling_eyes': u'\U0001F644',
    'face_with_steam_from_nose': u'\U0001F624',
    'face_with_symbols_on_mouth': u'\U0001F92C',
    'face_with_tears_of_joy': u'\U0001F602',
    'face_with_thermometer': u'\U0001F912',
    'face_with_tongue': u'\U0001F61B',
    'face_without_mouth': u'\U0001F636',
    'factory': u'\U0001F3ED',
    'fairy': u'\U0001F9DA',
    'fairy_dark_skin_tone': u'\U0001F9DA\U0001F3FF',
    'fairy_light_skin_tone': u'\U0001F9DA\U0001F3FB',
    'fairy_medium-dark_skin_tone': u'\U0001F9DA\U0001F3FE',
    'fairy_medium-light_skin_tone': u'\U0001F9DA\U0001F3FC',
    'fairy_medium_skin_tone': u'\U0001F9DA\U0001F3FD',
    'fallen_leaf': u'\U0001F342',
    'family': u'\U0001F46A',
    'family_man_boy': u'\U0001F468\U0000200D\U0001F466',
    'family_man_boy_boy': u'\U0001F468\U0000200D\U0001F466\U0000200D\U0001F466',
    'family_man_girl': u'\U0001F468\U0000200D\U0001F467',
    'family_man_girl_boy': u'\U0001F468\U0000200D\U0001F467\U0000200D\U0001F466',
    'family_man_girl_girl': u'\U0001F468\U0000200D\U0001F467\U0000200D\U0001F467',
    'family_man_man_boy': u'\U0001F468\U0000200D\U0001F468\U0000200D\U0001F466',
    'family_man_man_boy_boy': u'\U0001F468\U0000200D\U0001F468\U0000200D\U0001F466\U0000200D\U0001F466',
    'family_man_man_girl': u'\U0001F468\U0000200D\U0001F468\U0000200D\U0001F467',
    'family_man_man_girl_boy': u'\U0001F468\U0000200D\U0001F468\U0000200D\U0001F467\U0000200D\U0001F466',
    'family_man_man_girl_girl': u'\U0001F468\U0000200D\U0001F468\U0000200D\U0001F467\U0000200D\U0001F467',
    'family_man_woman_boy': u'\U0001F468\U0000200D\U0001F469\U0000200D\U0001F466',
    'family_man_woman_boy_boy': u'\U0001F468\U0000200D\U0001F469\U0000200D\U0001F466\U0000200D\U0001F466',
    'family_man_woman_girl': u'\U0001F468\U0000200D\U0001F469\U0000200D\U0001F467',
    'family_man_woman_girl_boy': u'\U0001F468\U0000200D\U0001F469\U0000200D\U0001F467\U0000200D\U0001F466',
    'family_man_woman_girl_girl': u'\U0001F468\U0000200D\U0001F469\U0000200D\U0001F467\U0000200D\U0001F467',
    'family_woman_boy': u'\U0001F469\U0000200D\U0001F466',
    'family_woman_boy_boy': u'\U0001F469\U0000200D\U0001F466\U0000200D\U0001F466',
    'family_woman_girl': u'\U0001F469\U0000200D\U0001F467',
    'family_woman_girl_boy': u'\U0001F469\U0000200D\U0001F467\U0000200D\U0001F466',
    'family_woman_girl_girl': u'\U0001F469\U0000200D\U0001F467\U0000200D\U0001F467',
    'family_woman_woman_boy': u'\U0001F469\U0000200D\U0001F469\U0000200D\U0001F466',
    'family_woman_woman_boy_boy': u'\U0001F469\U0000200D\U0001F469\U0000200D\U0001F466\U0000200D\U0001F466',
    'family_woman_woman_girl': u'\U0001F469\U0000200D\U0001F469\U0000200D\U0001F467',
    'family_woman_woman_girl_boy': u'\U0001F469\U0000200D\U0001F469\U0000200D\U0001F467\U0000200D\U0001F466',
    'family_woman_woman_girl_girl': u'\U0001F469\U0000200D\U0001F469\U0000200D\U0001F467\U0000200D\U0001F467',
    'fast-forward_button': u'\U000023E9',
    'fast_down_button': u'\U000023EC',
    'fast_reverse_button': u'\U000023EA',
    'fast_up_button': u'\U000023EB',
    'fax_machine': u'\U0001F4E0',
    'fearful_face': u'\U0001F628',
    'female_sign': u'\U00002640',
    'ferris_wheel': u'\U0001F3A1',
    'ferry': u'\U000026F4',
    'field_hockey': u'\U0001F3D1',
    'file_cabinet': u'\U0001F5C4',
    'file_folder': u'\U0001F4C1',
    'film_frames': u'\U0001F39E',
    'film_projector': u'\U0001F4FD',
    'fire': u'\U0001F525',
    'fire_extinguisher': u'\U0001F9EF',
    'firecracker': u'\U0001F9E8',
    'fire_engine': u'\U0001F692',
    'fireworks': u'\U0001F386',
    'first_quarter_moon': u'\U0001F313',
    'first_quarter_moon_face': u'\U0001F31B',
    'fish': u'\U0001F41F',
    'fish_cake_with_swirl': u'\U0001F365',
    'fishing_pole': u'\U0001F3A3',
    'five-thirty': u'\U0001F560',
    'five_o’clock': u'\U0001F554',
    'flag_in_hole': u'\U000026F3',
    'flashlight': u'\U0001F526',
    'flat_shoe': u'\U0001F97F',
    'fleur-de-lis': u'\U0000269C',
    'flexed_biceps': u'\U0001F4AA',
    'flexed_biceps_dark_skin_tone': u'\U0001F4AA\U0001F3FF',
    'flexed_biceps_light_skin_tone': u'\U0001F4AA\U0001F3FB',
    'flexed_biceps_medium-dark_skin_tone': u'\U0001F4AA\U0001F3FE',
    'flexed_biceps_medium-light_skin_tone': u'\U0001F4AA\U0001F3FC',
    'flexed_biceps_medium_skin_tone': u'\U0001F4AA\U0001F3FD',
    'floppy_disk': u'\U0001F4BE',
    'flower_playing_cards': u'\U0001F3B4',
    'flushed_face': u'\U0001F633',
    'flying_disc': u'\U0001F94F',
    'flying_saucer': u'\U0001F6F8',
    'fog': u'\U0001F32B',
    'foggy': u'\U0001F301',
    'folded_hands': u'\U0001F64F',
    'folded_hands_dark_skin_tone': u'\U0001F64F\U0001F3FF',
    'folded_hands_light_skin_tone': u'\U0001F64F\U0001F3FB',
    'folded_hands_medium-dark_skin_tone': u'\U0001F64F\U0001F3FE',
    'folded_hands_medium-light_skin_tone': u'\U0001F64F\U0001F3FC',
    'folded_hands_medium_skin_tone': u'\U0001F64F\U0001F3FD',
    'foot': u'\U0001F9B6',
    'footprints': u'\U0001F463',
    'fork_and_knife': u'\U0001F374',
    'fork_and_knife_with_plate': u'\U0001F37D',
    'fortune_cookie': u'\U0001F960',
    'fountain': u'\U000026F2',
    'fountain_pen': u'\U0001F58B',
    'four-thirty': u'\U0001F55F',
    'four_leaf_clover': u'\U0001F340',
    'four_o’clock': u'\U0001F553',
    'fox_face': u'\U0001F98A',
    'framed_picture': u'\U0001F5BC',
    'french_fries': u'\U0001F35F',
    'fried_shrimp': u'\U0001F364',
    'frog_face': u'\U0001F438',
    'front-facing_baby_chick': u'\U0001F425',
    'frowning_face': u'\U00002639',
    'frowning_face_with_open_mouth': u'\U0001F626',
    'fuel_pump': u'\U000026FD',
    'full_moon': u'\U0001F315',
    'full_moon_face': u'\U0001F31D',
    'funeral_urn': u'\U000026B1',
    'game_die': u'\U0001F3B2',
    'gear': u'\U00002699',
    'gem_stone': u'\U0001F48E',
    'genie': u'\U0001F9DE',
    'ghost': u'\U0001F47B',
    'giraffe': u'\U0001F992',
    'girl': u'\U0001F467',
    'girl_dark_skin_tone': u'\U0001F467\U0001F3FF',
    'girl_light_skin_tone': u'\U0001F467\U0001F3FB',
    'girl_medium-dark_skin_tone': u'\U0001F467\U0001F3FE',
    'girl_medium-light_skin_tone': u'\U0001F467\U0001F3FC',
    'girl_medium_skin_tone': u'\U0001F467\U0001F3FD',
    'glass_of_milk': u'\U0001F95B',
    'glasses': u'\U0001F453',
    'globe_showing_Americas': u'\U0001F30E',
    'globe_showing_Asia-Australia': u'\U0001F30F',
    'globe_showing_Europe-Africa': u'\U0001F30D',
    'globe_with_meridians': u'\U0001F310',
    'gloves': u'\U0001F9E4',
    'glowing_star': u'\U0001F31F',
    'goal_net': u'\U0001F945',
    'goat': u'\U0001F410',
    'goblin': u'\U0001F47A',
    'goggles': u'\U0001F97D',
    'gorilla': u'\U0001F98D',
    'graduation_cap': u'\U0001F393',
    'grapes': u'\U0001F347',
    'green_apple': u'\U0001F34F',
    'green_book': u'\U0001F4D7',
    'green_heart': u'\U0001F49A',
    'green_salad': u'\U0001F957',
    'grimacing_face': u'\U0001F62C',
    'grinning_cat_face': u'\U0001F63A',
    'grinning_cat_face_with_smiling_eyes': u'\U0001F638',
    'grinning_face': u'\U0001F600',
    'grinning_face_with_big_eyes': u'\U0001F603',
    'grinning_face_with_smiling_eyes': u'\U0001F604',
    'grinning_face_with_sweat': u'\U0001F605',
    'grinning_squinting_face': u'\U0001F606',
    'growing_heart': u'\U0001F497',
    'guard': u'\U0001F482',
    'guard_dark_skin_tone': u'\U0001F482\U0001F3FF',
    'guard_light_skin_tone': u'\U0001F482\U0001F3FB',
    'guard_medium-dark_skin_tone': u'\U0001F482\U0001F3FE',
    'guard_medium-light_skin_tone': u'\U0001F482\U0001F3FC',
    'guard_medium_skin_tone': u'\U0001F482\U0001F3FD',
    'guitar': u'\U0001F3B8',
    'hamburger': u'\U0001F354',
    'hammer': u'\U0001F528',
    'hammer_and_pick': u'\U00002692',
    'hammer_and_wrench': u'\U0001F6E0',
    'hamster_face': u'\U0001F439',
    'hand_with_fingers_splayed': u'\U0001F590',
    'hand_with_fingers_splayed_dark_skin_tone': u'\U0001F590\U0001F3FF',
    'hand_with_fingers_splayed_light_skin_tone': u'\U0001F590\U0001F3FB',
    'hand_with_fingers_splayed_medium-dark_skin_tone': u'\U0001F590\U0001F3FE',
    'hand_with_fingers_splayed_medium-light_skin_tone': u'\U0001F590\U0001F3FC',
    'hand_with_fingers_splayed_medium_skin_tone': u'\U0001F590\U0001F3FD',
    'handbag': u'\U0001F45C',
    'handshake': u'\U0001F91D',
    'hatching_chick': u'\U0001F423',
    'headphone': u'\U0001F3A7',
    'hear-no-evil_monkey': u'\U0001F649',
    'heart_decoration': u'\U0001F49F',
    'heart_suit': u'\U00002665',
    'heart_with_arrow': u'\U0001F498',
    'heart_with_ribbon': u'\U0001F49D',
    'heavy_check_mark': u'\U00002714',
    'heavy_division_sign': u'\U00002797',
    'heavy_dollar_sign': u'\U0001F4B2',
    'heavy_heart_exclamation': u'\U00002763',
    'heavy_large_circle': u'\U00002B55',
    'heavy_minus_sign': u'\U00002796',
    'heavy_multiplication_x': u'\U00002716',
    'heavy_plus_sign': u'\U00002795',
    'hedgehog': u'\U0001F994',
    'helicopter': u'\U0001F681',
    'herb': u'\U0001F33F',
    'hibiscus': u'\U0001F33A',
    'high-heeled_shoe': u'\U0001F460',
    'high-speed_train': u'\U0001F684',
    'high_voltage': u'\U000026A1',
    'hiking_boot': u'\U0001F97E',
    'hippopotamus': u'\U0001F99B',
    'hole': u'\U0001F573',
    'honey_pot': u'\U0001F36F',
    'honeybee': u'\U0001F41D',
    'horizontal_traffic_light': u'\U0001F6A5',
    'horse': u'\U0001F40E',
    'horse_face': u'\U0001F434',
    'horse_racing': u'\U0001F3C7',
    'horse_racing_dark_skin_tone': u'\U0001F3C7\U0001F3FF',
    'horse_racing_light_skin_tone': u'\U0001F3C7\U0001F3FB',
    'horse_racing_medium-dark_skin_tone': u'\U0001F3C7\U0001F3FE',
    'horse_racing_medium-light_skin_tone': u'\U0001F3C7\U0001F3FC',
    'horse_racing_medium_skin_tone': u'\U0001F3C7\U0001F3FD',
    'hospital': u'\U0001F3E5',
    'hot_beverage': u'\U00002615',
    'hot_dog': u'\U0001F32D',
    'hot_face': u'\U0001F975',
    'hot_pepper': u'\U0001F336',
    'hot_springs': u'\U00002668',
    'hotel': u'\U0001F3E8',
    'hourglass_done': u'\U0000231B',
    'hourglass_not_done': u'\U000023F3',
    'house': u'\U0001F3E0',
    'house_with_garden': u'\U0001F3E1',
    'houses': u'\U0001F3D8',
    'hugging_face': u'\U0001F917',
    'hundred_points': u'\U0001F4AF',
    'hushed_face': u'\U0001F62F',
    'ice_cream': u'\U0001F368',
    'ice_hockey': u'\U0001F3D2',
    'ice_skate': u'\U000026F8',
    'inbox_tray': u'\U0001F4E5',
    'incoming_envelope': u'\U0001F4E8',
    'index_pointing_up': u'\U0000261D',
    'index_pointing_up_dark_skin_tone': u'\U0000261D\U0001F3FF',
    'index_pointing_up_light_skin_tone': u'\U0000261D\U0001F3FB',
    'index_pointing_up_medium-dark_skin_tone': u'\U0000261D\U0001F3FE',
    'index_pointing_up_medium-light_skin_tone': u'\U0000261D\U0001F3FC',
    'index_pointing_up_medium_skin_tone': u'\U0000261D\U0001F3FD',
    'infinity': u'\U0000267E',
    'information': u'\U00002139',
    'input_latin_letters': u'\U0001F524',
    'input_latin_lowercase': u'\U0001F521',
    'input_latin_uppercase': u'\U0001F520',
    'input_numbers': u'\U0001F522',
    'input_symbols': u'\U0001F523',
    'jack-o-lantern': u'\U0001F383',
    'jeans': u'\U0001F456',
    'jigsaw': u'\U0001F9E9',
    'joker': u'\U0001F0CF',
    'joystick': u'\U0001F579',
    'kaaba': u'\U0001F54B',
    'kangaroo': u'\U0001F998',
    'key': u'\U0001F511',
    'keyboard': u'\U00002328',
    'keycap_#': u'\U00000023\U0000FE0F\U000020E3',
    'keycap_*': u'\U0000002A\U0000FE0F\U000020E3',
    'keycap_0': u'\U00000030\U0000FE0F\U000020E3',
    'keycap_1': u'\U00000031\U0000FE0F\U000020E3',
    'keycap_10': u'\U0001F51F',
    'keycap_2': u'\U00000032\U0000FE0F\U000020E3',
    'keycap_3': u'\U00000033\U0000FE0F\U000020E3',
    'keycap_4': u'\U00000034\U0000FE0F\U000020E3',
    'keycap_5': u'\U00000035\U0000FE0F\U000020E3',
    'keycap_6': u'\U00000036\U0000FE0F\U000020E3',
    'keycap_7': u'\U00000037\U0000FE0F\U000020E3',
    'keycap_8': u'\U00000038\U0000FE0F\U000020E3',
    'keycap_9': u'\U00000039\U0000FE0F\U000020E3',
    'kick_scooter': u'\U0001F6F4',
    'kimono': u'\U0001F458',
    'kiss': u'\U0001F48F',
    'kiss_man_man': u'\U0001F468\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B\U0000200D\U0001F468',
    'kiss_mark': u'\U0001F48B',
    'kiss_woman_man': u'\U0001F469\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B\U0000200D\U0001F468',
    'kiss_woman_woman': u'\U0001F469\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B\U0000200D\U0001F469',
    'kissing_cat_face': u'\U0001F63D',
    'kissing_face': u'\U0001F617',
    'kissing_face_with_closed_eyes': u'\U0001F61A',
    'kissing_face_with_smiling_eyes': u'\U0001F619',
    'kitchen_knife': u'\U0001F52A',
    'kiwi_fruit': u'\U0001F95D',
    'koala': u'\U0001F428',
    'lab_coat': u'\U0001F97C',
    'label': u'\U0001F3F7',
    'lacrosse': u'\U0001F94D',
    'lady_beetle': u'\U0001F41E',
    'laptop_computer': u'\U0001F4BB',
    'large_blue_diamond': u'\U0001F537',
    'large_orange_diamond': u'\U0001F536',
    'last_quarter_moon': u'\U0001F317',
    'last_quarter_moon_face': u'\U0001F31C',
    'last_track_button': u'\U000023EE',
    'latin_cross': u'\U0000271D',
    'leaf_fluttering_in_wind': u'\U0001F343',
    'leafy_green': u'\U0001F96C',
    'ledger': u'\U0001F4D2',
    'left-facing_fist': u'\U0001F91B',
    'left-facing_fist_dark_skin_tone': u'\U0001F91B\U0001F3FF',
    'left-facing_fist_light_skin_tone': u'\U0001F91B\U0001F3FB',
    'left-facing_fist_medium-dark_skin_tone': u'\U0001F91B\U0001F3FE',
    'left-facing_fist_medium-light_skin_tone': u'\U0001F91B\U0001F3FC',
    'left-facing_fist_medium_skin_tone': u'\U0001F91B\U0001F3FD',
    'left-right_arrow': u'\U00002194',
    'left_arrow': u'\U00002B05',
    'left_arrow_curving_right': u'\U000021AA',
    'left_luggage': u'\U0001F6C5',
    'left_speech_bubble': u'\U0001F5E8',
    'leg': u'\U0001F9B5',
    'lemon': u'\U0001F34B',
    'leopard': u'\U0001F406',
    'level_slider': u'\U0001F39A',
    'light_bulb': u'\U0001F4A1',
    'light_rail': u'\U0001F688',
    'link': u'\U0001F517',
    'linked_paperclips': u'\U0001F587',
    'lion_face': u'\U0001F981',
    'lipstick': u'\U0001F484',
    'litter_in_bin_sign': u'\U0001F6AE',
    'lizard': u'\U0001F98E',
    'llama': u'\U0001F999',
    'lobster': u'\U0001F99E',
    'locked': u'\U0001F512',
    'locked_with_key': u'\U0001F510',
    'locked_with_pen': u'\U0001F50F',
    'locomotive': u'\U0001F682',
    'lollipop': u'\U0001F36D',
    'lotion_bottle': u'\U0001F9F4',
    'loudly_crying_face': u'\U0001F62D',
    'loudspeaker': u'\U0001F4E2',
    'love-you_gesture': u'\U0001F91F',
    'love-you_gesture_dark_skin_tone': u'\U0001F91F\U0001F3FF',
    'love-you_gesture_light_skin_tone': u'\U0001F91F\U0001F3FB',
    'love-you_gesture_medium-dark_skin_tone': u'\U0001F91F\U0001F3FE',
    'love-you_gesture_medium-light_skin_tone': u'\U0001F91F\U0001F3FC',
    'love-you_gesture_medium_skin_tone': u'\U0001F91F\U0001F3FD',
    'love_hotel': u'\U0001F3E9',
    'love_letter': u'\U0001F48C',
    'luggage': u'\U0001F9F3',
    'lying_face': u'\U0001F925',
    'mage': u'\U0001F9D9',
    'mage_dark_skin_tone': u'\U0001F9D9\U0001F3FF',
    'mage_light_skin_tone': u'\U0001F9D9\U0001F3FB',
    'mage_medium-dark_skin_tone': u'\U0001F9D9\U0001F3FE',
    'mage_medium-light_skin_tone': u'\U0001F9D9\U0001F3FC',
    'mage_medium_skin_tone': u'\U0001F9D9\U0001F3FD',
    'magnet': u'\U0001F9F2',
    'magnifying_glass_tilted_left': u'\U0001F50D',
    'magnifying_glass_tilted_right': u'\U0001F50E',
    'mahjong_red_dragon': u'\U0001F004',
    'male_sign': u'\U00002642',
    'man': u'\U0001F468',
    'man_and_woman_holding_hands': u'\U0001F46B',
    'man_artist': u'\U0001F468\U0000200D\U0001F3A8',
    'man_artist_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F3A8',
    'man_artist_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F3A8',
    'man_artist_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F3A8',
    'man_artist_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F3A8',
    'man_artist_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F3A8',
    'man_astronaut': u'\U0001F468\U0000200D\U0001F680',
    'man_astronaut_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F680',
    'man_astronaut_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F680',
    'man_astronaut_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F680',
    'man_astronaut_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F680',
    'man_astronaut_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F680',
    'man_biking': u'\U0001F6B4\U0000200D\U00002642\U0000FE0F',
    'man_biking_dark_skin_tone': u'\U0001F6B4\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_biking_light_skin_tone': u'\U0001F6B4\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_biking_medium-dark_skin_tone': u'\U0001F6B4\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_biking_medium-light_skin_tone': u'\U0001F6B4\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_biking_medium_skin_tone': u'\U0001F6B4\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_bouncing_ball': u'\U000026F9\U0000FE0F\U0000200D\U00002642\U0000FE0F',
    'man_bouncing_ball_dark_skin_tone': u'\U000026F9\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_bouncing_ball_light_skin_tone': u'\U000026F9\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_bouncing_ball_medium-dark_skin_tone': u'\U000026F9\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_bouncing_ball_medium-light_skin_tone': u'\U000026F9\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_bouncing_ball_medium_skin_tone': u'\U000026F9\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_bowing': u'\U0001F647\U0000200D\U00002642\U0000FE0F',
    'man_bowing_dark_skin_tone': u'\U0001F647\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_bowing_light_skin_tone': u'\U0001F647\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_bowing_medium-dark_skin_tone': u'\U0001F647\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_bowing_medium-light_skin_tone': u'\U0001F647\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_bowing_medium_skin_tone': u'\U0001F647\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_cartwheeling': u'\U0001F938\U0000200D\U00002642\U0000FE0F',
    'man_cartwheeling_dark_skin_tone': u'\U0001F938\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_cartwheeling_light_skin_tone': u'\U0001F938\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_cartwheeling_medium-dark_skin_tone': u'\U0001F938\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_cartwheeling_medium-light_skin_tone': u'\U0001F938\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_cartwheeling_medium_skin_tone': u'\U0001F938\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_climbing': u'\U0001F9D7\U0000200D\U00002642\U0000FE0F',
    'man_climbing_dark_skin_tone': u'\U0001F9D7\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_climbing_light_skin_tone': u'\U0001F9D7\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_climbing_medium-dark_skin_tone': u'\U0001F9D7\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_climbing_medium-light_skin_tone': u'\U0001F9D7\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_climbing_medium_skin_tone': u'\U0001F9D7\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_construction_worker': u'\U0001F477\U0000200D\U00002642\U0000FE0F',
    'man_construction_worker_dark_skin_tone': u'\U0001F477\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_construction_worker_light_skin_tone': u'\U0001F477\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_construction_worker_medium-dark_skin_tone': u'\U0001F477\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_construction_worker_medium-light_skin_tone': u'\U0001F477\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_construction_worker_medium_skin_tone': u'\U0001F477\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_cook': u'\U0001F468\U0000200D\U0001F373',
    'man_cook_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F373',
    'man_cook_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F373',
    'man_cook_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F373',
    'man_cook_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F373',
    'man_cook_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F373',
    'man_dancing': u'\U0001F57A',
    'man_dancing_dark_skin_tone': u'\U0001F57A\U0001F3FF',
    'man_dancing_light_skin_tone': u'\U0001F57A\U0001F3FB',
    'man_dancing_medium-dark_skin_tone': u'\U0001F57A\U0001F3FE',
    'man_dancing_medium-light_skin_tone': u'\U0001F57A\U0001F3FC',
    'man_dancing_medium_skin_tone': u'\U0001F57A\U0001F3FD',
    'man_dark_skin_tone': u'\U0001F468\U0001F3FF',
    'man_detective': u'\U0001F575\U0000FE0F\U0000200D\U00002642\U0000FE0F',
    'man_detective_dark_skin_tone': u'\U0001F575\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_detective_light_skin_tone': u'\U0001F575\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_detective_medium-dark_skin_tone': u'\U0001F575\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_detective_medium-light_skin_tone': u'\U0001F575\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_detective_medium_skin_tone': u'\U0001F575\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_elf': u'\U0001F9DD\U0000200D\U00002642\U0000FE0F',
    'man_elf_dark_skin_tone': u'\U0001F9DD\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_elf_light_skin_tone': u'\U0001F9DD\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_elf_medium-dark_skin_tone': u'\U0001F9DD\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_elf_medium-light_skin_tone': u'\U0001F9DD\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_elf_medium_skin_tone': u'\U0001F9DD\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_facepalming': u'\U0001F926\U0000200D\U00002642\U0000FE0F',
    'man_facepalming_dark_skin_tone': u'\U0001F926\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_facepalming_light_skin_tone': u'\U0001F926\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_facepalming_medium-dark_skin_tone': u'\U0001F926\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_facepalming_medium-light_skin_tone': u'\U0001F926\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_facepalming_medium_skin_tone': u'\U0001F926\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_factory_worker': u'\U0001F468\U0000200D\U0001F3ED',
    'man_factory_worker_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F3ED',
    'man_factory_worker_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F3ED',
    'man_factory_worker_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F3ED',
    'man_factory_worker_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F3ED',
    'man_factory_worker_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F3ED',
    'man_fairy': u'\U0001F9DA\U0000200D\U00002642\U0000FE0F',
    'man_fairy_dark_skin_tone': u'\U0001F9DA\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_fairy_light_skin_tone': u'\U0001F9DA\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_fairy_medium-dark_skin_tone': u'\U0001F9DA\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_fairy_medium-light_skin_tone': u'\U0001F9DA\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_fairy_medium_skin_tone': u'\U0001F9DA\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_farmer': u'\U0001F468\U0000200D\U0001F33E',
    'man_farmer_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F33E',
    'man_farmer_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F33E',
    'man_farmer_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F33E',
    'man_farmer_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F33E',
    'man_farmer_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F33E',
    'man_firefighter': u'\U0001F468\U0000200D\U0001F692',
    'man_firefighter_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F692',
    'man_firefighter_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F692',
    'man_firefighter_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F692',
    'man_firefighter_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F692',
    'man_firefighter_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F692',
    'man_frowning': u'\U0001F64D\U0000200D\U00002642\U0000FE0F',
    'man_frowning_dark_skin_tone': u'\U0001F64D\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_frowning_light_skin_tone': u'\U0001F64D\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_frowning_medium-dark_skin_tone': u'\U0001F64D\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_frowning_medium-light_skin_tone': u'\U0001F64D\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_frowning_medium_skin_tone': u'\U0001F64D\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_genie': u'\U0001F9DE\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_NO': u'\U0001F645\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_NO_dark_skin_tone': u'\U0001F645\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_NO_light_skin_tone': u'\U0001F645\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_NO_medium-dark_skin_tone': u'\U0001F645\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_NO_medium-light_skin_tone': u'\U0001F645\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_NO_medium_skin_tone': u'\U0001F645\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_OK': u'\U0001F646\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_OK_dark_skin_tone': u'\U0001F646\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_OK_light_skin_tone': u'\U0001F646\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_OK_medium-dark_skin_tone': u'\U0001F646\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_OK_medium-light_skin_tone': u'\U0001F646\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_gesturing_OK_medium_skin_tone': u'\U0001F646\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_getting_haircut': u'\U0001F487\U0000200D\U00002642\U0000FE0F',
    'man_getting_haircut_dark_skin_tone': u'\U0001F487\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_getting_haircut_light_skin_tone': u'\U0001F487\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_getting_haircut_medium-dark_skin_tone': u'\U0001F487\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_getting_haircut_medium-light_skin_tone': u'\U0001F487\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_getting_haircut_medium_skin_tone': u'\U0001F487\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_getting_massage': u'\U0001F486\U0000200D\U00002642\U0000FE0F',
    'man_getting_massage_dark_skin_tone': u'\U0001F486\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_getting_massage_light_skin_tone': u'\U0001F486\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_getting_massage_medium-dark_skin_tone': u'\U0001F486\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_getting_massage_medium-light_skin_tone': u'\U0001F486\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_getting_massage_medium_skin_tone': u'\U0001F486\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_golfing': u'\U0001F3CC\U0000FE0F\U0000200D\U00002642\U0000FE0F',
    'man_golfing_dark_skin_tone': u'\U0001F3CC\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_golfing_light_skin_tone': u'\U0001F3CC\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_golfing_medium-dark_skin_tone': u'\U0001F3CC\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_golfing_medium-light_skin_tone': u'\U0001F3CC\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_golfing_medium_skin_tone': u'\U0001F3CC\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_guard': u'\U0001F482\U0000200D\U00002642\U0000FE0F',
    'man_guard_dark_skin_tone': u'\U0001F482\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_guard_light_skin_tone': u'\U0001F482\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_guard_medium-dark_skin_tone': u'\U0001F482\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_guard_medium-light_skin_tone': u'\U0001F482\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_guard_medium_skin_tone': u'\U0001F482\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_health_worker': u'\U0001F468\U0000200D\U00002695\U0000FE0F',
    'man_health_worker_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U00002695\U0000FE0F',
    'man_health_worker_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U00002695\U0000FE0F',
    'man_health_worker_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U00002695\U0000FE0F',
    'man_health_worker_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U00002695\U0000FE0F',
    'man_health_worker_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U00002695\U0000FE0F',
    'man_in_lotus_position': u'\U0001F9D8\U0000200D\U00002642\U0000FE0F',
    'man_in_lotus_position_dark_skin_tone': u'\U0001F9D8\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_in_lotus_position_light_skin_tone': u'\U0001F9D8\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_in_lotus_position_medium-dark_skin_tone': u'\U0001F9D8\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_in_lotus_position_medium-light_skin_tone': u'\U0001F9D8\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_in_lotus_position_medium_skin_tone': u'\U0001F9D8\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_in_steamy_room': u'\U0001F9D6\U0000200D\U00002642\U0000FE0F',
    'man_in_steamy_room_dark_skin_tone': u'\U0001F9D6\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_in_steamy_room_light_skin_tone': u'\U0001F9D6\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_in_steamy_room_medium-dark_skin_tone': u'\U0001F9D6\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_in_steamy_room_medium-light_skin_tone': u'\U0001F9D6\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_in_steamy_room_medium_skin_tone': u'\U0001F9D6\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_in_suit_levitating': u'\U0001F574',
    'man_in_suit_levitating_dark_skin_tone': u'\U0001F574\U0001F3FF',
    'man_in_suit_levitating_light_skin_tone': u'\U0001F574\U0001F3FB',
    'man_in_suit_levitating_medium-dark_skin_tone': u'\U0001F574\U0001F3FE',
    'man_in_suit_levitating_medium-light_skin_tone': u'\U0001F574\U0001F3FC',
    'man_in_suit_levitating_medium_skin_tone': u'\U0001F574\U0001F3FD',
    'man_in_tuxedo': u'\U0001F935',
    'man_in_tuxedo_dark_skin_tone': u'\U0001F935\U0001F3FF',
    'man_in_tuxedo_light_skin_tone': u'\U0001F935\U0001F3FB',
    'man_in_tuxedo_medium-dark_skin_tone': u'\U0001F935\U0001F3FE',
    'man_in_tuxedo_medium-light_skin_tone': u'\U0001F935\U0001F3FC',
    'man_in_tuxedo_medium_skin_tone': u'\U0001F935\U0001F3FD',
    'man_judge': u'\U0001F468\U0000200D\U00002696\U0000FE0F',
    'man_judge_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U00002696\U0000FE0F',
    'man_judge_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U00002696\U0000FE0F',
    'man_judge_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U00002696\U0000FE0F',
    'man_judge_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U00002696\U0000FE0F',
    'man_judge_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U00002696\U0000FE0F',
    'man_juggling': u'\U0001F939\U0000200D\U00002642\U0000FE0F',
    'man_juggling_dark_skin_tone': u'\U0001F939\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_juggling_light_skin_tone': u'\U0001F939\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_juggling_medium-dark_skin_tone': u'\U0001F939\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_juggling_medium-light_skin_tone': u'\U0001F939\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_juggling_medium_skin_tone': u'\U0001F939\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_lifting_weights': u'\U0001F3CB\U0000FE0F\U0000200D\U00002642\U0000FE0F',
    'man_lifting_weights_dark_skin_tone': u'\U0001F3CB\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_lifting_weights_light_skin_tone': u'\U0001F3CB\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_lifting_weights_medium-dark_skin_tone': u'\U0001F3CB\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_lifting_weights_medium-light_skin_tone': u'\U0001F3CB\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_lifting_weights_medium_skin_tone': u'\U0001F3CB\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_light_skin_tone': u'\U0001F468\U0001F3FB',
    'man_mage': u'\U0001F9D9\U0000200D\U00002642\U0000FE0F',
    'man_mage_dark_skin_tone': u'\U0001F9D9\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_mage_light_skin_tone': u'\U0001F9D9\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_mage_medium-dark_skin_tone': u'\U0001F9D9\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_mage_medium-light_skin_tone': u'\U0001F9D9\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_mage_medium_skin_tone': u'\U0001F9D9\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_mechanic': u'\U0001F468\U0000200D\U0001F527',
    'man_mechanic_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F527',
    'man_mechanic_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F527',
    'man_mechanic_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F527',
    'man_mechanic_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F527',
    'man_mechanic_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F527',
    'man_medium-dark_skin_tone': u'\U0001F468\U0001F3FE',
    'man_medium-light_skin_tone': u'\U0001F468\U0001F3FC',
    'man_medium_skin_tone': u'\U0001F468\U0001F3FD',
    'man_mountain_biking': u'\U0001F6B5\U0000200D\U00002642\U0000FE0F',
    'man_mountain_biking_dark_skin_tone': u'\U0001F6B5\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_mountain_biking_light_skin_tone': u'\U0001F6B5\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_mountain_biking_medium-dark_skin_tone': u'\U0001F6B5\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_mountain_biking_medium-light_skin_tone': u'\U0001F6B5\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_mountain_biking_medium_skin_tone': u'\U0001F6B5\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_office_worker': u'\U0001F468\U0000200D\U0001F4BC',
    'man_office_worker_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F4BC',
    'man_office_worker_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F4BC',
    'man_office_worker_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F4BC',
    'man_office_worker_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F4BC',
    'man_office_worker_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F4BC',
    'man_pilot': u'\U0001F468\U0000200D\U00002708\U0000FE0F',
    'man_pilot_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U00002708\U0000FE0F',
    'man_pilot_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U00002708\U0000FE0F',
    'man_pilot_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U00002708\U0000FE0F',
    'man_pilot_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U00002708\U0000FE0F',
    'man_pilot_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U00002708\U0000FE0F',
    'man_playing_handball': u'\U0001F93E\U0000200D\U00002642\U0000FE0F',
    'man_playing_handball_dark_skin_tone': u'\U0001F93E\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_playing_handball_light_skin_tone': u'\U0001F93E\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_playing_handball_medium-dark_skin_tone': u'\U0001F93E\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_playing_handball_medium-light_skin_tone': u'\U0001F93E\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_playing_handball_medium_skin_tone': u'\U0001F93E\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_playing_water_polo': u'\U0001F93D\U0000200D\U00002642\U0000FE0F',
    'man_playing_water_polo_dark_skin_tone': u'\U0001F93D\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_playing_water_polo_light_skin_tone': u'\U0001F93D\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_playing_water_polo_medium-dark_skin_tone': u'\U0001F93D\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_playing_water_polo_medium-light_skin_tone': u'\U0001F93D\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_playing_water_polo_medium_skin_tone': u'\U0001F93D\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_police_officer': u'\U0001F46E\U0000200D\U00002642\U0000FE0F',
    'man_police_officer_dark_skin_tone': u'\U0001F46E\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_police_officer_light_skin_tone': u'\U0001F46E\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_police_officer_medium-dark_skin_tone': u'\U0001F46E\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_police_officer_medium-light_skin_tone': u'\U0001F46E\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_police_officer_medium_skin_tone': u'\U0001F46E\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_pouting': u'\U0001F64E\U0000200D\U00002642\U0000FE0F',
    'man_pouting_dark_skin_tone': u'\U0001F64E\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_pouting_light_skin_tone': u'\U0001F64E\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_pouting_medium-dark_skin_tone': u'\U0001F64E\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_pouting_medium-light_skin_tone': u'\U0001F64E\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_pouting_medium_skin_tone': u'\U0001F64E\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_raising_hand': u'\U0001F64B\U0000200D\U00002642\U0000FE0F',
    'man_raising_hand_dark_skin_tone': u'\U0001F64B\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_raising_hand_light_skin_tone': u'\U0001F64B\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_raising_hand_medium-dark_skin_tone': u'\U0001F64B\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_raising_hand_medium-light_skin_tone': u'\U0001F64B\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_raising_hand_medium_skin_tone': u'\U0001F64B\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_rowing_boat': u'\U0001F6A3\U0000200D\U00002642\U0000FE0F',
    'man_rowing_boat_dark_skin_tone': u'\U0001F6A3\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_rowing_boat_light_skin_tone': u'\U0001F6A3\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_rowing_boat_medium-dark_skin_tone': u'\U0001F6A3\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_rowing_boat_medium-light_skin_tone': u'\U0001F6A3\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_rowing_boat_medium_skin_tone': u'\U0001F6A3\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_running': u'\U0001F3C3\U0000200D\U00002642\U0000FE0F',
    'man_running_dark_skin_tone': u'\U0001F3C3\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_running_light_skin_tone': u'\U0001F3C3\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_running_medium-dark_skin_tone': u'\U0001F3C3\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_running_medium-light_skin_tone': u'\U0001F3C3\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_running_medium_skin_tone': u'\U0001F3C3\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_scientist': u'\U0001F468\U0000200D\U0001F52C',
    'man_scientist_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F52C',
    'man_scientist_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F52C',
    'man_scientist_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F52C',
    'man_scientist_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F52C',
    'man_scientist_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F52C',
    'man_shrugging': u'\U0001F937\U0000200D\U00002642\U0000FE0F',
    'man_shrugging_dark_skin_tone': u'\U0001F937\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_shrugging_light_skin_tone': u'\U0001F937\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_shrugging_medium-dark_skin_tone': u'\U0001F937\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_shrugging_medium-light_skin_tone': u'\U0001F937\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_shrugging_medium_skin_tone': u'\U0001F937\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_singer': u'\U0001F468\U0000200D\U0001F3A4',
    'man_singer_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F3A4',
    'man_singer_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F3A4',
    'man_singer_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F3A4',
    'man_singer_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F3A4',
    'man_singer_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F3A4',
    'man_student': u'\U0001F468\U0000200D\U0001F393',
    'man_student_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F393',
    'man_student_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F393',
    'man_student_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F393',
    'man_student_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F393',
    'man_student_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F393',
    'man_surfing': u'\U0001F3C4\U0000200D\U00002642\U0000FE0F',
    'man_surfing_dark_skin_tone': u'\U0001F3C4\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_surfing_light_skin_tone': u'\U0001F3C4\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_surfing_medium-dark_skin_tone': u'\U0001F3C4\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_surfing_medium-light_skin_tone': u'\U0001F3C4\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_surfing_medium_skin_tone': u'\U0001F3C4\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_swimming': u'\U0001F3CA\U0000200D\U00002642\U0000FE0F',
    'man_swimming_dark_skin_tone': u'\U0001F3CA\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_swimming_light_skin_tone': u'\U0001F3CA\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_swimming_medium-dark_skin_tone': u'\U0001F3CA\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_swimming_medium-light_skin_tone': u'\U0001F3CA\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_swimming_medium_skin_tone': u'\U0001F3CA\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_teacher': u'\U0001F468\U0000200D\U0001F3EB',
    'man_teacher_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F3EB',
    'man_teacher_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F3EB',
    'man_teacher_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F3EB',
    'man_teacher_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F3EB',
    'man_teacher_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F3EB',
    'man_technologist': u'\U0001F468\U0000200D\U0001F4BB',
    'man_technologist_dark_skin_tone': u'\U0001F468\U0001F3FF\U0000200D\U0001F4BB',
    'man_technologist_light_skin_tone': u'\U0001F468\U0001F3FB\U0000200D\U0001F4BB',
    'man_technologist_medium-dark_skin_tone': u'\U0001F468\U0001F3FE\U0000200D\U0001F4BB',
    'man_technologist_medium-light_skin_tone': u'\U0001F468\U0001F3FC\U0000200D\U0001F4BB',
    'man_technologist_medium_skin_tone': u'\U0001F468\U0001F3FD\U0000200D\U0001F4BB',
    'man_tipping_hand': u'\U0001F481\U0000200D\U00002642\U0000FE0F',
    'man_tipping_hand_dark_skin_tone': u'\U0001F481\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_tipping_hand_light_skin_tone': u'\U0001F481\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_tipping_hand_medium-dark_skin_tone': u'\U0001F481\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_tipping_hand_medium-light_skin_tone': u'\U0001F481\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_tipping_hand_medium_skin_tone': u'\U0001F481\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_vampire': u'\U0001F9DB\U0000200D\U00002642\U0000FE0F',
    'man_vampire_dark_skin_tone': u'\U0001F9DB\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_vampire_light_skin_tone': u'\U0001F9DB\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_vampire_medium-dark_skin_tone': u'\U0001F9DB\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_vampire_medium-light_skin_tone': u'\U0001F9DB\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_vampire_medium_skin_tone': u'\U0001F9DB\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_walking': u'\U0001F6B6\U0000200D\U00002642\U0000FE0F',
    'man_walking_dark_skin_tone': u'\U0001F6B6\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_walking_light_skin_tone': u'\U0001F6B6\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_walking_medium-dark_skin_tone': u'\U0001F6B6\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_walking_medium-light_skin_tone': u'\U0001F6B6\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_walking_medium_skin_tone': u'\U0001F6B6\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_wearing_turban': u'\U0001F473\U0000200D\U00002642\U0000FE0F',
    'man_wearing_turban_dark_skin_tone': u'\U0001F473\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'man_wearing_turban_light_skin_tone': u'\U0001F473\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'man_wearing_turban_medium-dark_skin_tone': u'\U0001F473\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'man_wearing_turban_medium-light_skin_tone': u'\U0001F473\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'man_wearing_turban_medium_skin_tone': u'\U0001F473\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'man_with_Chinese_cap': u'\U0001F472',
    'man_with_Chinese_cap_dark_skin_tone': u'\U0001F472\U0001F3FF',
    'man_with_Chinese_cap_light_skin_tone': u'\U0001F472\U0001F3FB',
    'man_with_Chinese_cap_medium-dark_skin_tone': u'\U0001F472\U0001F3FE',
    'man_with_Chinese_cap_medium-light_skin_tone': u'\U0001F472\U0001F3FC',
    'man_with_Chinese_cap_medium_skin_tone': u'\U0001F472\U0001F3FD',
    'man_zombie': u'\U0001F9DF\U0000200D\U00002642\U0000FE0F',
    'mango': u'\U0001F96D',
    'mantelpiece_clock': u'\U0001F570',
    'man’s_shoe': u'\U0001F45E',
    'map_of_Japan': u'\U0001F5FE',
    'maple_leaf': u'\U0001F341',
    'martial_arts_uniform': u'\U0001F94B',
    'meat_on_bone': u'\U0001F356',
    'medical_symbol': u'\U00002695',
    'megaphone': u'\U0001F4E3',
    'melon': u'\U0001F348',
    'memo': u'\U0001F4DD',
    'men_with_bunny_ears': u'\U0001F46F\U0000200D\U00002642\U0000FE0F',
    'men_wrestling': u'\U0001F93C\U0000200D\U00002642\U0000FE0F',
    'menorah': u'\U0001F54E',
    'men’s_room': u'\U0001F6B9',
    'mermaid': u'\U0001F9DC\U0000200D\U00002640\U0000FE0F',
    'mermaid_dark_skin_tone': u'\U0001F9DC\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'mermaid_light_skin_tone': u'\U0001F9DC\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'mermaid_medium-dark_skin_tone': u'\U0001F9DC\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'mermaid_medium-light_skin_tone': u'\U0001F9DC\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'mermaid_medium_skin_tone': u'\U0001F9DC\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'merman': u'\U0001F9DC\U0000200D\U00002642\U0000FE0F',
    'merman_dark_skin_tone': u'\U0001F9DC\U0001F3FF\U0000200D\U00002642\U0000FE0F',
    'merman_light_skin_tone': u'\U0001F9DC\U0001F3FB\U0000200D\U00002642\U0000FE0F',
    'merman_medium-dark_skin_tone': u'\U0001F9DC\U0001F3FE\U0000200D\U00002642\U0000FE0F',
    'merman_medium-light_skin_tone': u'\U0001F9DC\U0001F3FC\U0000200D\U00002642\U0000FE0F',
    'merman_medium_skin_tone': u'\U0001F9DC\U0001F3FD\U0000200D\U00002642\U0000FE0F',
    'merperson': u'\U0001F9DC',
    'merperson_dark_skin_tone': u'\U0001F9DC\U0001F3FF',
    'merperson_light_skin_tone': u'\U0001F9DC\U0001F3FB',
    'merperson_medium-dark_skin_tone': u'\U0001F9DC\U0001F3FE',
    'merperson_medium-light_skin_tone': u'\U0001F9DC\U0001F3FC',
    'merperson_medium_skin_tone': u'\U0001F9DC\U0001F3FD',
    'metro': u'\U0001F687',
    'microbe': u'\U0001F9A0',
    'microphone': u'\U0001F3A4',
    'microscope': u'\U0001F52C',
    'middle_finger': u'\U0001F595',
    'middle_finger_dark_skin_tone': u'\U0001F595\U0001F3FF',
    'middle_finger_light_skin_tone': u'\U0001F595\U0001F3FB',
    'middle_finger_medium-dark_skin_tone': u'\U0001F595\U0001F3FE',
    'middle_finger_medium-light_skin_tone': u'\U0001F595\U0001F3FC',
    'middle_finger_medium_skin_tone': u'\U0001F595\U0001F3FD',
    'military_medal': u'\U0001F396',
    'milky_way': u'\U0001F30C',
    'minibus': u'\U0001F690',
    'moai': u'\U0001F5FF',
    'mobile_phone': u'\U0001F4F1',
    'mobile_phone_off': u'\U0001F4F4',
    'mobile_phone_with_arrow': u'\U0001F4F2',
    'money-mouth_face': u'\U0001F911',
    'money_bag': u'\U0001F4B0',
    'money_with_wings': u'\U0001F4B8',
    'monkey': u'\U0001F412',
    'monkey_face': u'\U0001F435',
    'monorail': u'\U0001F69D',
    'moon_cake': u'\U0001F96E',
    'moon_viewing_ceremony': u'\U0001F391',
    'mosque': u'\U0001F54C',
    'mosquito': u'\U0001F99F',
    'motor_boat': u'\U0001F6E5',
    'motor_scooter': u'\U0001F6F5',
    'motorcycle': u'\U0001F3CD',
    'motorway': u'\U0001F6E3',
    'mount_fuji': u'\U0001F5FB',
    'mountain': u'\U000026F0',
    'mountain_cableway': u'\U0001F6A0',
    'mountain_railway': u'\U0001F69E',
    'mouse': u'\U0001F401',
    'mouse_face': u'\U0001F42D',
    'mouth': u'\U0001F444',
    'movie_camera': u'\U0001F3A5',
    'mushroom': u'\U0001F344',
    'musical_keyboard': u'\U0001F3B9',
    'musical_note': u'\U0001F3B5',
    'musical_notes': u'\U0001F3B6',
    'musical_score': u'\U0001F3BC',
    'muted_speaker': u'\U0001F507',
    'nail_polish': u'\U0001F485',
    'nail_polish_dark_skin_tone': u'\U0001F485\U0001F3FF',
    'nail_polish_light_skin_tone': u'\U0001F485\U0001F3FB',
    'nail_polish_medium-dark_skin_tone': u'\U0001F485\U0001F3FE',
    'nail_polish_medium-light_skin_tone': u'\U0001F485\U0001F3FC',
    'nail_polish_medium_skin_tone': u'\U0001F485\U0001F3FD',
    'name_badge': u'\U0001F4DB',
    'national_park': u'\U0001F3DE',
    'nauseated_face': u'\U0001F922',
    'nazar_amulet': u'\U0001F9FF',
    'necktie': u'\U0001F454',
    'nerd_face': u'\U0001F913',
    'neutral_face': u'\U0001F610',
    'new_moon': u'\U0001F311',
    'new_moon_face': u'\U0001F31A',
    'newspaper': u'\U0001F4F0',
    'next_track_button': u'\U000023ED',
    'night_with_stars': u'\U0001F303',
    'nine-thirty': u'\U0001F564',
    'nine_o’clock': u'\U0001F558',
    'no_bicycles': u'\U0001F6B3',
    'no_entry': u'\U000026D4',
    'no_littering': u'\U0001F6AF',
    'no_mobile_phones': u'\U0001F4F5',
    'no_one_under_eighteen': u'\U0001F51E',
    'no_pedestrians': u'\U0001F6B7',
    'no_smoking': u'\U0001F6AD',
    'non-potable_water': u'\U0001F6B1',
    'nose': u'\U0001F443',
    'nose_dark_skin_tone': u'\U0001F443\U0001F3FF',
    'nose_light_skin_tone': u'\U0001F443\U0001F3FB',
    'nose_medium-dark_skin_tone': u'\U0001F443\U0001F3FE',
    'nose_medium-light_skin_tone': u'\U0001F443\U0001F3FC',
    'nose_medium_skin_tone': u'\U0001F443\U0001F3FD',
    'notebook': u'\U0001F4D3',
    'notebook_with_decorative_cover': u'\U0001F4D4',
    'nut_and_bolt': u'\U0001F529',
    'octopus': u'\U0001F419',
    'oden': u'\U0001F362',
    'office_building': u'\U0001F3E2',
    'ogre': u'\U0001F479',
    'oil_drum': u'\U0001F6E2',
    'old_key': u'\U0001F5DD',
    'old_man': u'\U0001F474',
    'old_man_dark_skin_tone': u'\U0001F474\U0001F3FF',
    'old_man_light_skin_tone': u'\U0001F474\U0001F3FB',
    'old_man_medium-dark_skin_tone': u'\U0001F474\U0001F3FE',
    'old_man_medium-light_skin_tone': u'\U0001F474\U0001F3FC',
    'old_man_medium_skin_tone': u'\U0001F474\U0001F3FD',
    'old_woman': u'\U0001F475',
    'old_woman_dark_skin_tone': u'\U0001F475\U0001F3FF',
    'old_woman_light_skin_tone': u'\U0001F475\U0001F3FB',
    'old_woman_medium-dark_skin_tone': u'\U0001F475\U0001F3FE',
    'old_woman_medium-light_skin_tone': u'\U0001F475\U0001F3FC',
    'old_woman_medium_skin_tone': u'\U0001F475\U0001F3FD',
    'older_adult': u'\U0001F9D3',
    'older_adult_dark_skin_tone': u'\U0001F9D3\U0001F3FF',
    'older_adult_light_skin_tone': u'\U0001F9D3\U0001F3FB',
    'older_adult_medium-dark_skin_tone': u'\U0001F9D3\U0001F3FE',
    'older_adult_medium-light_skin_tone': u'\U0001F9D3\U0001F3FC',
    'older_adult_medium_skin_tone': u'\U0001F9D3\U0001F3FD',
    'om': u'\U0001F549',
    'oncoming_automobile': u'\U0001F698',
    'oncoming_bus': u'\U0001F68D',
    'oncoming_fist': u'\U0001F44A',
    'oncoming_fist_dark_skin_tone': u'\U0001F44A\U0001F3FF',
    'oncoming_fist_light_skin_tone': u'\U0001F44A\U0001F3FB',
    'oncoming_fist_medium-dark_skin_tone': u'\U0001F44A\U0001F3FE',
    'oncoming_fist_medium-light_skin_tone': u'\U0001F44A\U0001F3FC',
    'oncoming_fist_medium_skin_tone': u'\U0001F44A\U0001F3FD',
    'oncoming_police_car': u'\U0001F694',
    'oncoming_taxi': u'\U0001F696',
    'one-thirty': u'\U0001F55C',
    'one_o’clock': u'\U0001F550',
    'open_book': u'\U0001F4D6',
    'open_file_folder': u'\U0001F4C2',
    'open_hands': u'\U0001F450',
    'open_hands_dark_skin_tone': u'\U0001F450\U0001F3FF',
    'open_hands_light_skin_tone': u'\U0001F450\U0001F3FB',
    'open_hands_medium-dark_skin_tone': u'\U0001F450\U0001F3FE',
    'open_hands_medium-light_skin_tone': u'\U0001F450\U0001F3FC',
    'open_hands_medium_skin_tone': u'\U0001F450\U0001F3FD',
    'open_mailbox_with_lowered_flag': u'\U0001F4ED',
    'open_mailbox_with_raised_flag': u'\U0001F4EC',
    'optical_disk': u'\U0001F4BF',
    'orange_book': u'\U0001F4D9',
    'orange_heart': u'\U0001F9E1',
    'orthodox_cross': u'\U00002626',
    'outbox_tray': u'\U0001F4E4',
    'owl': u'\U0001F989',
    'ox': u'\U0001F402',
    'package': u'\U0001F4E6',
    'page_facing_up': u'\U0001F4C4',
    'page_with_curl': u'\U0001F4C3',
    'pager': u'\U0001F4DF',
    'paintbrush': u'\U0001F58C',
    'palm_tree': u'\U0001F334',
    'palms_up_together': u'\U0001F932',
    'palms_up_together_dark_skin_tone': u'\U0001F932\U0001F3FF',
    'palms_up_together_light_skin_tone': u'\U0001F932\U0001F3FB',
    'palms_up_together_medium-dark_skin_tone': u'\U0001F932\U0001F3FE',
    'palms_up_together_medium-light_skin_tone': u'\U0001F932\U0001F3FC',
    'palms_up_together_medium_skin_tone': u'\U0001F932\U0001F3FD',
    'pancakes': u'\U0001F95E',
    'panda_face': u'\U0001F43C',
    'paperclip': u'\U0001F4CE',
    'parrot': u'\U0001F99C',
    'part_alternation_mark': u'\U0000303D',
    'party_popper': u'\U0001F389',
    'partying_face': u'\U0001F973',
    'passenger_ship': u'\U0001F6F3',
    'passport_control': u'\U0001F6C2',
    'pause_button': u'\U000023F8',
    'paw_prints': u'\U0001F43E',
    'peace_symbol': u'\U0000262E',
    'peach': u'\U0001F351',
    'peacock': u'\U0001F99A',
    'peanuts': u'\U0001F95C',
    'pear': u'\U0001F350',
    'pen': u'\U0001F58A',
    'pencil': u'\U0000270F',
    'penguin': u'\U0001F427',
    'pensive_face': u'\U0001F614',
    'people_with_bunny_ears': u'\U0001F46F',
    'people_wrestling': u'\U0001F93C',
    'performing_arts': u'\U0001F3AD',
    'persevering_face': u'\U0001F623',
    'person_biking': u'\U0001F6B4',
    'person_biking_dark_skin_tone': u'\U0001F6B4\U0001F3FF',
    'person_biking_light_skin_tone': u'\U0001F6B4\U0001F3FB',
    'person_biking_medium-dark_skin_tone': u'\U0001F6B4\U0001F3FE',
    'person_biking_medium-light_skin_tone': u'\U0001F6B4\U0001F3FC',
    'person_biking_medium_skin_tone': u'\U0001F6B4\U0001F3FD',
    'person_bouncing_ball': u'\U000026F9',
    'person_bouncing_ball_dark_skin_tone': u'\U000026F9\U0001F3FF',
    'person_bouncing_ball_light_skin_tone': u'\U000026F9\U0001F3FB',
    'person_bouncing_ball_medium-dark_skin_tone': u'\U000026F9\U0001F3FE',
    'person_bouncing_ball_medium-light_skin_tone': u'\U000026F9\U0001F3FC',
    'person_bouncing_ball_medium_skin_tone': u'\U000026F9\U0001F3FD',
    'person_bowing': u'\U0001F647',
    'person_bowing_dark_skin_tone': u'\U0001F647\U0001F3FF',
    'person_bowing_light_skin_tone': u'\U0001F647\U0001F3FB',
    'person_bowing_medium-dark_skin_tone': u'\U0001F647\U0001F3FE',
    'person_bowing_medium-light_skin_tone': u'\U0001F647\U0001F3FC',
    'person_bowing_medium_skin_tone': u'\U0001F647\U0001F3FD',
    'person_cartwheeling': u'\U0001F938',
    'person_cartwheeling_dark_skin_tone': u'\U0001F938\U0001F3FF',
    'person_cartwheeling_light_skin_tone': u'\U0001F938\U0001F3FB',
    'person_cartwheeling_medium-dark_skin_tone': u'\U0001F938\U0001F3FE',
    'person_cartwheeling_medium-light_skin_tone': u'\U0001F938\U0001F3FC',
    'person_cartwheeling_medium_skin_tone': u'\U0001F938\U0001F3FD',
    'person_climbing': u'\U0001F9D7',
    'person_climbing_dark_skin_tone': u'\U0001F9D7\U0001F3FF',
    'person_climbing_light_skin_tone': u'\U0001F9D7\U0001F3FB',
    'person_climbing_medium-dark_skin_tone': u'\U0001F9D7\U0001F3FE',
    'person_climbing_medium-light_skin_tone': u'\U0001F9D7\U0001F3FC',
    'person_climbing_medium_skin_tone': u'\U0001F9D7\U0001F3FD',
    'person_facepalming': u'\U0001F926',
    'person_facepalming_dark_skin_tone': u'\U0001F926\U0001F3FF',
    'person_facepalming_light_skin_tone': u'\U0001F926\U0001F3FB',
    'person_facepalming_medium-dark_skin_tone': u'\U0001F926\U0001F3FE',
    'person_facepalming_medium-light_skin_tone': u'\U0001F926\U0001F3FC',
    'person_facepalming_medium_skin_tone': u'\U0001F926\U0001F3FD',
    'person_fencing': u'\U0001F93A',
    'person_frowning': u'\U0001F64D',
    'person_frowning_dark_skin_tone': u'\U0001F64D\U0001F3FF',
    'person_frowning_light_skin_tone': u'\U0001F64D\U0001F3FB',
    'person_frowning_medium-dark_skin_tone': u'\U0001F64D\U0001F3FE',
    'person_frowning_medium-light_skin_tone': u'\U0001F64D\U0001F3FC',
    'person_frowning_medium_skin_tone': u'\U0001F64D\U0001F3FD',
    'person_gesturing_NO': u'\U0001F645',
    'person_gesturing_NO_dark_skin_tone': u'\U0001F645\U0001F3FF',
    'person_gesturing_NO_light_skin_tone': u'\U0001F645\U0001F3FB',
    'person_gesturing_NO_medium-dark_skin_tone': u'\U0001F645\U0001F3FE',
    'person_gesturing_NO_medium-light_skin_tone': u'\U0001F645\U0001F3FC',
    'person_gesturing_NO_medium_skin_tone': u'\U0001F645\U0001F3FD',
    'person_gesturing_OK': u'\U0001F646',
    'person_gesturing_OK_dark_skin_tone': u'\U0001F646\U0001F3FF',
    'person_gesturing_OK_light_skin_tone': u'\U0001F646\U0001F3FB',
    'person_gesturing_OK_medium-dark_skin_tone': u'\U0001F646\U0001F3FE',
    'person_gesturing_OK_medium-light_skin_tone': u'\U0001F646\U0001F3FC',
    'person_gesturing_OK_medium_skin_tone': u'\U0001F646\U0001F3FD',
    'person_getting_haircut': u'\U0001F487',
    'person_getting_haircut_dark_skin_tone': u'\U0001F487\U0001F3FF',
    'person_getting_haircut_light_skin_tone': u'\U0001F487\U0001F3FB',
    'person_getting_haircut_medium-dark_skin_tone': u'\U0001F487\U0001F3FE',
    'person_getting_haircut_medium-light_skin_tone': u'\U0001F487\U0001F3FC',
    'person_getting_haircut_medium_skin_tone': u'\U0001F487\U0001F3FD',
    'person_getting_massage': u'\U0001F486',
    'person_getting_massage_dark_skin_tone': u'\U0001F486\U0001F3FF',
    'person_getting_massage_light_skin_tone': u'\U0001F486\U0001F3FB',
    'person_getting_massage_medium-dark_skin_tone': u'\U0001F486\U0001F3FE',
    'person_getting_massage_medium-light_skin_tone': u'\U0001F486\U0001F3FC',
    'person_getting_massage_medium_skin_tone': u'\U0001F486\U0001F3FD',
    'person_golfing': u'\U0001F3CC',
    'person_golfing_dark_skin_tone': u'\U0001F3CC\U0001F3FF',
    'person_golfing_light_skin_tone': u'\U0001F3CC\U0001F3FB',
    'person_golfing_medium-dark_skin_tone': u'\U0001F3CC\U0001F3FE',
    'person_golfing_medium-light_skin_tone': u'\U0001F3CC\U0001F3FC',
    'person_golfing_medium_skin_tone': u'\U0001F3CC\U0001F3FD',
    'person_in_bed': u'\U0001F6CC',
    'person_in_bed_dark_skin_tone': u'\U0001F6CC\U0001F3FF',
    'person_in_bed_light_skin_tone': u'\U0001F6CC\U0001F3FB',
    'person_in_bed_medium-dark_skin_tone': u'\U0001F6CC\U0001F3FE',
    'person_in_bed_medium-light_skin_tone': u'\U0001F6CC\U0001F3FC',
    'person_in_bed_medium_skin_tone': u'\U0001F6CC\U0001F3FD',
    'person_in_lotus_position': u'\U0001F9D8',
    'person_in_lotus_position_dark_skin_tone': u'\U0001F9D8\U0001F3FF',
    'person_in_lotus_position_light_skin_tone': u'\U0001F9D8\U0001F3FB',
    'person_in_lotus_position_medium-dark_skin_tone': u'\U0001F9D8\U0001F3FE',
    'person_in_lotus_position_medium-light_skin_tone': u'\U0001F9D8\U0001F3FC',
    'person_in_lotus_position_medium_skin_tone': u'\U0001F9D8\U0001F3FD',
    'person_in_steamy_room': u'\U0001F9D6',
    'person_in_steamy_room_dark_skin_tone': u'\U0001F9D6\U0001F3FF',
    'person_in_steamy_room_light_skin_tone': u'\U0001F9D6\U0001F3FB',
    'person_in_steamy_room_medium-dark_skin_tone': u'\U0001F9D6\U0001F3FE',
    'person_in_steamy_room_medium-light_skin_tone': u'\U0001F9D6\U0001F3FC',
    'person_in_steamy_room_medium_skin_tone': u'\U0001F9D6\U0001F3FD',
    'person_juggling': u'\U0001F939',
    'person_juggling_dark_skin_tone': u'\U0001F939\U0001F3FF',
    'person_juggling_light_skin_tone': u'\U0001F939\U0001F3FB',
    'person_juggling_medium-dark_skin_tone': u'\U0001F939\U0001F3FE',
    'person_juggling_medium-light_skin_tone': u'\U0001F939\U0001F3FC',
    'person_juggling_medium_skin_tone': u'\U0001F939\U0001F3FD',
    'person_lifting_weights': u'\U0001F3CB',
    'person_lifting_weights_dark_skin_tone': u'\U0001F3CB\U0001F3FF',
    'person_lifting_weights_light_skin_tone': u'\U0001F3CB\U0001F3FB',
    'person_lifting_weights_medium-dark_skin_tone': u'\U0001F3CB\U0001F3FE',
    'person_lifting_weights_medium-light_skin_tone': u'\U0001F3CB\U0001F3FC',
    'person_lifting_weights_medium_skin_tone': u'\U0001F3CB\U0001F3FD',
    'person_mountain_biking': u'\U0001F6B5',
    'person_mountain_biking_dark_skin_tone': u'\U0001F6B5\U0001F3FF',
    'person_mountain_biking_light_skin_tone': u'\U0001F6B5\U0001F3FB',
    'person_mountain_biking_medium-dark_skin_tone': u'\U0001F6B5\U0001F3FE',
    'person_mountain_biking_medium-light_skin_tone': u'\U0001F6B5\U0001F3FC',
    'person_mountain_biking_medium_skin_tone': u'\U0001F6B5\U0001F3FD',
    'person_playing_handball': u'\U0001F93E',
    'person_playing_handball_dark_skin_tone': u'\U0001F93E\U0001F3FF',
    'person_playing_handball_light_skin_tone': u'\U0001F93E\U0001F3FB',
    'person_playing_handball_medium-dark_skin_tone': u'\U0001F93E\U0001F3FE',
    'person_playing_handball_medium-light_skin_tone': u'\U0001F93E\U0001F3FC',
    'person_playing_handball_medium_skin_tone': u'\U0001F93E\U0001F3FD',
    'person_playing_water_polo': u'\U0001F93D',
    'person_playing_water_polo_dark_skin_tone': u'\U0001F93D\U0001F3FF',
    'person_playing_water_polo_light_skin_tone': u'\U0001F93D\U0001F3FB',
    'person_playing_water_polo_medium-dark_skin_tone': u'\U0001F93D\U0001F3FE',
    'person_playing_water_polo_medium-light_skin_tone': u'\U0001F93D\U0001F3FC',
    'person_playing_water_polo_medium_skin_tone': u'\U0001F93D\U0001F3FD',
    'person_pouting': u'\U0001F64E',
    'person_pouting_dark_skin_tone': u'\U0001F64E\U0001F3FF',
    'person_pouting_light_skin_tone': u'\U0001F64E\U0001F3FB',
    'person_pouting_medium-dark_skin_tone': u'\U0001F64E\U0001F3FE',
    'person_pouting_medium-light_skin_tone': u'\U0001F64E\U0001F3FC',
    'person_pouting_medium_skin_tone': u'\U0001F64E\U0001F3FD',
    'person_raising_hand': u'\U0001F64B',
    'person_raising_hand_dark_skin_tone': u'\U0001F64B\U0001F3FF',
    'person_raising_hand_light_skin_tone': u'\U0001F64B\U0001F3FB',
    'person_raising_hand_medium-dark_skin_tone': u'\U0001F64B\U0001F3FE',
    'person_raising_hand_medium-light_skin_tone': u'\U0001F64B\U0001F3FC',
    'person_raising_hand_medium_skin_tone': u'\U0001F64B\U0001F3FD',
    'person_rowing_boat': u'\U0001F6A3',
    'person_rowing_boat_dark_skin_tone': u'\U0001F6A3\U0001F3FF',
    'person_rowing_boat_light_skin_tone': u'\U0001F6A3\U0001F3FB',
    'person_rowing_boat_medium-dark_skin_tone': u'\U0001F6A3\U0001F3FE',
    'person_rowing_boat_medium-light_skin_tone': u'\U0001F6A3\U0001F3FC',
    'person_rowing_boat_medium_skin_tone': u'\U0001F6A3\U0001F3FD',
    'person_running': u'\U0001F3C3',
    'person_running_dark_skin_tone': u'\U0001F3C3\U0001F3FF',
    'person_running_light_skin_tone': u'\U0001F3C3\U0001F3FB',
    'person_running_medium-dark_skin_tone': u'\U0001F3C3\U0001F3FE',
    'person_running_medium-light_skin_tone': u'\U0001F3C3\U0001F3FC',
    'person_running_medium_skin_tone': u'\U0001F3C3\U0001F3FD',
    'person_shrugging': u'\U0001F937',
    'person_shrugging_dark_skin_tone': u'\U0001F937\U0001F3FF',
    'person_shrugging_light_skin_tone': u'\U0001F937\U0001F3FB',
    'person_shrugging_medium-dark_skin_tone': u'\U0001F937\U0001F3FE',
    'person_shrugging_medium-light_skin_tone': u'\U0001F937\U0001F3FC',
    'person_shrugging_medium_skin_tone': u'\U0001F937\U0001F3FD',
    'person_surfing': u'\U0001F3C4',
    'person_surfing_dark_skin_tone': u'\U0001F3C4\U0001F3FF',
    'person_surfing_light_skin_tone': u'\U0001F3C4\U0001F3FB',
    'person_surfing_medium-dark_skin_tone': u'\U0001F3C4\U0001F3FE',
    'person_surfing_medium-light_skin_tone': u'\U0001F3C4\U0001F3FC',
    'person_surfing_medium_skin_tone': u'\U0001F3C4\U0001F3FD',
    'person_swimming': u'\U0001F3CA',
    'person_swimming_dark_skin_tone': u'\U0001F3CA\U0001F3FF',
    'person_swimming_light_skin_tone': u'\U0001F3CA\U0001F3FB',
    'person_swimming_medium-dark_skin_tone': u'\U0001F3CA\U0001F3FE',
    'person_swimming_medium-light_skin_tone': u'\U0001F3CA\U0001F3FC',
    'person_swimming_medium_skin_tone': u'\U0001F3CA\U0001F3FD',
    'person_taking_bath': u'\U0001F6C0',
    'person_taking_bath_dark_skin_tone': u'\U0001F6C0\U0001F3FF',
    'person_taking_bath_light_skin_tone': u'\U0001F6C0\U0001F3FB',
    'person_taking_bath_medium-dark_skin_tone': u'\U0001F6C0\U0001F3FE',
    'person_taking_bath_medium-light_skin_tone': u'\U0001F6C0\U0001F3FC',
    'person_taking_bath_medium_skin_tone': u'\U0001F6C0\U0001F3FD',
    'person_tipping_hand': u'\U0001F481',
    'person_tipping_hand_dark_skin_tone': u'\U0001F481\U0001F3FF',
    'person_tipping_hand_light_skin_tone': u'\U0001F481\U0001F3FB',
    'person_tipping_hand_medium-dark_skin_tone': u'\U0001F481\U0001F3FE',
    'person_tipping_hand_medium-light_skin_tone': u'\U0001F481\U0001F3FC',
    'person_tipping_hand_medium_skin_tone': u'\U0001F481\U0001F3FD',
    'person_walking': u'\U0001F6B6',
    'person_walking_dark_skin_tone': u'\U0001F6B6\U0001F3FF',
    'person_walking_light_skin_tone': u'\U0001F6B6\U0001F3FB',
    'person_walking_medium-dark_skin_tone': u'\U0001F6B6\U0001F3FE',
    'person_walking_medium-light_skin_tone': u'\U0001F6B6\U0001F3FC',
    'person_walking_medium_skin_tone': u'\U0001F6B6\U0001F3FD',
    'person_wearing_turban': u'\U0001F473',
    'person_wearing_turban_dark_skin_tone': u'\U0001F473\U0001F3FF',
    'person_wearing_turban_light_skin_tone': u'\U0001F473\U0001F3FB',
    'person_wearing_turban_medium-dark_skin_tone': u'\U0001F473\U0001F3FE',
    'person_wearing_turban_medium-light_skin_tone': u'\U0001F473\U0001F3FC',
    'person_wearing_turban_medium_skin_tone': u'\U0001F473\U0001F3FD',
    'petri_dish': u'\U0001F9EB',
    'pick': u'\U000026CF',
    'pie': u'\U0001F967',
    'pig': u'\U0001F416',
    'pig_face': u'\U0001F437',
    'pig_nose': u'\U0001F43D',
    'pile_of_poo': u'\U0001F4A9',
    'pill': u'\U0001F48A',
    'pine_decoration': u'\U0001F38D',
    'pineapple': u'\U0001F34D',
    'ping_pong': u'\U0001F3D3',
    'pirate_flag': u'\U0001F3F4\U0000200D\U00002620\U0000FE0F',
    'pistol': u'\U0001F52B',
    'pizza': u'\U0001F355',
    'place_of_worship': u'\U0001F6D0',
    'play_button': u'\U000025B6',
    'play_or_pause_button': u'\U000023EF',
    'pleading_face': u'\U0001F97A',
    'police_car': u'\U0001F693',
    'police_car_light': u'\U0001F6A8',
    'police_officer': u'\U0001F46E',
    'police_officer_dark_skin_tone': u'\U0001F46E\U0001F3FF',
    'police_officer_light_skin_tone': u'\U0001F46E\U0001F3FB',
    'police_officer_medium-dark_skin_tone': u'\U0001F46E\U0001F3FE',
    'police_officer_medium-light_skin_tone': u'\U0001F46E\U0001F3FC',
    'police_officer_medium_skin_tone': u'\U0001F46E\U0001F3FD',
    'poodle': u'\U0001F429',
    'pool_8_ball': u'\U0001F3B1',
    'popcorn': u'\U0001F37F',
    'post_office': u'\U0001F3E4',
    'postal_horn': u'\U0001F4EF',
    'postbox': u'\U0001F4EE',
    'pot_of_food': u'\U0001F372',
    'potable_water': u'\U0001F6B0',
    'potato': u'\U0001F954',
    'poultry_leg': u'\U0001F357',
    'pound_banknote': u'\U0001F4B7',
    'pouting_cat_face': u'\U0001F63E',
    'pouting_face': u'\U0001F621',
    'prayer_beads': u'\U0001F4FF',
    'pregnant_woman': u'\U0001F930',
    'pregnant_woman_dark_skin_tone': u'\U0001F930\U0001F3FF',
    'pregnant_woman_light_skin_tone': u'\U0001F930\U0001F3FB',
    'pregnant_woman_medium-dark_skin_tone': u'\U0001F930\U0001F3FE',
    'pregnant_woman_medium-light_skin_tone': u'\U0001F930\U0001F3FC',
    'pregnant_woman_medium_skin_tone': u'\U0001F930\U0001F3FD',
    'pretzel': u'\U0001F968',
    'prince': u'\U0001F934',
    'prince_dark_skin_tone': u'\U0001F934\U0001F3FF',
    'prince_light_skin_tone': u'\U0001F934\U0001F3FB',
    'prince_medium-dark_skin_tone': u'\U0001F934\U0001F3FE',
    'prince_medium-light_skin_tone': u'\U0001F934\U0001F3FC',
    'prince_medium_skin_tone': u'\U0001F934\U0001F3FD',
    'princess': u'\U0001F478',
    'princess_dark_skin_tone': u'\U0001F478\U0001F3FF',
    'princess_light_skin_tone': u'\U0001F478\U0001F3FB',
    'princess_medium-dark_skin_tone': u'\U0001F478\U0001F3FE',
    'princess_medium-light_skin_tone': u'\U0001F478\U0001F3FC',
    'princess_medium_skin_tone': u'\U0001F478\U0001F3FD',
    'printer': u'\U0001F5A8',
    'prohibited': u'\U0001F6AB',
    'purple_heart': u'\U0001F49C',
    'purse': u'\U0001F45B',
    'pushpin': u'\U0001F4CC',
    'question_mark': u'\U00002753',
    'rabbit': u'\U0001F407',
    'rabbit_face': u'\U0001F430',
    'raccoon': u'\U0001F99D',
    'racing_car': u'\U0001F3CE',
    'radio': u'\U0001F4FB',
    'radio_button': u'\U0001F518',
    'radioactive': u'\U00002622',
    'railway_car': u'\U0001F683',
    'railway_track': u'\U0001F6E4',
    'rainbow': u'\U0001F308',
    'rainbow_flag': u'\U0001F3F3\U0000FE0F\U0000200D\U0001F308',
    'raised_back_of_hand': u'\U0001F91A',
    'raised_back_of_hand_dark_skin_tone': u'\U0001F91A\U0001F3FF',
    'raised_back_of_hand_light_skin_tone': u'\U0001F91A\U0001F3FB',
    'raised_back_of_hand_medium-dark_skin_tone': u'\U0001F91A\U0001F3FE',
    'raised_back_of_hand_medium-light_skin_tone': u'\U0001F91A\U0001F3FC',
    'raised_back_of_hand_medium_skin_tone': u'\U0001F91A\U0001F3FD',
    'raised_fist': u'\U0000270A',
    'raised_fist_dark_skin_tone': u'\U0000270A\U0001F3FF',
    'raised_fist_light_skin_tone': u'\U0000270A\U0001F3FB',
    'raised_fist_medium-dark_skin_tone': u'\U0000270A\U0001F3FE',
    'raised_fist_medium-light_skin_tone': u'\U0000270A\U0001F3FC',
    'raised_fist_medium_skin_tone': u'\U0000270A\U0001F3FD',
    'raised_hand': u'\U0000270B',
    'raised_hand_dark_skin_tone': u'\U0000270B\U0001F3FF',
    'raised_hand_light_skin_tone': u'\U0000270B\U0001F3FB',
    'raised_hand_medium-dark_skin_tone': u'\U0000270B\U0001F3FE',
    'raised_hand_medium-light_skin_tone': u'\U0000270B\U0001F3FC',
    'raised_hand_medium_skin_tone': u'\U0000270B\U0001F3FD',
    'raising_hands': u'\U0001F64C',
    'raising_hands_dark_skin_tone': u'\U0001F64C\U0001F3FF',
    'raising_hands_light_skin_tone': u'\U0001F64C\U0001F3FB',
    'raising_hands_medium-dark_skin_tone': u'\U0001F64C\U0001F3FE',
    'raising_hands_medium-light_skin_tone': u'\U0001F64C\U0001F3FC',
    'raising_hands_medium_skin_tone': u'\U0001F64C\U0001F3FD',
    'ram': u'\U0001F40F',
    'rat': u'\U0001F400',
    'receipt': u'\U0001F9FE',
    'record_button': u'\U000023FA',
    'recycling_symbol': u'\U0000267B',
    'red_apple': u'\U0001F34E',
    'red_circle': u'\U0001F534',
    'red_envelope': u'\U0001F9E7',
    'red_hair': u'\U0001F9B0',
    'red-haired_man': u'\U0001F468\U0000200D\U0001F9B0',
    'red-haired_woman': u'\U0001F469\U0000200D\U0001F9B0',
    'red_heart': u'\U00002764',
    'red_paper_lantern': u'\U0001F3EE',
    'red_triangle_pointed_down': u'\U0001F53B',
    'red_triangle_pointed_up': u'\U0001F53A',
    'registered': u'\U000000AE',
    'relieved_face': u'\U0001F60C',
    'reminder_ribbon': u'\U0001F397',
    'repeat_button': u'\U0001F501',
    'repeat_single_button': u'\U0001F502',
    'rescue_worker’s_helmet': u'\U000026D1',
    'restroom': u'\U0001F6BB',
    'reverse_button': u'\U000025C0',
    'revolving_hearts': u'\U0001F49E',
    'rhinoceros': u'\U0001F98F',
    'ribbon': u'\U0001F380',
    'rice_ball': u'\U0001F359',
    'rice_cracker': u'\U0001F358',
    'right-facing_fist': u'\U0001F91C',
    'right-facing_fist_dark_skin_tone': u'\U0001F91C\U0001F3FF',
    'right-facing_fist_light_skin_tone': u'\U0001F91C\U0001F3FB',
    'right-facing_fist_medium-dark_skin_tone': u'\U0001F91C\U0001F3FE',
    'right-facing_fist_medium-light_skin_tone': u'\U0001F91C\U0001F3FC',
    'right-facing_fist_medium_skin_tone': u'\U0001F91C\U0001F3FD',
    'right_anger_bubble': u'\U0001F5EF',
    'right_arrow': u'\U000027A1',
    'right_arrow_curving_down': u'\U00002935',
    'right_arrow_curving_left': u'\U000021A9',
    'right_arrow_curving_up': u'\U00002934',
    'ring': u'\U0001F48D',
    'roasted_sweet_potato': u'\U0001F360',
    'robot_face': u'\U0001F916',
    'rocket': u'\U0001F680',
    'roll_of_paper': u'\U0001F9FB',
    'rolled-up_newspaper': u'\U0001F5DE',
    'roller_coaster': u'\U0001F3A2',
    'rolling_on_the_floor_laughing': u'\U0001F923',
    'rooster': u'\U0001F413',
    'rose': u'\U0001F339',
    'rosette': u'\U0001F3F5',
    'round_pushpin': u'\U0001F4CD',
    'rugby_football': u'\U0001F3C9',
    'running_shirt': u'\U0001F3BD',
    'running_shoe': u'\U0001F45F',
    'sad_but_relieved_face': u'\U0001F625',
    'safety_pin': u'\U0001F9F7',
    'salt': u'\U0001F9C2',
    'sailboat': u'\U000026F5',
    'sake': u'\U0001F376',
    'sandwich': u'\U0001F96A',
    'satellite': u'\U0001F6F0',
    'satellite_antenna': u'\U0001F4E1',
    'sauropod': u'\U0001F995',
    'saxophone': u'\U0001F3B7',
    'scarf': u'\U0001F9E3',
    'school': u'\U0001F3EB',
    'school_backpack': u'\U0001F392',
    'scissors': u'\U00002702',
    'scorpion': u'\U0001F982',
    'scroll': u'\U0001F4DC',
    'seat': u'\U0001F4BA',
    'see-no-evil_monkey': u'\U0001F648',
    'seedling': u'\U0001F331',
    'selfie': u'\U0001F933',
    'selfie_dark_skin_tone': u'\U0001F933\U0001F3FF',
    'selfie_light_skin_tone': u'\U0001F933\U0001F3FB',
    'selfie_medium-dark_skin_tone': u'\U0001F933\U0001F3FE',
    'selfie_medium-light_skin_tone': u'\U0001F933\U0001F3FC',
    'selfie_medium_skin_tone': u'\U0001F933\U0001F3FD',
    'seven-thirty': u'\U0001F562',
    'seven_o’clock': u'\U0001F556',
    'shallow_pan_of_food': u'\U0001F958',
    'shamrock': u'\U00002618',
    'shark': u'\U0001F988',
    'shaved_ice': u'\U0001F367',
    'sheaf_of_rice': u'\U0001F33E',
    'shield': u'\U0001F6E1',
    'shinto_shrine': u'\U000026E9',
    'ship': u'\U0001F6A2',
    'shooting_star': u'\U0001F320',
    'shopping_bags': u'\U0001F6CD',
    'shopping_cart': u'\U0001F6D2',
    'shortcake': u'\U0001F370',
    'shower': u'\U0001F6BF',
    'shrimp': u'\U0001F990',
    'shuffle_tracks_button': u'\U0001F500',
    'shushing_face': u'\U0001F92B',
    'sign_of_the_horns': u'\U0001F918',
    'sign_of_the_horns_dark_skin_tone': u'\U0001F918\U0001F3FF',
    'sign_of_the_horns_light_skin_tone': u'\U0001F918\U0001F3FB',
    'sign_of_the_horns_medium-dark_skin_tone': u'\U0001F918\U0001F3FE',
    'sign_of_the_horns_medium-light_skin_tone': u'\U0001F918\U0001F3FC',
    'sign_of_the_horns_medium_skin_tone': u'\U0001F918\U0001F3FD',
    'six-thirty': u'\U0001F561',
    'six_o’clock': u'\U0001F555',
    'skateboard': u'\U0001F6F9',
    'skier': u'\U000026F7',
    'skis': u'\U0001F3BF',
    'skull': u'\U0001F480',
    'skull_and_crossbones': u'\U00002620',
    'sled': u'\U0001F6F7',
    'sleeping_face': u'\U0001F634',
    'sleepy_face': u'\U0001F62A',
    'slightly_frowning_face': u'\U0001F641',
    'slightly_smiling_face': u'\U0001F642',
    'slot_machine': u'\U0001F3B0',
    'small_airplane': u'\U0001F6E9',
    'small_blue_diamond': u'\U0001F539',
    'small_orange_diamond': u'\U0001F538',
    'smiling_cat_face_with_heart-eyes': u'\U0001F63B',
    'smiling_face': u'\U0000263A',
    'smiling_face_with_halo': u'\U0001F607',
    'smiling_face_with_3_hearts': u'\U0001F970',
    'smiling_face_with_heart-eyes': u'\U0001F60D',
    'smiling_face_with_horns': u'\U0001F608',
    'smiling_face_with_smiling_eyes': u'\U0001F60A',
    'smiling_face_with_sunglasses': u'\U0001F60E',
    'smirking_face': u'\U0001F60F',
    'snail': u'\U0001F40C',
    'snake': u'\U0001F40D',
    'sneezing_face': u'\U0001F927',
    'snow-capped_mountain': u'\U0001F3D4',
    'snowboarder': u'\U0001F3C2',
    'snowboarder_dark_skin_tone': u'\U0001F3C2\U0001F3FF',
    'snowboarder_light_skin_tone': u'\U0001F3C2\U0001F3FB',
    'snowboarder_medium-dark_skin_tone': u'\U0001F3C2\U0001F3FE',
    'snowboarder_medium-light_skin_tone': u'\U0001F3C2\U0001F3FC',
    'snowboarder_medium_skin_tone': u'\U0001F3C2\U0001F3FD',
    'snowflake': u'\U00002744',
    'snowman': u'\U00002603',
    'snowman_without_snow': u'\U000026C4',
    'soap': u'\U0001F9FC',
    'soccer_ball': u'\U000026BD',
    'socks': u'\U0001F9E6',
    'softball': u'\U0001F94E',
    'soft_ice_cream': u'\U0001F366',
    'spade_suit': u'\U00002660',
    'spaghetti': u'\U0001F35D',
    'sparkle': u'\U00002747',
    'sparkler': u'\U0001F387',
    'sparkles': u'\U00002728',
    'sparkling_heart': u'\U0001F496',
    'speak-no-evil_monkey': u'\U0001F64A',
    'speaker_high_volume': u'\U0001F50A',
    'speaker_low_volume': u'\U0001F508',
    'speaker_medium_volume': u'\U0001F509',
    'speaking_head': u'\U0001F5E3',
    'speech_balloon': u'\U0001F4AC',
    'speedboat': u'\U0001F6A4',
    'spider': u'\U0001F577',
    'spider_web': u'\U0001F578',
    'spiral_calendar': u'\U0001F5D3',
    'spiral_notepad': u'\U0001F5D2',
    'spiral_shell': u'\U0001F41A',
    'spoon': u'\U0001F944',
    'sponge': u'\U0001F9FD',
    'sport_utility_vehicle': u'\U0001F699',
    'sports_medal': u'\U0001F3C5',
    'spouting_whale': u'\U0001F433',
    'squid': u'\U0001F991',
    'squinting_face_with_tongue': u'\U0001F61D',
    'stadium': u'\U0001F3DF',
    'star-struck': u'\U0001F929',
    'star_and_crescent': u'\U0000262A',
    'star_of_David': u'\U00002721',
    'station': u'\U0001F689',
    'steaming_bowl': u'\U0001F35C',
    'stop_button': u'\U000023F9',
    'stop_sign': u'\U0001F6D1',
    'stopwatch': u'\U000023F1',
    'straight_ruler': u'\U0001F4CF',
    'strawberry': u'\U0001F353',
    'studio_microphone': u'\U0001F399',
    'stuffed_flatbread': u'\U0001F959',
    'sun': u'\U00002600',
    'sun_behind_cloud': u'\U000026C5',
    'sun_behind_large_cloud': u'\U0001F325',
    'sun_behind_rain_cloud': u'\U0001F326',
    'sun_behind_small_cloud': u'\U0001F324',
    'sun_with_face': u'\U0001F31E',
    'sunflower': u'\U0001F33B',
    'sunglasses': u'\U0001F576',
    'sunrise': u'\U0001F305',
    'sunrise_over_mountains': u'\U0001F304',
    'sunset': u'\U0001F307',
    'superhero': u'\U0001F9B8',
    'supervillain': u'\U0001F9B9',
    'sushi': u'\U0001F363',
    'suspension_railway': u'\U0001F69F',
    'swan': u'\U0001F9A2',
    'sweat_droplets': u'\U0001F4A6',
    'synagogue': u'\U0001F54D',
    'syringe': u'\U0001F489',
    't-shirt': u'\U0001F455',
    'taco': u'\U0001F32E',
    'takeout_box': u'\U0001F961',
    'tanabata_tree': u'\U0001F38B',
    'tangerine': u'\U0001F34A',
    'taxi': u'\U0001F695',
    'teacup_without_handle': u'\U0001F375',
    'tear-off_calendar': u'\U0001F4C6',
    'teddy_bear': u'\U0001F9F8',
    'telephone': u'\U0000260E',
    'telephone_receiver': u'\U0001F4DE',
    'telescope': u'\U0001F52D',
    'television': u'\U0001F4FA',
    'ten-thirty': u'\U0001F565',
    'ten_o’clock': u'\U0001F559',
    'tennis': u'\U0001F3BE',
    'tent': u'\U000026FA',
    'test_tube': u'\U0001F9EA',
    'thermometer': u'\U0001F321',
    'thinking_face': u'\U0001F914',
    'thought_balloon': u'\U0001F4AD',
    'thread': u'\U0001F9F5',
    'three-thirty': u'\U0001F55E',
    'three_o’clock': u'\U0001F552',
    'thumbs_down': u'\U0001F44E',
    'thumbs_down_dark_skin_tone': u'\U0001F44E\U0001F3FF',
    'thumbs_down_light_skin_tone': u'\U0001F44E\U0001F3FB',
    'thumbs_down_medium-dark_skin_tone': u'\U0001F44E\U0001F3FE',
    'thumbs_down_medium-light_skin_tone': u'\U0001F44E\U0001F3FC',
    'thumbs_down_medium_skin_tone': u'\U0001F44E\U0001F3FD',
    'thumbs_up': u'\U0001F44D',
    'thumbs_up_dark_skin_tone': u'\U0001F44D\U0001F3FF',
    'thumbs_up_light_skin_tone': u'\U0001F44D\U0001F3FB',
    'thumbs_up_medium-dark_skin_tone': u'\U0001F44D\U0001F3FE',
    'thumbs_up_medium-light_skin_tone': u'\U0001F44D\U0001F3FC',
    'thumbs_up_medium_skin_tone': u'\U0001F44D\U0001F3FD',
    'ticket': u'\U0001F3AB',
    'tiger': u'\U0001F405',
    'tiger_face': u'\U0001F42F',
    'timer_clock': u'\U000023F2',
    'tired_face': u'\U0001F62B',
    'toolbox': u'\U0001F9F0',
    'toilet': u'\U0001F6BD',
    'tomato': u'\U0001F345',
    'tongue': u'\U0001F445',
    'tooth': u'\U0001F9B7',
    'top_hat': u'\U0001F3A9',
    'tornado': u'\U0001F32A',
    'trackball': u'\U0001F5B2',
    'tractor': u'\U0001F69C',
    'trade_mark': u'\U00002122',
    'train': u'\U0001F686',
    'tram': u'\U0001F68A',
    'tram_car': u'\U0001F68B',
    'triangular_flag': u'\U0001F6A9',
    'triangular_ruler': u'\U0001F4D0',
    'trident_emblem': u'\U0001F531',
    'trolleybus': u'\U0001F68E',
    'trophy': u'\U0001F3C6',
    'tropical_drink': u'\U0001F379',
    'tropical_fish': u'\U0001F420',
    'trumpet': u'\U0001F3BA',
    'tulip': u'\U0001F337',
    'tumbler_glass': u'\U0001F943',
    'turkey': u'\U0001F983',
    'turtle': u'\U0001F422',
    'twelve-thirty': u'\U0001F567',
    'twelve_o’clock': u'\U0001F55B',
    'two-hump_camel': u'\U0001F42B',
    'two-thirty': u'\U0001F55D',
    'two_hearts': u'\U0001F495',
    'two_men_holding_hands': u'\U0001F46C',
    'two_o’clock': u'\U0001F551',
    'two_women_holding_hands': u'\U0001F46D',
    'umbrella': u'\U00002602',
    'umbrella_on_ground': u'\U000026F1',
    'umbrella_with_rain_drops': u'\U00002614',
    'unamused_face': u'\U0001F612',
    'unicorn_face': u'\U0001F984',
    'unlocked': u'\U0001F513',
    'up-down_arrow': u'\U00002195',
    'up-left_arrow': u'\U00002196',
    'up-right_arrow': u'\U00002197',
    'up_arrow': u'\U00002B06',
    'upside-down_face': u'\U0001F643',
    'upwards_button': u'\U0001F53C',
    'vampire': u'\U0001F9DB',
    'vampire_dark_skin_tone': u'\U0001F9DB\U0001F3FF',
    'vampire_light_skin_tone': u'\U0001F9DB\U0001F3FB',
    'vampire_medium-dark_skin_tone': u'\U0001F9DB\U0001F3FE',
    'vampire_medium-light_skin_tone': u'\U0001F9DB\U0001F3FC',
    'vampire_medium_skin_tone': u'\U0001F9DB\U0001F3FD',
    'vertical_traffic_light': u'\U0001F6A6',
    'vibration_mode': u'\U0001F4F3',
    'victory_hand': u'\U0000270C',
    'victory_hand_dark_skin_tone': u'\U0000270C\U0001F3FF',
    'victory_hand_light_skin_tone': u'\U0000270C\U0001F3FB',
    'victory_hand_medium-dark_skin_tone': u'\U0000270C\U0001F3FE',
    'victory_hand_medium-light_skin_tone': u'\U0000270C\U0001F3FC',
    'victory_hand_medium_skin_tone': u'\U0000270C\U0001F3FD',
    'video_camera': u'\U0001F4F9',
    'video_game': u'\U0001F3AE',
    'videocassette': u'\U0001F4FC',
    'violin': u'\U0001F3BB',
    'volcano': u'\U0001F30B',
    'volleyball': u'\U0001F3D0',
    'vulcan_salute': u'\U0001F596',
    'vulcan_salute_dark_skin_tone': u'\U0001F596\U0001F3FF',
    'vulcan_salute_light_skin_tone': u'\U0001F596\U0001F3FB',
    'vulcan_salute_medium-dark_skin_tone': u'\U0001F596\U0001F3FE',
    'vulcan_salute_medium-light_skin_tone': u'\U0001F596\U0001F3FC',
    'vulcan_salute_medium_skin_tone': u'\U0001F596\U0001F3FD',
    'waning_crescent_moon': u'\U0001F318',
    'waning_gibbous_moon': u'\U0001F316',
    'warning': u'\U000026A0',
    'wastebasket': u'\U0001F5D1',
    'watch': u'\U0000231A',
    'water_buffalo': u'\U0001F403',
    'water_closet': u'\U0001F6BE',
    'water_wave': u'\U0001F30A',
    'watermelon': u'\U0001F349',
    'waving_hand': u'\U0001F44B',
    'waving_hand_dark_skin_tone': u'\U0001F44B\U0001F3FF',
    'waving_hand_light_skin_tone': u'\U0001F44B\U0001F3FB',
    'waving_hand_medium-dark_skin_tone': u'\U0001F44B\U0001F3FE',
    'waving_hand_medium-light_skin_tone': u'\U0001F44B\U0001F3FC',
    'waving_hand_medium_skin_tone': u'\U0001F44B\U0001F3FD',
    'wavy_dash': u'\U00003030',
    'waxing_crescent_moon': u'\U0001F312',
    'waxing_gibbous_moon': u'\U0001F314',
    'weary_cat_face': u'\U0001F640',
    'weary_face': u'\U0001F629',
    'wedding': u'\U0001F492',
    'whale': u'\U0001F40B',
    'wheel_of_dharma': u'\U00002638',
    'wheelchair_symbol': u'\U0000267F',
    'white_circle': u'\U000026AA',
    'white_exclamation_mark': u'\U00002755',
    'white_flag': u'\U0001F3F3',
    'white_flower': u'\U0001F4AE',
    'white_hair': u'\U0001F9B3',
    'white-haired_man': u'\U0001F468\U0000200D\U0001F9B3',
    'white-haired_woman': u'\U0001F469\U0000200D\U0001F9B3',
    'white_heavy_check_mark': u'\U00002705',
    'white_large_square': u'\U00002B1C',
    'white_medium-small_square': u'\U000025FD',
    'white_medium_square': u'\U000025FB',
    'white_medium_star': u'\U00002B50',
    'white_question_mark': u'\U00002754',
    'white_small_square': u'\U000025AB',
    'white_square_button': u'\U0001F533',
    'wilted_flower': u'\U0001F940',
    'wind_chime': u'\U0001F390',
    'wind_face': u'\U0001F32C',
    'wine_glass': u'\U0001F377',
    'winking_face': u'\U0001F609',
    'winking_face_with_tongue': u'\U0001F61C',
    'wolf_face': u'\U0001F43A',
    'woman': u'\U0001F469',
    'woman_artist': u'\U0001F469\U0000200D\U0001F3A8',
    'woman_artist_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F3A8',
    'woman_artist_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F3A8',
    'woman_artist_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F3A8',
    'woman_artist_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F3A8',
    'woman_artist_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F3A8',
    'woman_astronaut': u'\U0001F469\U0000200D\U0001F680',
    'woman_astronaut_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F680',
    'woman_astronaut_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F680',
    'woman_astronaut_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F680',
    'woman_astronaut_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F680',
    'woman_astronaut_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F680',
    'woman_biking': u'\U0001F6B4\U0000200D\U00002640\U0000FE0F',
    'woman_biking_dark_skin_tone': u'\U0001F6B4\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_biking_light_skin_tone': u'\U0001F6B4\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_biking_medium-dark_skin_tone': u'\U0001F6B4\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_biking_medium-light_skin_tone': u'\U0001F6B4\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_biking_medium_skin_tone': u'\U0001F6B4\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_bouncing_ball': u'\U000026F9\U0000FE0F\U0000200D\U00002640\U0000FE0F',
    'woman_bouncing_ball_dark_skin_tone': u'\U000026F9\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_bouncing_ball_light_skin_tone': u'\U000026F9\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_bouncing_ball_medium-dark_skin_tone': u'\U000026F9\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_bouncing_ball_medium-light_skin_tone': u'\U000026F9\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_bouncing_ball_medium_skin_tone': u'\U000026F9\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_bowing': u'\U0001F647\U0000200D\U00002640\U0000FE0F',
    'woman_bowing_dark_skin_tone': u'\U0001F647\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_bowing_light_skin_tone': u'\U0001F647\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_bowing_medium-dark_skin_tone': u'\U0001F647\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_bowing_medium-light_skin_tone': u'\U0001F647\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_bowing_medium_skin_tone': u'\U0001F647\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_cartwheeling': u'\U0001F938\U0000200D\U00002640\U0000FE0F',
    'woman_cartwheeling_dark_skin_tone': u'\U0001F938\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_cartwheeling_light_skin_tone': u'\U0001F938\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_cartwheeling_medium-dark_skin_tone': u'\U0001F938\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_cartwheeling_medium-light_skin_tone': u'\U0001F938\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_cartwheeling_medium_skin_tone': u'\U0001F938\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_climbing': u'\U0001F9D7\U0000200D\U00002640\U0000FE0F',
    'woman_climbing_dark_skin_tone': u'\U0001F9D7\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_climbing_light_skin_tone': u'\U0001F9D7\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_climbing_medium-dark_skin_tone': u'\U0001F9D7\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_climbing_medium-light_skin_tone': u'\U0001F9D7\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_climbing_medium_skin_tone': u'\U0001F9D7\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_construction_worker': u'\U0001F477\U0000200D\U00002640\U0000FE0F',
    'woman_construction_worker_dark_skin_tone': u'\U0001F477\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_construction_worker_light_skin_tone': u'\U0001F477\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_construction_worker_medium-dark_skin_tone': u'\U0001F477\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_construction_worker_medium-light_skin_tone': u'\U0001F477\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_construction_worker_medium_skin_tone': u'\U0001F477\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_cook': u'\U0001F469\U0000200D\U0001F373',
    'woman_cook_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F373',
    'woman_cook_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F373',
    'woman_cook_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F373',
    'woman_cook_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F373',
    'woman_cook_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F373',
    'woman_dancing': u'\U0001F483',
    'woman_dancing_dark_skin_tone': u'\U0001F483\U0001F3FF',
    'woman_dancing_light_skin_tone': u'\U0001F483\U0001F3FB',
    'woman_dancing_medium-dark_skin_tone': u'\U0001F483\U0001F3FE',
    'woman_dancing_medium-light_skin_tone': u'\U0001F483\U0001F3FC',
    'woman_dancing_medium_skin_tone': u'\U0001F483\U0001F3FD',
    'woman_dark_skin_tone': u'\U0001F469\U0001F3FF',
    'woman_detective': u'\U0001F575\U0000FE0F\U0000200D\U00002640\U0000FE0F',
    'woman_detective_dark_skin_tone': u'\U0001F575\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_detective_light_skin_tone': u'\U0001F575\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_detective_medium-dark_skin_tone': u'\U0001F575\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_detective_medium-light_skin_tone': u'\U0001F575\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_detective_medium_skin_tone': u'\U0001F575\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_elf': u'\U0001F9DD\U0000200D\U00002640\U0000FE0F',
    'woman_elf_dark_skin_tone': u'\U0001F9DD\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_elf_light_skin_tone': u'\U0001F9DD\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_elf_medium-dark_skin_tone': u'\U0001F9DD\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_elf_medium-light_skin_tone': u'\U0001F9DD\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_elf_medium_skin_tone': u'\U0001F9DD\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_facepalming': u'\U0001F926\U0000200D\U00002640\U0000FE0F',
    'woman_facepalming_dark_skin_tone': u'\U0001F926\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_facepalming_light_skin_tone': u'\U0001F926\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_facepalming_medium-dark_skin_tone': u'\U0001F926\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_facepalming_medium-light_skin_tone': u'\U0001F926\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_facepalming_medium_skin_tone': u'\U0001F926\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_factory_worker': u'\U0001F469\U0000200D\U0001F3ED',
    'woman_factory_worker_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F3ED',
    'woman_factory_worker_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F3ED',
    'woman_factory_worker_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F3ED',
    'woman_factory_worker_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F3ED',
    'woman_factory_worker_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F3ED',
    'woman_fairy': u'\U0001F9DA\U0000200D\U00002640\U0000FE0F',
    'woman_fairy_dark_skin_tone': u'\U0001F9DA\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_fairy_light_skin_tone': u'\U0001F9DA\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_fairy_medium-dark_skin_tone': u'\U0001F9DA\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_fairy_medium-light_skin_tone': u'\U0001F9DA\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_fairy_medium_skin_tone': u'\U0001F9DA\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_farmer': u'\U0001F469\U0000200D\U0001F33E',
    'woman_farmer_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F33E',
    'woman_farmer_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F33E',
    'woman_farmer_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F33E',
    'woman_farmer_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F33E',
    'woman_farmer_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F33E',
    'woman_firefighter': u'\U0001F469\U0000200D\U0001F692',
    'woman_firefighter_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F692',
    'woman_firefighter_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F692',
    'woman_firefighter_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F692',
    'woman_firefighter_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F692',
    'woman_firefighter_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F692',
    'woman_frowning': u'\U0001F64D\U0000200D\U00002640\U0000FE0F',
    'woman_frowning_dark_skin_tone': u'\U0001F64D\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_frowning_light_skin_tone': u'\U0001F64D\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_frowning_medium-dark_skin_tone': u'\U0001F64D\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_frowning_medium-light_skin_tone': u'\U0001F64D\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_frowning_medium_skin_tone': u'\U0001F64D\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_genie': u'\U0001F9DE\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_NO': u'\U0001F645\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_NO_dark_skin_tone': u'\U0001F645\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_NO_light_skin_tone': u'\U0001F645\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_NO_medium-dark_skin_tone': u'\U0001F645\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_NO_medium-light_skin_tone': u'\U0001F645\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_NO_medium_skin_tone': u'\U0001F645\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_OK': u'\U0001F646\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_OK_dark_skin_tone': u'\U0001F646\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_OK_light_skin_tone': u'\U0001F646\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_OK_medium-dark_skin_tone': u'\U0001F646\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_OK_medium-light_skin_tone': u'\U0001F646\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_gesturing_OK_medium_skin_tone': u'\U0001F646\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_getting_haircut': u'\U0001F487\U0000200D\U00002640\U0000FE0F',
    'woman_getting_haircut_dark_skin_tone': u'\U0001F487\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_getting_haircut_light_skin_tone': u'\U0001F487\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_getting_haircut_medium-dark_skin_tone': u'\U0001F487\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_getting_haircut_medium-light_skin_tone': u'\U0001F487\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_getting_haircut_medium_skin_tone': u'\U0001F487\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_getting_massage': u'\U0001F486\U0000200D\U00002640\U0000FE0F',
    'woman_getting_massage_dark_skin_tone': u'\U0001F486\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_getting_massage_light_skin_tone': u'\U0001F486\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_getting_massage_medium-dark_skin_tone': u'\U0001F486\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_getting_massage_medium-light_skin_tone': u'\U0001F486\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_getting_massage_medium_skin_tone': u'\U0001F486\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_golfing': u'\U0001F3CC\U0000FE0F\U0000200D\U00002640\U0000FE0F',
    'woman_golfing_dark_skin_tone': u'\U0001F3CC\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_golfing_light_skin_tone': u'\U0001F3CC\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_golfing_medium-dark_skin_tone': u'\U0001F3CC\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_golfing_medium-light_skin_tone': u'\U0001F3CC\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_golfing_medium_skin_tone': u'\U0001F3CC\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_guard': u'\U0001F482\U0000200D\U00002640\U0000FE0F',
    'woman_guard_dark_skin_tone': u'\U0001F482\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_guard_light_skin_tone': u'\U0001F482\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_guard_medium-dark_skin_tone': u'\U0001F482\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_guard_medium-light_skin_tone': u'\U0001F482\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_guard_medium_skin_tone': u'\U0001F482\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_health_worker': u'\U0001F469\U0000200D\U00002695\U0000FE0F',
    'woman_health_worker_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U00002695\U0000FE0F',
    'woman_health_worker_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U00002695\U0000FE0F',
    'woman_health_worker_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U00002695\U0000FE0F',
    'woman_health_worker_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U00002695\U0000FE0F',
    'woman_health_worker_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U00002695\U0000FE0F',
    'woman_in_lotus_position': u'\U0001F9D8\U0000200D\U00002640\U0000FE0F',
    'woman_in_lotus_position_dark_skin_tone': u'\U0001F9D8\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_in_lotus_position_light_skin_tone': u'\U0001F9D8\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_in_lotus_position_medium-dark_skin_tone': u'\U0001F9D8\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_in_lotus_position_medium-light_skin_tone': u'\U0001F9D8\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_in_lotus_position_medium_skin_tone': u'\U0001F9D8\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_in_steamy_room': u'\U0001F9D6\U0000200D\U00002640\U0000FE0F',
    'woman_in_steamy_room_dark_skin_tone': u'\U0001F9D6\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_in_steamy_room_light_skin_tone': u'\U0001F9D6\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_in_steamy_room_medium-dark_skin_tone': u'\U0001F9D6\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_in_steamy_room_medium-light_skin_tone': u'\U0001F9D6\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_in_steamy_room_medium_skin_tone': u'\U0001F9D6\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_judge': u'\U0001F469\U0000200D\U00002696\U0000FE0F',
    'woman_judge_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U00002696\U0000FE0F',
    'woman_judge_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U00002696\U0000FE0F',
    'woman_judge_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U00002696\U0000FE0F',
    'woman_judge_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U00002696\U0000FE0F',
    'woman_judge_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U00002696\U0000FE0F',
    'woman_juggling': u'\U0001F939\U0000200D\U00002640\U0000FE0F',
    'woman_juggling_dark_skin_tone': u'\U0001F939\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_juggling_light_skin_tone': u'\U0001F939\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_juggling_medium-dark_skin_tone': u'\U0001F939\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_juggling_medium-light_skin_tone': u'\U0001F939\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_juggling_medium_skin_tone': u'\U0001F939\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_lifting_weights': u'\U0001F3CB\U0000FE0F\U0000200D\U00002640\U0000FE0F',
    'woman_lifting_weights_dark_skin_tone': u'\U0001F3CB\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_lifting_weights_light_skin_tone': u'\U0001F3CB\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_lifting_weights_medium-dark_skin_tone': u'\U0001F3CB\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_lifting_weights_medium-light_skin_tone': u'\U0001F3CB\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_lifting_weights_medium_skin_tone': u'\U0001F3CB\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_light_skin_tone': u'\U0001F469\U0001F3FB',
    'woman_mage': u'\U0001F9D9\U0000200D\U00002640\U0000FE0F',
    'woman_mage_dark_skin_tone': u'\U0001F9D9\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_mage_light_skin_tone': u'\U0001F9D9\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_mage_medium-dark_skin_tone': u'\U0001F9D9\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_mage_medium-light_skin_tone': u'\U0001F9D9\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_mage_medium_skin_tone': u'\U0001F9D9\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_mechanic': u'\U0001F469\U0000200D\U0001F527',
    'woman_mechanic_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F527',
    'woman_mechanic_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F527',
    'woman_mechanic_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F527',
    'woman_mechanic_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F527',
    'woman_mechanic_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F527',
    'woman_medium-dark_skin_tone': u'\U0001F469\U0001F3FE',
    'woman_medium-light_skin_tone': u'\U0001F469\U0001F3FC',
    'woman_medium_skin_tone': u'\U0001F469\U0001F3FD',
    'woman_mountain_biking': u'\U0001F6B5\U0000200D\U00002640\U0000FE0F',
    'woman_mountain_biking_dark_skin_tone': u'\U0001F6B5\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_mountain_biking_light_skin_tone': u'\U0001F6B5\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_mountain_biking_medium-dark_skin_tone': u'\U0001F6B5\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_mountain_biking_medium-light_skin_tone': u'\U0001F6B5\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_mountain_biking_medium_skin_tone': u'\U0001F6B5\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_office_worker': u'\U0001F469\U0000200D\U0001F4BC',
    'woman_office_worker_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F4BC',
    'woman_office_worker_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F4BC',
    'woman_office_worker_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F4BC',
    'woman_office_worker_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F4BC',
    'woman_office_worker_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F4BC',
    'woman_pilot': u'\U0001F469\U0000200D\U00002708\U0000FE0F',
    'woman_pilot_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U00002708\U0000FE0F',
    'woman_pilot_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U00002708\U0000FE0F',
    'woman_pilot_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U00002708\U0000FE0F',
    'woman_pilot_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U00002708\U0000FE0F',
    'woman_pilot_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U00002708\U0000FE0F',
    'woman_playing_handball': u'\U0001F93E\U0000200D\U00002640\U0000FE0F',
    'woman_playing_handball_dark_skin_tone': u'\U0001F93E\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_playing_handball_light_skin_tone': u'\U0001F93E\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_playing_handball_medium-dark_skin_tone': u'\U0001F93E\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_playing_handball_medium-light_skin_tone': u'\U0001F93E\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_playing_handball_medium_skin_tone': u'\U0001F93E\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_playing_water_polo': u'\U0001F93D\U0000200D\U00002640\U0000FE0F',
    'woman_playing_water_polo_dark_skin_tone': u'\U0001F93D\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_playing_water_polo_light_skin_tone': u'\U0001F93D\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_playing_water_polo_medium-dark_skin_tone': u'\U0001F93D\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_playing_water_polo_medium-light_skin_tone': u'\U0001F93D\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_playing_water_polo_medium_skin_tone': u'\U0001F93D\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_police_officer': u'\U0001F46E\U0000200D\U00002640\U0000FE0F',
    'woman_police_officer_dark_skin_tone': u'\U0001F46E\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_police_officer_light_skin_tone': u'\U0001F46E\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_police_officer_medium-dark_skin_tone': u'\U0001F46E\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_police_officer_medium-light_skin_tone': u'\U0001F46E\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_police_officer_medium_skin_tone': u'\U0001F46E\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_pouting': u'\U0001F64E\U0000200D\U00002640\U0000FE0F',
    'woman_pouting_dark_skin_tone': u'\U0001F64E\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_pouting_light_skin_tone': u'\U0001F64E\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_pouting_medium-dark_skin_tone': u'\U0001F64E\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_pouting_medium-light_skin_tone': u'\U0001F64E\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_pouting_medium_skin_tone': u'\U0001F64E\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_raising_hand': u'\U0001F64B\U0000200D\U00002640\U0000FE0F',
    'woman_raising_hand_dark_skin_tone': u'\U0001F64B\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_raising_hand_light_skin_tone': u'\U0001F64B\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_raising_hand_medium-dark_skin_tone': u'\U0001F64B\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_raising_hand_medium-light_skin_tone': u'\U0001F64B\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_raising_hand_medium_skin_tone': u'\U0001F64B\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_rowing_boat': u'\U0001F6A3\U0000200D\U00002640\U0000FE0F',
    'woman_rowing_boat_dark_skin_tone': u'\U0001F6A3\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_rowing_boat_light_skin_tone': u'\U0001F6A3\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_rowing_boat_medium-dark_skin_tone': u'\U0001F6A3\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_rowing_boat_medium-light_skin_tone': u'\U0001F6A3\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_rowing_boat_medium_skin_tone': u'\U0001F6A3\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_running': u'\U0001F3C3\U0000200D\U00002640\U0000FE0F',
    'woman_running_dark_skin_tone': u'\U0001F3C3\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_running_light_skin_tone': u'\U0001F3C3\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_running_medium-dark_skin_tone': u'\U0001F3C3\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_running_medium-light_skin_tone': u'\U0001F3C3\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_running_medium_skin_tone': u'\U0001F3C3\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_scientist': u'\U0001F469\U0000200D\U0001F52C',
    'woman_scientist_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F52C',
    'woman_scientist_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F52C',
    'woman_scientist_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F52C',
    'woman_scientist_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F52C',
    'woman_scientist_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F52C',
    'woman_shrugging': u'\U0001F937\U0000200D\U00002640\U0000FE0F',
    'woman_shrugging_dark_skin_tone': u'\U0001F937\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_shrugging_light_skin_tone': u'\U0001F937\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_shrugging_medium-dark_skin_tone': u'\U0001F937\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_shrugging_medium-light_skin_tone': u'\U0001F937\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_shrugging_medium_skin_tone': u'\U0001F937\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_singer': u'\U0001F469\U0000200D\U0001F3A4',
    'woman_singer_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F3A4',
    'woman_singer_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F3A4',
    'woman_singer_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F3A4',
    'woman_singer_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F3A4',
    'woman_singer_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F3A4',
    'woman_student': u'\U0001F469\U0000200D\U0001F393',
    'woman_student_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F393',
    'woman_student_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F393',
    'woman_student_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F393',
    'woman_student_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F393',
    'woman_student_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F393',
    'woman_surfing': u'\U0001F3C4\U0000200D\U00002640\U0000FE0F',
    'woman_surfing_dark_skin_tone': u'\U0001F3C4\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_surfing_light_skin_tone': u'\U0001F3C4\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_surfing_medium-dark_skin_tone': u'\U0001F3C4\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_surfing_medium-light_skin_tone': u'\U0001F3C4\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_surfing_medium_skin_tone': u'\U0001F3C4\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_swimming': u'\U0001F3CA\U0000200D\U00002640\U0000FE0F',
    'woman_swimming_dark_skin_tone': u'\U0001F3CA\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_swimming_light_skin_tone': u'\U0001F3CA\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_swimming_medium-dark_skin_tone': u'\U0001F3CA\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_swimming_medium-light_skin_tone': u'\U0001F3CA\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_swimming_medium_skin_tone': u'\U0001F3CA\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_teacher': u'\U0001F469\U0000200D\U0001F3EB',
    'woman_teacher_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F3EB',
    'woman_teacher_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F3EB',
    'woman_teacher_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F3EB',
    'woman_teacher_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F3EB',
    'woman_teacher_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F3EB',
    'woman_technologist': u'\U0001F469\U0000200D\U0001F4BB',
    'woman_technologist_dark_skin_tone': u'\U0001F469\U0001F3FF\U0000200D\U0001F4BB',
    'woman_technologist_light_skin_tone': u'\U0001F469\U0001F3FB\U0000200D\U0001F4BB',
    'woman_technologist_medium-dark_skin_tone': u'\U0001F469\U0001F3FE\U0000200D\U0001F4BB',
    'woman_technologist_medium-light_skin_tone': u'\U0001F469\U0001F3FC\U0000200D\U0001F4BB',
    'woman_technologist_medium_skin_tone': u'\U0001F469\U0001F3FD\U0000200D\U0001F4BB',
    'woman_tipping_hand': u'\U0001F481\U0000200D\U00002640\U0000FE0F',
    'woman_tipping_hand_dark_skin_tone': u'\U0001F481\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_tipping_hand_light_skin_tone': u'\U0001F481\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_tipping_hand_medium-dark_skin_tone': u'\U0001F481\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_tipping_hand_medium-light_skin_tone': u'\U0001F481\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_tipping_hand_medium_skin_tone': u'\U0001F481\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_vampire': u'\U0001F9DB\U0000200D\U00002640\U0000FE0F',
    'woman_vampire_dark_skin_tone': u'\U0001F9DB\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_vampire_light_skin_tone': u'\U0001F9DB\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_vampire_medium-dark_skin_tone': u'\U0001F9DB\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_vampire_medium-light_skin_tone': u'\U0001F9DB\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_vampire_medium_skin_tone': u'\U0001F9DB\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_walking': u'\U0001F6B6\U0000200D\U00002640\U0000FE0F',
    'woman_walking_dark_skin_tone': u'\U0001F6B6\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_walking_light_skin_tone': u'\U0001F6B6\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_walking_medium-dark_skin_tone': u'\U0001F6B6\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_walking_medium-light_skin_tone': u'\U0001F6B6\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_walking_medium_skin_tone': u'\U0001F6B6\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_wearing_turban': u'\U0001F473\U0000200D\U00002640\U0000FE0F',
    'woman_wearing_turban_dark_skin_tone': u'\U0001F473\U0001F3FF\U0000200D\U00002640\U0000FE0F',
    'woman_wearing_turban_light_skin_tone': u'\U0001F473\U0001F3FB\U0000200D\U00002640\U0000FE0F',
    'woman_wearing_turban_medium-dark_skin_tone': u'\U0001F473\U0001F3FE\U0000200D\U00002640\U0000FE0F',
    'woman_wearing_turban_medium-light_skin_tone': u'\U0001F473\U0001F3FC\U0000200D\U00002640\U0000FE0F',
    'woman_wearing_turban_medium_skin_tone': u'\U0001F473\U0001F3FD\U0000200D\U00002640\U0000FE0F',
    'woman_with_headscarf': u'\U0001F9D5',
    'woman_with_headscarf_dark_skin_tone': u'\U0001F9D5\U0001F3FF',
    'woman_with_headscarf_light_skin_tone': u'\U0001F9D5\U0001F3FB',
    'woman_with_headscarf_medium-dark_skin_tone': u'\U0001F9D5\U0001F3FE',
    'woman_with_headscarf_medium-light_skin_tone': u'\U0001F9D5\U0001F3FC',
    'woman_with_headscarf_medium_skin_tone': u'\U0001F9D5\U0001F3FD',
    'woman_zombie': u'\U0001F9DF\U0000200D\U00002640\U0000FE0F',
    'woman’s_boot': u'\U0001F462',
    'woman’s_clothes': u'\U0001F45A',
    'woman’s_hat': u'\U0001F452',
    'woman’s_sandal': u'\U0001F461',
    'women_with_bunny_ears': u'\U0001F46F\U0000200D\U00002640\U0000FE0F',
    'women_wrestling': u'\U0001F93C\U0000200D\U00002640\U0000FE0F',
    'women’s_room': u'\U0001F6BA',
    'woozy_face': u'\U0001F974',
    'world_map': u'\U0001F5FA',
    'worried_face': u'\U0001F61F',
    'wrapped_gift': u'\U0001F381',
    'wrench': u'\U0001F527',
    'writing_hand': u'\U0000270D',
    'writing_hand_dark_skin_tone': u'\U0000270D\U0001F3FF',
    'writing_hand_light_skin_tone': u'\U0000270D\U0001F3FB',
    'writing_hand_medium-dark_skin_tone': u'\U0000270D\U0001F3FE',
    'writing_hand_medium-light_skin_tone': u'\U0000270D\U0001F3FC',
    'writing_hand_medium_skin_tone': u'\U0000270D\U0001F3FD',
    'yarn': u'\U0001F9F6',
    'yellow_heart': u'\U0001F49B',
    'yen_banknote': u'\U0001F4B4',
    'yin_yang': u'\U0000262F',
    'zany_face': u'\U0001F92A',
    'zebra': u'\U0001F993',
    'zipper-mouth_face': u'\U0001F910',
    'zombie': u'\U0001F9DF',
    'zzz': u'\U0001F4A4',
    'Åland_Islands': u'\U0001F1E6\U0001F1FD', 

    ### alias
 'admission_tickets': u'\U0001F39F',
    'aerial_tramway': u'\U0001F6A1',
    'airplane': u'\U00002708',
    'airplane_arriving': u'\U0001F6EC',
    'airplane_departure': u'\U0001F6EB',
    'alarm_clock': u'\U000023F0',
    'alembic': u'\U00002697',
    'space_invader': u'\U0001F47E',
    'ambulance': u'\U0001F691',
    'football': u'\U0001F3C8',
    'amphora': u'\U0001F3FA',
    'anchor': u'\U00002693',
    'anger': u'\U0001F4A2',
    'angry': u'\U0001F620',
    'anguished': u'\U0001F627',
    'ant': u'\U0001F41C',
    'signal_strength': u'\U0001F4F6',
    'arrows_counterclockwise': u'\U0001F504',
    'aquarius': u'\U00002652',
    'aries': u'\U00002648',
    'arrow_heading_down': u'\U00002935',
    'arrow_heading_up': u'\U00002934',
    'articulated_lorry': u'\U0001F69B',
    'art': u'\U0001F3A8',
    'astonished': u'\U0001F632',
    'athletic_shoe': u'\U0001F45F',
    'atom_symbol': u'\U0000269B',
    'eggplant': u'\U0001F346',
    'atm': u'\U0001F3E7',
    'car': u'\U0001F697',
    'red_car': u'\U0001F697',
    'baby': u'\U0001F476',
    'angel': u'\U0001F47C',
    'baby_bottle': u'\U0001F37C',
    'baby_chick': u'\U0001F424',
    'baby_symbol': u'\U0001F6BC',
    'back': u'\U0001F519',
    'camel': u'\U0001F42B',
    'badminton_racquet_and_shuttlecock': u'\U0001F3F8',
    'baggage_claim': u'\U0001F6C4',
    'balloon': u'\U0001F388',
    'ballot_box_with_ballot': u'\U0001F5F3',
    'ballot_box_with_check': u'\U00002611',
    'banana': u'\U0001F34C',
    'bank': u'\U0001F3E6',
    'dollar': u'\U0001F4B5',
    'euro': u'\U0001F4B6',
    'pound': u'\U0001F4B7',
    'yen': u'\U0001F4B4',
    'bar_chart': u'\U0001F4CA',
    'barber': u'\U0001F488',
    'baseball': u'\U000026BE',
    'basketball': u'\U0001F3C0',
    'bath': u'\U0001F6C0',
    'bathtub': u'\U0001F6C1',
    'battery': u'\U0001F50B',
    'beach_with_umbrella': u'\U0001F3D6',
    'bear': u'\U0001F43B',
    'heartbeat': u'\U0001F493',
    'bed': u'\U0001F6CF',
    'beer': u'\U0001F37A',
    'bell': u'\U0001F514',
    'no_bell': u'\U0001F515',
    'bellhop_bell': u'\U0001F6CE',
    'bento': u'\U0001F371',
    'bike': u'\U0001F6B2',
    'bicyclist': u'\U0001F6B4',
    'bikini': u'\U0001F459',
    '8ball': u'\U0001F3B1',
    'biohazard_sign': u'\U00002623',
    'bird': u'\U0001F426',
    'birthday': u'\U0001F382',
    'black_circle_for_record': u'\U000023FA',
    'clubs': u'\U00002663',
    'diamonds': u'\U00002666',
    'arrow_double_down': u'\U000023EC',
    'hearts': u'\U00002665',
    'black_large_square': u'\U00002B1B',
    'rewind': u'\U000023EA',
    'black_left__pointing_double_triangle_with_vertical_bar': u'\U000023EE',
    'arrow_backward': u'\U000025C0',
    'black_medium_small_square': u'\U000025FE',
    'black_medium_square': u'\U000025FC',
    'black_nib': u'\U00002712',
    'question': u'\U00002753',
    'fast_forward': u'\U000023E9',
    'black_right__pointing_double_triangle_with_vertical_bar': u'\U000023ED',
    'arrow_forward': u'\U000025B6',
    'black_right__pointing_triangle_with_double_vertical_bar': u'\U000023EF',
    'arrow_right': u'\U000027A1',
    'scissors': u'\U00002702',
    'black_small_square': u'\U000025AA',
    'spades': u'\U00002660',
    'black_square_button': u'\U0001F532',
    'black_square_for_stop': u'\U000023F9',
    'sunny': u'\U00002600',
    'phone': u'\U0000260E',
    'telephone': u'\U0000260E',
    'recycle': u'\U0000267B',
    'arrow_double_up': u'\U000023EB',
    'blossom': u'\U0001F33C',
    'blowfish': u'\U0001F421',
    'blue_book': u'\U0001F4D8',
    'blue_heart': u'\U0001F499',
    'boar': u'\U0001F417',
    'bomb': u'\U0001F4A3',
    'bookmark': u'\U0001F516',
    'bookmark_tabs': u'\U0001F4D1',
    'books': u'\U0001F4DA',
    'bottle_with_popping_cork': u'\U0001F37E',
    'bouquet': u'\U0001F490',
    'bow_and_arrow': u'\U0001F3F9',
    'bowling': u'\U0001F3B3',
    'boy': u'\U0001F466',
    'bread': u'\U0001F35E',
    'bride_with_veil': u'\U0001F470',
    'bridge_at_night': u'\U0001F309',
    'briefcase': u'\U0001F4BC',
    'broken_heart': u'\U0001F494',
    'bug': u'\U0001F41B',
    'building_construction': u'\U0001F3D7',
    'burrito': u'\U0001F32F',
    'bus': u'\U0001F68C',
    'busstop': u'\U0001F68F',
    'bust_in_silhouette': u'\U0001F464',
    'busts_in_silhouette': u'\U0001F465',
    'cactus': u'\U0001F335',
    'date': u'\U0001F4C5',
    'camera': u'\U0001F4F7',
    'camera_with_flash': u'\U0001F4F8',
    'camping': u'\U0001F3D5',
    'cancer': u'\U0000264B',
    'candle': u'\U0001F56F',
    'candy': u'\U0001F36C',
    'capricorn': u'\U00002651',
    'card_file_box': u'\U0001F5C3',
    'card_index': u'\U0001F4C7',
    'card_index_dividers': u'\U0001F5C2',
    'carousel_horse': u'\U0001F3A0',
    'flags': u'\U0001F38F',
    'cat2': u'\U0001F408',
    'cat': u'\U0001F431',
    'joy_cat': u'\U0001F639',
    'smirk_cat': u'\U0001F63C',
    'chains': u'\U000026D3',
    'chart_with_downwards_trend': u'\U0001F4C9',
    'chart_with_upwards_trend': u'\U0001F4C8',
    'chart': u'\U0001F4B9',
    'mega': u'\U0001F4E3',
    'cheese_wedge': u'\U0001F9C0',
    'checkered_flag': u'\U0001F3C1',
    'cherries': u'\U0001F352',
    'cherry_blossom': u'\U0001F338',
    'chestnut': u'\U0001F330',
    'chicken': u'\U0001F414',
    'children_crossing': u'\U0001F6B8',
    'chipmunk': u'\U0001F43F',
    'chocolate_bar': u'\U0001F36B',
    'christmas_tree': u'\U0001F384',
    'church': u'\U000026EA',
    'cinema': u'\U0001F3A6',
    'accept': u'\U0001F251',
    'ideograph_advantage': u'\U0001F250',
    'congratulations': u'\U00003297',
    'secret': u'\U00003299',
    'm': u'\U000024C2',
    'circus_tent': u'\U0001F3AA',
    'cityscape': u'\U0001F3D9',
    'city_sunset': u'\U0001F306',
    'clapper': u'\U0001F3AC',
    'clap': u'\U0001F44F',
    'classical_building': u'\U0001F3DB',
    'beers': u'\U0001F37B',
    'clipboard': u'\U0001F4CB',
    'clock830': u'\U0001F563',
    'clock8': u'\U0001F557',
    'clock1130': u'\U0001F566',
    'clock11': u'\U0001F55A',
    'clock530': u'\U0001F560',
    'clock5': u'\U0001F554',
    'clock430': u'\U0001F55F',
    'clock4': u'\U0001F553',
    'clock930': u'\U0001F564',
    'clock9': u'\U0001F558',
    'clock130': u'\U0001F55C',
    'clock1': u'\U0001F550',
    'clock730': u'\U0001F562',
    'clock7': u'\U0001F556',
    'clock630': u'\U0001F561',
    'clock6': u'\U0001F555',
    'clock1030': u'\U0001F565',
    'clock10': u'\U0001F559',
    'clock330': u'\U0001F55E',
    'clock3': u'\U0001F552',
    'clock1230': u'\U0001F567',
    'clock12': u'\U0001F55B',
    'clock230': u'\U0001F55D',
    'clock2': u'\U0001F551',
    'arrows_clockwise': u'\U0001F503',
    'repeat': u'\U0001F501',
    'repeat_one': u'\U0001F502',
    'closed_book': u'\U0001F4D5',
    'closed_lock_with_key': u'\U0001F510',
    'mailbox_closed': u'\U0001F4EA',
    'mailbox': u'\U0001F4EB',
    'closed_umbrella': u'\U0001F302',
    'cloud': u'\U00002601',
    'cloud_with_lightning': u'\U0001F329',
    'cloud_with_rain': u'\U0001F327',
    'cloud_with_snow': u'\U0001F328',
    'cloud_with_tornado': u'\U0001F32A',
    'cocktail': u'\U0001F378',
    'coffin': u'\U000026B0',
    'boom': u'\U0001F4A5',
    'collision': u'\U0001F4A5',
    'comet': u'\U00002604',
    'compression': u'\U0001F5DC',
    'confetti_ball': u'\U0001F38A',
    'confounded': u'\U0001F616',
    'confused': u'\U0001F615',
    'construction': u'\U0001F6A7',
    'construction_worker': u'\U0001F477',
    'control_knobs': u'\U0001F39B',
    'convenience_store': u'\U0001F3EA',
    'rice': u'\U0001F35A',
    'cookie': u'\U0001F36A',
    'egg': u'\U0001F373',
    'copyright': u'\U000000A9',
    'couch_and_lamp': u'\U0001F6CB',
    'couple_with_heart': u'\U0001F491',
    'cow2': u'\U0001F404',
    'cow': u'\U0001F42E',
    'crab': u'\U0001F980',
    'credit_card': u'\U0001F4B3',
    'crescent_moon': u'\U0001F319',
    'cricket_bat_and_ball': u'\U0001F3CF',
    'crocodile': u'\U0001F40A',
    'x': u'\U0000274C',
    'crossed_flags': u'\U0001F38C',
    'crossed_swords': u'\U00002694',
    'crown': u'\U0001F451',
    'crying_cat_face': u'\U0001F63F',
    'cry': u'\U0001F622',
    'crystal_ball': u'\U0001F52E',
    'curly_loop': u'\U000027B0',
    'currency_exchange': u'\U0001F4B1',
    'curry': u'\U0001F35B',
    'custard': u'\U0001F36E',
    'customs': u'\U0001F6C3',
    'cyclone': u'\U0001F300',
    'dagger_knife': u'\U0001F5E1',
    'dancer': u'\U0001F483',
    'dango': u'\U0001F361',
    'dark_sunglasses': u'\U0001F576',
    'dash': u'\U0001F4A8',
    'deciduous_tree': u'\U0001F333',
    'truck': u'\U0001F69A',
    'department_store': u'\U0001F3EC',
    'derelict_house_building': u'\U0001F3DA',
    'desert': u'\U0001F3DC',
    'desert_island': u'\U0001F3DD',
    'desktop_computer': u'\U0001F5A5',
    'diamond_shape_with_a_dot_inside': u'\U0001F4A0',
    'dart': u'\U0001F3AF',
    'disappointed_relieved': u'\U0001F625',
    'disappointed': u'\U0001F61E',
    'dizzy_face': u'\U0001F635',
    'dizzy': u'\U0001F4AB',
    'do_not_litter': u'\U0001F6AF',
    'dog2': u'\U0001F415',
    'dog': u'\U0001F436',
    'dolphin': u'\U0001F42C',
    'flipper': u'\U0001F42C',
    'door': u'\U0001F6AA',
    'loop': u'\U000027BF',
    'bangbang': u'\U0000203C',
    'double_vertical_bar': u'\U000023F8',
    'doughnut': u'\U0001F369',
    'dove_of_peace': u'\U0001F54A',
    'small_red_triangle_down': u'\U0001F53B',
    'arrow_down_small': u'\U0001F53D',
    'arrow_down': u'\U00002B07',
    'dragon': u'\U0001F409',
    'dragon_face': u'\U0001F432',
    'dress': u'\U0001F457',
    'dromedary_camel': u'\U0001F42A',
    'droplet': u'\U0001F4A7',
    'dvd': u'\U0001F4C0',
    'e__mail': u'\U0001F4E7',
    'ear': u'\U0001F442',
    'corn': u'\U0001F33D',
    'ear_of_rice': u'\U0001F33E',
    'earth_americas': u'\U0001F30E',
    'earth_asia': u'\U0001F30F',
    'earth_africa': u'\U0001F30D',
    'eight_pointed_black_star': u'\U00002734',
    'eight_spoked_asterisk': u'\U00002733',
    'eject_symbol': u'\U000023CF',
    'bulb': u'\U0001F4A1',
    'electric_plug': u'\U0001F50C',
    'flashlight': u'\U0001F526',
    'elephant': u'\U0001F418',
    'emoji_modifier_fitzpatrick_type__1__2': u'\U0001F3FB',
    'emoji_modifier_fitzpatrick_type__3': u'\U0001F3FC',
    'emoji_modifier_fitzpatrick_type__4': u'\U0001F3FD',
    'emoji_modifier_fitzpatrick_type__5': u'\U0001F3FE',
    'emoji_modifier_fitzpatrick_type__6': u'\U0001F3FF',
    'end': u'\U0001F51A',
    'email': u'\U00002709',
    'envelope': u'\U00002709',
    'envelope_with_arrow': u'\U0001F4E9',
    'european_castle': u'\U0001F3F0',
    'european_post_office': u'\U0001F3E4',
    'evergreen_tree': u'\U0001F332',
    'interrobang': u'\U00002049',
    'expressionless': u'\U0001F611',
    'alien': u'\U0001F47D',
    'eye': u'\U0001F441',
    'eyeglasses': u'\U0001F453',
    'eyes': u'\U0001F440',
    'massage': u'\U0001F486',
    'yum': u'\U0001F60B',
    'scream': u'\U0001F631',
    'kissing_heart': u'\U0001F618',
    'sweat': u'\U0001F613',
    'face_with_head__bandage': u'\U0001F915',
    'triumph': u'\U0001F624',
    'mask': u'\U0001F637',
    'no_good': u'\U0001F645',
    'ok_woman': u'\U0001F646',
    'open_mouth': u'\U0001F62E',
    'cold_sweat': u'\U0001F630',
    'face_with_rolling_eyes': u'\U0001F644',
    'stuck_out_tongue': u'\U0001F61B',
    'stuck_out_tongue_closed_eyes': u'\U0001F61D',
    'stuck_out_tongue_winking_eye': u'\U0001F61C',
    'joy': u'\U0001F602',
    'face_with_thermometer': u'\U0001F912',
    'no_mouth': u'\U0001F636',
    'factory': u'\U0001F3ED',
    'fallen_leaf': u'\U0001F342',
    'family': u'\U0001F46A',
    'santa': u'\U0001F385',
    'fax': u'\U0001F4E0',
    'fearful': u'\U0001F628',
    'ferris_wheel': u'\U0001F3A1',
    'ferry': u'\U000026F4',
    'field_hockey_stick_and_ball': u'\U0001F3D1',
    'file_cabinet': u'\U0001F5C4',
    'file_folder': u'\U0001F4C1',
    'film_frames': u'\U0001F39E',
    'film_projector': u'\U0001F4FD',
    'fire': u'\U0001F525',
    'fire_engine': u'\U0001F692',
    'sparkler': u'\U0001F387',
    'fireworks': u'\U0001F386',
    'first_quarter_moon': u'\U0001F313',
    'first_quarter_moon_with_face': u'\U0001F31B',
    'fish': u'\U0001F41F',
    'fish_cake': u'\U0001F365',
    'fishing_pole_and_fish': u'\U0001F3A3',
    'facepunch': u'\U0001F44A',
    'punch': u'\U0001F44A',
    'flag_for_Afghanistan': u'\U0001F1E6\U0001F1EB',
    'flag_for_Albania': u'\U0001F1E6\U0001F1F1',
    'flag_for_Algeria': u'\U0001F1E9\U0001F1FF',
    'flag_for_American_Samoa': u'\U0001F1E6\U0001F1F8',
    'flag_for_Andorra': u'\U0001F1E6\U0001F1E9',
    'flag_for_Angola': u'\U0001F1E6\U0001F1F4',
    'flag_for_Anguilla': u'\U0001F1E6\U0001F1EE',
    'flag_for_Antarctica': u'\U0001F1E6\U0001F1F6',
    'flag_for_Antigua_&_Barbuda': u'\U0001F1E6\U0001F1EC',
    'flag_for_Argentina': u'\U0001F1E6\U0001F1F7',
    'flag_for_Armenia': u'\U0001F1E6\U0001F1F2',
    'flag_for_Aruba': u'\U0001F1E6\U0001F1FC',
    'flag_for_Ascension_Island': u'\U0001F1E6\U0001F1E8',
    'flag_for_Australia': u'\U0001F1E6\U0001F1FA',
    'flag_for_Austria': u'\U0001F1E6\U0001F1F9',
    'flag_for_Azerbaijan': u'\U0001F1E6\U0001F1FF',
    'flag_for_Bahamas': u'\U0001F1E7\U0001F1F8',
    'flag_for_Bahrain': u'\U0001F1E7\U0001F1ED',
    'flag_for_Bangladesh': u'\U0001F1E7\U0001F1E9',
    'flag_for_Barbados': u'\U0001F1E7\U0001F1E7',
    'flag_for_Belarus': u'\U0001F1E7\U0001F1FE',
    'flag_for_Belgium': u'\U0001F1E7\U0001F1EA',
    'flag_for_Belize': u'\U0001F1E7\U0001F1FF',
    'flag_for_Benin': u'\U0001F1E7\U0001F1EF',
    'flag_for_Bermuda': u'\U0001F1E7\U0001F1F2',
    'flag_for_Bhutan': u'\U0001F1E7\U0001F1F9',
    'flag_for_Bolivia': u'\U0001F1E7\U0001F1F4',
    'flag_for_Bosnia_&_Herzegovina': u'\U0001F1E7\U0001F1E6',
    'flag_for_Botswana': u'\U0001F1E7\U0001F1FC',
    'flag_for_Bouvet_Island': u'\U0001F1E7\U0001F1FB',
    'flag_for_Brazil': u'\U0001F1E7\U0001F1F7',
    'flag_for_British_Indian_Ocean_Territory': u'\U0001F1EE\U0001F1F4',
    'flag_for_British_Virgin_Islands': u'\U0001F1FB\U0001F1EC',
    'flag_for_Brunei': u'\U0001F1E7\U0001F1F3',
    'flag_for_Bulgaria': u'\U0001F1E7\U0001F1EC',
    'flag_for_Burkina_Faso': u'\U0001F1E7\U0001F1EB',
    'flag_for_Burundi': u'\U0001F1E7\U0001F1EE',
    'flag_for_Cambodia': u'\U0001F1F0\U0001F1ED',
    'flag_for_Cameroon': u'\U0001F1E8\U0001F1F2',
    'flag_for_Canada': u'\U0001F1E8\U0001F1E6',
    'flag_for_Canary_Islands': u'\U0001F1EE\U0001F1E8',
    'flag_for_Cape_Verde': u'\U0001F1E8\U0001F1FB',
    'flag_for_Caribbean_Netherlands': u'\U0001F1E7\U0001F1F6',
    'flag_for_Cayman_Islands': u'\U0001F1F0\U0001F1FE',
    'flag_for_Central_African_Republic': u'\U0001F1E8\U0001F1EB',
    'flag_for_Ceuta_&_Melilla': u'\U0001F1EA\U0001F1E6',
    'flag_for_Chad': u'\U0001F1F9\U0001F1E9',
    'flag_for_Chile': u'\U0001F1E8\U0001F1F1',
    'flag_for_China': u'\U0001F1E8\U0001F1F3',
    'flag_for_Christmas_Island': u'\U0001F1E8\U0001F1FD',
    'flag_for_Clipperton_Island': u'\U0001F1E8\U0001F1F5',
    'flag_for_Cocos__Islands': u'\U0001F1E8\U0001F1E8',
    'flag_for_Colombia': u'\U0001F1E8\U0001F1F4',
    'flag_for_Comoros': u'\U0001F1F0\U0001F1F2',
    'flag_for_Congo____Brazzaville': u'\U0001F1E8\U0001F1EC',
    'flag_for_Congo____Kinshasa': u'\U0001F1E8\U0001F1E9',
    'flag_for_Cook_Islands': u'\U0001F1E8\U0001F1F0',
    'flag_for_Costa_Rica': u'\U0001F1E8\U0001F1F7',
    'flag_for_Croatia': u'\U0001F1ED\U0001F1F7',
    'flag_for_Cuba': u'\U0001F1E8\U0001F1FA',
    'flag_for_Curaçao': u'\U0001F1E8\U0001F1FC',
    'flag_for_Cyprus': u'\U0001F1E8\U0001F1FE',
    'flag_for_Czech_Republic': u'\U0001F1E8\U0001F1FF',
    'flag_for_Côte_d’Ivoire': u'\U0001F1E8\U0001F1EE',
    'flag_for_Denmark': u'\U0001F1E9\U0001F1F0',
    'flag_for_Diego_Garcia': u'\U0001F1E9\U0001F1EC',
    'flag_for_Djibouti': u'\U0001F1E9\U0001F1EF',
    'flag_for_Dominica': u'\U0001F1E9\U0001F1F2',
    'flag_for_Dominican_Republic': u'\U0001F1E9\U0001F1F4',
    'flag_for_Ecuador': u'\U0001F1EA\U0001F1E8',
    'flag_for_Egypt': u'\U0001F1EA\U0001F1EC',
    'flag_for_El_Salvador': u'\U0001F1F8\U0001F1FB',
    'flag_for_Equatorial_Guinea': u'\U0001F1EC\U0001F1F6',
    'flag_for_Eritrea': u'\U0001F1EA\U0001F1F7',
    'flag_for_Estonia': u'\U0001F1EA\U0001F1EA',
    'flag_for_Ethiopia': u'\U0001F1EA\U0001F1F9',
    'flag_for_European_Union': u'\U0001F1EA\U0001F1FA',
    'flag_for_Falkland_Islands': u'\U0001F1EB\U0001F1F0',
    'flag_for_Faroe_Islands': u'\U0001F1EB\U0001F1F4',
    'flag_for_Fiji': u'\U0001F1EB\U0001F1EF',
    'flag_for_Finland': u'\U0001F1EB\U0001F1EE',
    'flag_for_France': u'\U0001F1EB\U0001F1F7',
    'flag_for_French_Guiana': u'\U0001F1EC\U0001F1EB',
    'flag_for_French_Polynesia': u'\U0001F1F5\U0001F1EB',
    'flag_for_French_Southern_Territories': u'\U0001F1F9\U0001F1EB',
    'flag_for_Gabon': u'\U0001F1EC\U0001F1E6',
    'flag_for_Gambia': u'\U0001F1EC\U0001F1F2',
    'flag_for_Georgia': u'\U0001F1EC\U0001F1EA',
    'flag_for_Germany': u'\U0001F1E9\U0001F1EA',
    'flag_for_Ghana': u'\U0001F1EC\U0001F1ED',
    'flag_for_Gibraltar': u'\U0001F1EC\U0001F1EE',
    'flag_for_Greece': u'\U0001F1EC\U0001F1F7',
    'flag_for_Greenland': u'\U0001F1EC\U0001F1F1',
    'flag_for_Grenada': u'\U0001F1EC\U0001F1E9',
    'flag_for_Guadeloupe': u'\U0001F1EC\U0001F1F5',
    'flag_for_Guam': u'\U0001F1EC\U0001F1FA',
    'flag_for_Guatemala': u'\U0001F1EC\U0001F1F9',
    'flag_for_Guernsey': u'\U0001F1EC\U0001F1EC',
    'flag_for_Guinea': u'\U0001F1EC\U0001F1F3',
    'flag_for_Guinea__Bissau': u'\U0001F1EC\U0001F1FC',
    'flag_for_Guyana': u'\U0001F1EC\U0001F1FE',
    'flag_for_Haiti': u'\U0001F1ED\U0001F1F9',
    'flag_for_Heard_&_McDonald_Islands': u'\U0001F1ED\U0001F1F2',
    'flag_for_Honduras': u'\U0001F1ED\U0001F1F3',
    'flag_for_Hong_Kong': u'\U0001F1ED\U0001F1F0',
    'flag_for_Hungary': u'\U0001F1ED\U0001F1FA',
    'flag_for_Iceland': u'\U0001F1EE\U0001F1F8',
    'flag_for_India': u'\U0001F1EE\U0001F1F3',
    'flag_for_Indonesia': u'\U0001F1EE\U0001F1E9',
    'flag_for_Iran': u'\U0001F1EE\U0001F1F7',
    'flag_for_Iraq': u'\U0001F1EE\U0001F1F6',
    'flag_for_Ireland': u'\U0001F1EE\U0001F1EA',
    'flag_for_Isle_of_Man': u'\U0001F1EE\U0001F1F2',
    'flag_for_Israel': u'\U0001F1EE\U0001F1F1',
    'flag_for_Italy': u'\U0001F1EE\U0001F1F9',
    'flag_for_Jamaica': u'\U0001F1EF\U0001F1F2',
    'flag_for_Japan': u'\U0001F1EF\U0001F1F5',
    'flag_for_Jersey': u'\U0001F1EF\U0001F1EA',
    'flag_for_Jordan': u'\U0001F1EF\U0001F1F4',
    'flag_for_Kazakhstan': u'\U0001F1F0\U0001F1FF',
    'flag_for_Kenya': u'\U0001F1F0\U0001F1EA',
    'flag_for_Kiribati': u'\U0001F1F0\U0001F1EE',
    'flag_for_Kosovo': u'\U0001F1FD\U0001F1F0',
    'flag_for_Kuwait': u'\U0001F1F0\U0001F1FC',
    'flag_for_Kyrgyzstan': u'\U0001F1F0\U0001F1EC',
    'flag_for_Laos': u'\U0001F1F1\U0001F1E6',
    'flag_for_Latvia': u'\U0001F1F1\U0001F1FB',
    'flag_for_Lebanon': u'\U0001F1F1\U0001F1E7',
    'flag_for_Lesotho': u'\U0001F1F1\U0001F1F8',
    'flag_for_Liberia': u'\U0001F1F1\U0001F1F7',
    'flag_for_Libya': u'\U0001F1F1\U0001F1FE',
    'flag_for_Liechtenstein': u'\U0001F1F1\U0001F1EE',
    'flag_for_Lithuania': u'\U0001F1F1\U0001F1F9',
    'flag_for_Luxembourg': u'\U0001F1F1\U0001F1FA',
    'flag_for_Macau': u'\U0001F1F2\U0001F1F4',
    'flag_for_Macedonia': u'\U0001F1F2\U0001F1F0',
    'flag_for_Madagascar': u'\U0001F1F2\U0001F1EC',
    'flag_for_Malawi': u'\U0001F1F2\U0001F1FC',
    'flag_for_Malaysia': u'\U0001F1F2\U0001F1FE',
    'flag_for_Maldives': u'\U0001F1F2\U0001F1FB',
    'flag_for_Mali': u'\U0001F1F2\U0001F1F1',
    'flag_for_Malta': u'\U0001F1F2\U0001F1F9',
    'flag_for_Marshall_Islands': u'\U0001F1F2\U0001F1ED',
    'flag_for_Martinique': u'\U0001F1F2\U0001F1F6',
    'flag_for_Mauritania': u'\U0001F1F2\U0001F1F7',
    'flag_for_Mauritius': u'\U0001F1F2\U0001F1FA',
    'flag_for_Mayotte': u'\U0001F1FE\U0001F1F9',
    'flag_for_Mexico': u'\U0001F1F2\U0001F1FD',
    'flag_for_Micronesia': u'\U0001F1EB\U0001F1F2',
    'flag_for_Moldova': u'\U0001F1F2\U0001F1E9',
    'flag_for_Monaco': u'\U0001F1F2\U0001F1E8',
    'flag_for_Mongolia': u'\U0001F1F2\U0001F1F3',
    'flag_for_Montenegro': u'\U0001F1F2\U0001F1EA',
    'flag_for_Montserrat': u'\U0001F1F2\U0001F1F8',
    'flag_for_Morocco': u'\U0001F1F2\U0001F1E6',
    'flag_for_Mozambique': u'\U0001F1F2\U0001F1FF',
    'flag_for_Myanmar': u'\U0001F1F2\U0001F1F2',
    'flag_for_Namibia': u'\U0001F1F3\U0001F1E6',
    'flag_for_Nauru': u'\U0001F1F3\U0001F1F7',
    'flag_for_Nepal': u'\U0001F1F3\U0001F1F5',
    'flag_for_Netherlands': u'\U0001F1F3\U0001F1F1',
    'flag_for_New_Caledonia': u'\U0001F1F3\U0001F1E8',
    'flag_for_New_Zealand': u'\U0001F1F3\U0001F1FF',
    'flag_for_Nicaragua': u'\U0001F1F3\U0001F1EE',
    'flag_for_Niger': u'\U0001F1F3\U0001F1EA',
    'flag_for_Nigeria': u'\U0001F1F3\U0001F1EC',
    'flag_for_Niue': u'\U0001F1F3\U0001F1FA',
    'flag_for_Norfolk_Island': u'\U0001F1F3\U0001F1EB',
    'flag_for_North_Korea': u'\U0001F1F0\U0001F1F5',
    'flag_for_Northern_Mariana_Islands': u'\U0001F1F2\U0001F1F5',
    'flag_for_Norway': u'\U0001F1F3\U0001F1F4',
    'flag_for_Oman': u'\U0001F1F4\U0001F1F2',
    'flag_for_Pakistan': u'\U0001F1F5\U0001F1F0',
    'flag_for_Palau': u'\U0001F1F5\U0001F1FC',
    'flag_for_Palestinian_Territories': u'\U0001F1F5\U0001F1F8',
    'flag_for_Panama': u'\U0001F1F5\U0001F1E6',
    'flag_for_Papua_New_Guinea': u'\U0001F1F5\U0001F1EC',
    'flag_for_Paraguay': u'\U0001F1F5\U0001F1FE',
    'flag_for_Peru': u'\U0001F1F5\U0001F1EA',
    'flag_for_Philippines': u'\U0001F1F5\U0001F1ED',
    'flag_for_Pitcairn_Islands': u'\U0001F1F5\U0001F1F3',
    'flag_for_Poland': u'\U0001F1F5\U0001F1F1',
    'flag_for_Portugal': u'\U0001F1F5\U0001F1F9',
    'flag_for_Puerto_Rico': u'\U0001F1F5\U0001F1F7',
    'flag_for_Qatar': u'\U0001F1F6\U0001F1E6',
    'flag_for_Romania': u'\U0001F1F7\U0001F1F4',
    'flag_for_Russia': u'\U0001F1F7\U0001F1FA',
    'flag_for_Rwanda': u'\U0001F1F7\U0001F1FC',
    'flag_for_Réunion': u'\U0001F1F7\U0001F1EA',
    'flag_for_Samoa': u'\U0001F1FC\U0001F1F8',
    'flag_for_San_Marino': u'\U0001F1F8\U0001F1F2',
    'flag_for_Saudi_Arabia': u'\U0001F1F8\U0001F1E6',
    'flag_for_Senegal': u'\U0001F1F8\U0001F1F3',
    'flag_for_Serbia': u'\U0001F1F7\U0001F1F8',
    'flag_for_Seychelles': u'\U0001F1F8\U0001F1E8',
    'flag_for_Sierra_Leone': u'\U0001F1F8\U0001F1F1',
    'flag_for_Singapore': u'\U0001F1F8\U0001F1EC',
    'flag_for_Sint_Maarten': u'\U0001F1F8\U0001F1FD',
    'flag_for_Slovakia': u'\U0001F1F8\U0001F1F0',
    'flag_for_Slovenia': u'\U0001F1F8\U0001F1EE',
    'flag_for_Solomon_Islands': u'\U0001F1F8\U0001F1E7',
    'flag_for_Somalia': u'\U0001F1F8\U0001F1F4',
    'flag_for_South_Africa': u'\U0001F1FF\U0001F1E6',
    'flag_for_South_Georgia_&_South_Sandwich_Islands': u'\U0001F1EC\U0001F1F8',
    'flag_for_South_Korea': u'\U0001F1F0\U0001F1F7',
    'flag_for_South_Sudan': u'\U0001F1F8\U0001F1F8',
    'flag_for_Spain': u'\U0001F1EA\U0001F1F8',
    'flag_for_Sri_Lanka': u'\U0001F1F1\U0001F1F0',
    'flag_for_St._Barthélemy': u'\U0001F1E7\U0001F1F1',
    'flag_for_St._Helena': u'\U0001F1F8\U0001F1ED',
    'flag_for_St._Kitts_&_Nevis': u'\U0001F1F0\U0001F1F3',
    'flag_for_St._Lucia': u'\U0001F1F1\U0001F1E8',
    'flag_for_St._Martin': u'\U0001F1F2\U0001F1EB',
    'flag_for_St._Pierre_&_Miquelon': u'\U0001F1F5\U0001F1F2',
    'flag_for_St._Vincent_&_Grenadines': u'\U0001F1FB\U0001F1E8',
    'flag_for_Sudan': u'\U0001F1F8\U0001F1E9',
    'flag_for_Suriname': u'\U0001F1F8\U0001F1F7',
    'flag_for_Svalbard_&_Jan_Mayen': u'\U0001F1F8\U0001F1EF',
    'flag_for_Swaziland': u'\U0001F1F8\U0001F1FF',
    'flag_for_Sweden': u'\U0001F1F8\U0001F1EA',
    'flag_for_Switzerland': u'\U0001F1E8\U0001F1ED',
    'flag_for_Syria': u'\U0001F1F8\U0001F1FE',
    'flag_for_São_Tomé_&_Príncipe': u'\U0001F1F8\U0001F1F9',
    'flag_for_Taiwan': u'\U0001F1F9\U0001F1FC',
    'flag_for_Tajikistan': u'\U0001F1F9\U0001F1EF',
    'flag_for_Tanzania': u'\U0001F1F9\U0001F1FF',
    'flag_for_Thailand': u'\U0001F1F9\U0001F1ED',
    'flag_for_Timor__Leste': u'\U0001F1F9\U0001F1F1',
    'flag_for_Togo': u'\U0001F1F9\U0001F1EC',
    'flag_for_Tokelau': u'\U0001F1F9\U0001F1F0',
    'flag_for_Tonga': u'\U0001F1F9\U0001F1F4',
    'flag_for_Trinidad_&_Tobago': u'\U0001F1F9\U0001F1F9',
    'flag_for_Tristan_da_Cunha': u'\U0001F1F9\U0001F1E6',
    'flag_for_Tunisia': u'\U0001F1F9\U0001F1F3',
    'flag_for_Turkey': u'\U0001F1F9\U0001F1F7',
    'flag_for_Turkmenistan': u'\U0001F1F9\U0001F1F2',
    'flag_for_Turks_&_Caicos_Islands': u'\U0001F1F9\U0001F1E8',
    'flag_for_Tuvalu': u'\U0001F1F9\U0001F1FB',
    'flag_for_U.S._Outlying_Islands': u'\U0001F1FA\U0001F1F2',
    'flag_for_U.S._Virgin_Islands': u'\U0001F1FB\U0001F1EE',
    'flag_for_Uganda': u'\U0001F1FA\U0001F1EC',
    'flag_for_Ukraine': u'\U0001F1FA\U0001F1E6',
    'flag_for_United_Arab_Emirates': u'\U0001F1E6\U0001F1EA',
    'flag_for_United_Kingdom': u'\U0001F1EC\U0001F1E7',
    'flag_for_United_States': u'\U0001F1FA\U0001F1F8',
    'flag_for_Uruguay': u'\U0001F1FA\U0001F1FE',
    'flag_for_Uzbekistan': u'\U0001F1FA\U0001F1FF',
    'flag_for_Vanuatu': u'\U0001F1FB\U0001F1FA',
    'flag_for_Vatican_City': u'\U0001F1FB\U0001F1E6',
    'flag_for_Venezuela': u'\U0001F1FB\U0001F1EA',
    'flag_for_Vietnam': u'\U0001F1FB\U0001F1F3',
    'flag_for_Wallis_&_Futuna': u'\U0001F1FC\U0001F1EB',
    'flag_for_Western_Sahara': u'\U0001F1EA\U0001F1ED',
    'flag_for_Yemen': u'\U0001F1FE\U0001F1EA',
    'flag_for_Zambia': u'\U0001F1FF\U0001F1F2',
    'flag_for_Zimbabwe': u'\U0001F1FF\U0001F1FC',
    'flag_for_Åland_Islands': u'\U0001F1E6\U0001F1FD',
    'golf': u'\U000026F3',
    'fleur__de__lis': u'\U0000269C',
    'muscle': u'\U0001F4AA',
    'floppy_disk': u'\U0001F4BE',
    'flower_playing_cards': u'\U0001F3B4',
    'flushed': u'\U0001F633',
    'fog': u'\U0001F32B',
    'foggy': u'\U0001F301',
    'footprints': u'\U0001F463',
    'fork_and_knife': u'\U0001F374',
    'fork_and_knife_with_plate': u'\U0001F37D',
    'fountain': u'\U000026F2',
    'four_leaf_clover': u'\U0001F340',
    'frame_with_picture': u'\U0001F5BC',
    'fries': u'\U0001F35F',
    'fried_shrimp': u'\U0001F364',
    'frog': u'\U0001F438',
    'hatched_chick': u'\U0001F425',
    'frowning': u'\U0001F626',
    'fuelpump': u'\U000026FD',
    'full_moon': u'\U0001F315',
    'full_moon_with_face': u'\U0001F31D',
    'funeral_urn': u'\U000026B1',
    'game_die': u'\U0001F3B2',
    'gear': u'\U00002699',
    'gem': u'\U0001F48E',
    'gemini': u'\U0000264A',
    'ghost': u'\U0001F47B',
    'girl': u'\U0001F467',
    'globe_with_meridians': u'\U0001F310',
    'star2': u'\U0001F31F',
    'goat': u'\U0001F410',
    'golfer': u'\U0001F3CC',
    'mortar_board': u'\U0001F393',
    'grapes': u'\U0001F347',
    'green_apple': u'\U0001F34F',
    'green_book': u'\U0001F4D7',
    'green_heart': u'\U0001F49A',
    'grimacing': u'\U0001F62C',
    'smile_cat': u'\U0001F638',
    'grinning': u'\U0001F600',
    'grin': u'\U0001F601',
    'heartpulse': u'\U0001F497',
    'guardsman': u'\U0001F482',
    'guitar': u'\U0001F3B8',
    'haircut': u'\U0001F487',
    'hamburger': u'\U0001F354',
    'hammer': u'\U0001F528',
    'hammer_and_pick': u'\U00002692',
    'hammer_and_wrench': u'\U0001F6E0',
    'hamster': u'\U0001F439',
    'handbag': u'\U0001F45C',
    'raising_hand': u'\U0001F64B',
    'hatching_chick': u'\U0001F423',
    'headphones': u'\U0001F3A7',
    'hear_no_evil': u'\U0001F649',
    'heart_decoration': u'\U0001F49F',
    'cupid': u'\U0001F498',
    'gift_heart': u'\U0001F49D',
    'heart': u'\U00002764',
    'heavy_check_mark': u'\U00002714',
    'heavy_division_sign': u'\U00002797',
    'heavy_dollar_sign': u'\U0001F4B2',
    'exclamation': u'\U00002757',
    'heavy_exclamation_mark': u'\U00002757',
    'heavy_heart_exclamation_mark_ornament': u'\U00002763',
    'o': u'\U00002B55',
    'heavy_minus_sign': u'\U00002796',
    'heavy_multiplication_x': u'\U00002716',
    'heavy_plus_sign': u'\U00002795',
    'helicopter': u'\U0001F681',
    'helm_symbol': u'\U00002388',
    'helmet_with_white_cross': u'\U000026D1',
    'herb': u'\U0001F33F',
    'hibiscus': u'\U0001F33A',
    'high_heel': u'\U0001F460',
    'bullettrain_side': u'\U0001F684',
    'bullettrain_front': u'\U0001F685',
    'high_brightness': u'\U0001F506',
    'zap': u'\U000026A1',
    'hocho': u'\U0001F52A',
    'knife': u'\U0001F52A',
    'hole': u'\U0001F573',
    'honey_pot': u'\U0001F36F',
    'bee': u'\U0001F41D',
    'traffic_light': u'\U0001F6A5',
    'racehorse': u'\U0001F40E',
    'horse': u'\U0001F434',
    'horse_racing': u'\U0001F3C7',
    'hospital': u'\U0001F3E5',
    'coffee': u'\U00002615',
    'hot_dog': u'\U0001F32D',
    'hot_pepper': u'\U0001F336',
    'hotsprings': u'\U00002668',
    'hotel': u'\U0001F3E8',
    'hourglass': u'\U0000231B',
    'hourglass_flowing_sand': u'\U000023F3',
    'house': u'\U0001F3E0',
    'house_buildings': u'\U0001F3D8',
    'house_with_garden': u'\U0001F3E1',
    'hugging_face': u'\U0001F917',
    '100': u'\U0001F4AF',
    'hushed': u'\U0001F62F',
    'ice_cream': u'\U0001F368',
    'ice_hockey_stick_and_puck': u'\U0001F3D2',
    'ice_skate': u'\U000026F8',
    'imp': u'\U0001F47F',
    'inbox_tray': u'\U0001F4E5',
    'incoming_envelope': u'\U0001F4E8',
    'information_desk_person': u'\U0001F481',
    'information_source': u'\U00002139',
    'capital_abcd': u'\U0001F520',
    'abc': u'\U0001F524',
    'abcd': u'\U0001F521',
    '1234': u'\U0001F522',
    'symbols': u'\U0001F523',
    'izakaya_lantern': u'\U0001F3EE',
    'lantern': u'\U0001F3EE',
    'jack_o_lantern': u'\U0001F383',
    'japanese_castle': u'\U0001F3EF',
    'dolls': u'\U0001F38E',
    'japanese_goblin': u'\U0001F47A',
    'japanese_ogre': u'\U0001F479',
    'post_office': u'\U0001F3E3',
    'beginner': u'\U0001F530',
    'jeans': u'\U0001F456',
    'joystick': u'\U0001F579',
    'kaaba': u'\U0001F54B',
    'key': u'\U0001F511',
    'keyboard': u'\U00002328',
    'keycap_asterisk': u'\U0000002A\U000020E3',
    'keycap_digit_eight': u'\U00000038\U000020E3',
    'keycap_digit_five': u'\U00000035\U000020E3',
    'keycap_digit_four': u'\U00000034\U000020E3',
    'keycap_digit_nine': u'\U00000039\U000020E3',
    'keycap_digit_one': u'\U00000031\U000020E3',
    'keycap_digit_seven': u'\U00000037\U000020E3',
    'keycap_digit_six': u'\U00000036\U000020E3',
    'keycap_digit_three': u'\U00000033\U000020E3',
    'keycap_digit_two': u'\U00000032\U000020E3',
    'keycap_digit_zero': u'\U00000030\U000020E3',
    'keycap_number_sign': u'\U00000023\U000020E3',
    'keycap_ten': u'\U0001F51F',
    'zero': u'\U00000030\U0000FE0F\U000020E3',
    'one': u'\U00000031\U0000FE0F\U000020E3',
    'ten': u'\U0001F51F',
    'two': u'\U00000032\U0000FE0F\U000020E3',
    'three': u'\U00000033\U0000FE0F\U000020E3',
    'four': u'\U00000034\U0000FE0F\U000020E3',
    'five': u'\U00000035\U0000FE0F\U000020E3',
    'six': u'\U00000036\U0000FE0F\U000020E3',
    'seven': u'\U00000037\U0000FE0F\U000020E3',
    'eight': u'\U00000038\U0000FE0F\U000020E3',
    'nine': u'\U00000039\U0000FE0F\U000020E3',
    'kimono': u'\U0001F458',
    'couplekiss': u'\U0001F48F',
    'kiss': u'\U0001F48B',
    'kissing_cat': u'\U0001F63D',
    'kissing': u'\U0001F617',
    'kissing_closed_eyes': u'\U0001F61A',
    'kissing_smiling_eyes': u'\U0001F619',
    'koala': u'\U0001F428',
    'label': u'\U0001F3F7',
    'beetle': u'\U0001F41E',
    'large_blue_circle': u'\U0001F535',
    'large_blue_diamond': u'\U0001F537',
    'large_orange_diamond': u'\U0001F536',
    'red_circle': u'\U0001F534',
    'last_quarter_moon': u'\U0001F317',
    'last_quarter_moon_with_face': u'\U0001F31C',
    'latin_cross': u'\U0000271D',
    'leaves': u'\U0001F343',
    'ledger': u'\U0001F4D2',
    'mag': u'\U0001F50D',
    'left_luggage': u'\U0001F6C5',
    'left_right_arrow': u'\U00002194',
    'leftwards_arrow_with_hook': u'\U000021A9',
    'arrow_left': u'\U00002B05',
    'lemon': u'\U0001F34B',
    'leo': u'\U0000264C',
    'leopard': u'\U0001F406',
    'level_slider': u'\U0001F39A',
    'libra': u'\U0000264E',
    'light_rail': u'\U0001F688',
    'link': u'\U0001F517',
    'linked_paperclips': u'\U0001F587',
    'lion_face': u'\U0001F981',
    'lipstick': u'\U0001F484',
    'lock': u'\U0001F512',
    'lock_with_ink_pen': u'\U0001F50F',
    'lollipop': u'\U0001F36D',
    'sob': u'\U0001F62D',
    'love_hotel': u'\U0001F3E9',
    'love_letter': u'\U0001F48C',
    'low_brightness': u'\U0001F505',
    'lower_left_ballpoint_pen': u'\U0001F58A',
    'lower_left_crayon': u'\U0001F58D',
    'lower_left_fountain_pen': u'\U0001F58B',
    'lower_left_paintbrush': u'\U0001F58C',
    'mahjong': u'\U0001F004',
    'man': u'\U0001F468',
    'couple': u'\U0001F46B',
    'man_in_business_suit_levitating': u'\U0001F574',
    'man_with_gua_pi_mao': u'\U0001F472',
    'man_with_turban': u'\U0001F473',
    'mans_shoe': u'\U0001F45E',
    'shoe': u'\U0001F45E',
    'mantelpiece_clock': u'\U0001F570',
    'maple_leaf': u'\U0001F341',
    'meat_on_bone': u'\U0001F356',
    'black_circle': u'\U000026AB',
    'white_circle': u'\U000026AA',
    'melon': u'\U0001F348',
    'memo': u'\U0001F4DD',
    'pencil': u'\U0001F4DD',
    'menorah_with_nine_branches': u'\U0001F54E',
    'mens': u'\U0001F6B9',
    'metro': u'\U0001F687',
    'microphone': u'\U0001F3A4',
    'microscope': u'\U0001F52C',
    'military_medal': u'\U0001F396',
    'milky_way': u'\U0001F30C',
    'minibus': u'\U0001F690',
    'minidisc': u'\U0001F4BD',
    'iphone': u'\U0001F4F1',
    'mobile_phone_off': u'\U0001F4F4',
    'calling': u'\U0001F4F2',
    'money__mouth_face': u'\U0001F911',
    'moneybag': u'\U0001F4B0',
    'money_with_wings': u'\U0001F4B8',
    'monkey': u'\U0001F412',
    'monkey_face': u'\U0001F435',
    'monorail': u'\U0001F69D',
    'rice_scene': u'\U0001F391',
    'mosque': u'\U0001F54C',
    'motor_boat': u'\U0001F6E5',
    'motorway': u'\U0001F6E3',
    'mount_fuji': u'\U0001F5FB',
    'mountain': u'\U000026F0',
    'mountain_bicyclist': u'\U0001F6B5',
    'mountain_cableway': u'\U0001F6A0',
    'mountain_railway': u'\U0001F69E',
    'mouse2': u'\U0001F401',
    'mouse': u'\U0001F42D',
    'lips': u'\U0001F444',
    'movie_camera': u'\U0001F3A5',
    'moyai': u'\U0001F5FF',
    'notes': u'\U0001F3B6',
    'mushroom': u'\U0001F344',
    'musical_keyboard': u'\U0001F3B9',
    'musical_note': u'\U0001F3B5',
    'musical_score': u'\U0001F3BC',
    'nail_care': u'\U0001F485',
    'name_badge': u'\U0001F4DB',
    'national_park': u'\U0001F3DE',
    'necktie': u'\U0001F454',
    'ab': u'\U0001F18E',
    'negative_squared_cross_mark': u'\U0000274E',
    'a': u'\U0001F170',
    'b': u'\U0001F171',
    'o2': u'\U0001F17E',
    'parking': u'\U0001F17F',
    'nerd_face': u'\U0001F913',
    'neutral_face': u'\U0001F610',
    'new_moon': u'\U0001F311',
    'honeybee': u'\U0001F41D',
    'new_moon_with_face': u'\U0001F31A',
    'newspaper': u'\U0001F4F0',
    'night_with_stars': u'\U0001F303',
    'no_bicycles': u'\U0001F6B3',
    'no_entry': u'\U000026D4',
    'no_entry_sign': u'\U0001F6AB',
    'no_mobile_phones': u'\U0001F4F5',
    'underage': u'\U0001F51E',
    'no_pedestrians': u'\U0001F6B7',
    'no_smoking': u'\U0001F6AD',
    'non__potable_water': u'\U0001F6B1',
    'arrow_upper_right': u'\U00002197',
    'arrow_upper_left': u'\U00002196',
    'nose': u'\U0001F443',
    'notebook': u'\U0001F4D3',
    'notebook_with_decorative_cover': u'\U0001F4D4',
    'nut_and_bolt': u'\U0001F529',
    'octopus': u'\U0001F419',
    'oden': u'\U0001F362',
    'office': u'\U0001F3E2',
    'oil_drum': u'\U0001F6E2',
    'ok_hand': u'\U0001F44C',
    'old_key': u'\U0001F5DD',
    'older_man': u'\U0001F474',
    'older_woman': u'\U0001F475',
    'om_symbol': u'\U0001F549',
    'on': u'\U0001F51B',
    'oncoming_automobile': u'\U0001F698',
    'oncoming_bus': u'\U0001F68D',
    'oncoming_police_car': u'\U0001F694',
    'oncoming_taxi': u'\U0001F696',
    'book': u'\U0001F4D6',
    'open_book': u'\U0001F4D6',
    'open_file_folder': u'\U0001F4C2',
    'open_hands': u'\U0001F450',
    'unlock': u'\U0001F513',
    'mailbox_with_no_mail': u'\U0001F4ED',
    'mailbox_with_mail': u'\U0001F4EC',
    'ophiuchus': u'\U000026CE',
    'cd': u'\U0001F4BF',
    'orange_book': u'\U0001F4D9',
    'orthodox_cross': u'\U00002626',
    'outbox_tray': u'\U0001F4E4',
    'ox': u'\U0001F402',
    'package': u'\U0001F4E6',
    'page_facing_up': u'\U0001F4C4',
    'page_with_curl': u'\U0001F4C3',
    'pager': u'\U0001F4DF',
    'palm_tree': u'\U0001F334',
    'panda_face': u'\U0001F43C',
    'paperclip': u'\U0001F4CE',
    'part_alternation_mark': u'\U0000303D',
    'tada': u'\U0001F389',
    'passenger_ship': u'\U0001F6F3',
    'passport_control': u'\U0001F6C2',
    'feet': u'\U0001F43E',
    'paw_prints': u'\U0001F43E',
    'peace_symbol': u'\U0000262E',
    'peach': u'\U0001F351',
    'pear': u'\U0001F350',
    'walking': u'\U0001F6B6',
    'pencil2': u'\U0000270F',
    'penguin': u'\U0001F427',
    'pensive': u'\U0001F614',
    'performing_arts': u'\U0001F3AD',
    'persevere': u'\U0001F623',
    'bow': u'\U0001F647',
    'person_frowning': u'\U0001F64D',
    'raised_hands': u'\U0001F64C',
    'person_with_ball': u'\U000026F9',
    'person_with_blond_hair': u'\U0001F471',
    'pray': u'\U0001F64F',
    'person_with_pouting_face': u'\U0001F64E',
    'computer': u'\U0001F4BB',
    'pick': u'\U000026CF',
    'pig2': u'\U0001F416',
    'pig': u'\U0001F437',
    'pig_nose': u'\U0001F43D',
    'hankey': u'\U0001F4A9',
    'poop': u'\U0001F4A9',
    'shit': u'\U0001F4A9',
    'pill': u'\U0001F48A',
    'bamboo': u'\U0001F38D',
    'pineapple': u'\U0001F34D',
    'pisces': u'\U00002653',
    'gun': u'\U0001F52B',
    'place_of_worship': u'\U0001F6D0',
    'black_joker': u'\U0001F0CF',
    'police_car': u'\U0001F693',
    'rotating_light': u'\U0001F6A8',
    'cop': u'\U0001F46E',
    'poodle': u'\U0001F429',
    'popcorn': u'\U0001F37F',
    'postal_horn': u'\U0001F4EF',
    'postbox': u'\U0001F4EE',
    'stew': u'\U0001F372',
    'potable_water': u'\U0001F6B0',
    'pouch': u'\U0001F45D',
    'poultry_leg': u'\U0001F357',
    'pouting_cat': u'\U0001F63E',
    'rage': u'\U0001F621',
    'prayer_beads': u'\U0001F4FF',
    'princess': u'\U0001F478',
    'printer': u'\U0001F5A8',
    'loudspeaker': u'\U0001F4E2',
    'purple_heart': u'\U0001F49C',
    'purse': u'\U0001F45B',
    'pushpin': u'\U0001F4CC',
    'put_litter_in_its_place': u'\U0001F6AE',
    'rabbit2': u'\U0001F407',
    'rabbit': u'\U0001F430',
    'racing_car': u'\U0001F3CE',
    'racing_motorcycle': u'\U0001F3CD',
    'radio': u'\U0001F4FB',
    'radio_button': u'\U0001F518',
    'radioactive_sign': u'\U00002622',
    'railway_car': u'\U0001F683',
    'railway_track': u'\U0001F6E4',
    'rainbow': u'\U0001F308',
    'fist': u'\U0000270A',
    'hand': u'\U0000270B',
    'raised_hand': u'\U0000270B',
    'raised_hand_with_fingers_splayed': u'\U0001F590',
    'raised_hand_with_part_between_middle_and_ring_fingers': u'\U0001F596',
    'ram': u'\U0001F40F',
    'rat': u'\U0001F400',
    'blue_car': u'\U0001F699',
    'apple': u'\U0001F34E',
    'registered': u'\U000000AE',
    'relieved': u'\U0001F60C',
    'reminder_ribbon': u'\U0001F397',
    'restroom': u'\U0001F6BB',
    'reversed_hand_with_middle_finger_extended': u'\U0001F595',
    'revolving_hearts': u'\U0001F49E',
    'ribbon': u'\U0001F380',
    'rice_ball': u'\U0001F359',
    'rice_cracker': u'\U0001F358',
    'mag_right': u'\U0001F50E',
    'right_anger_bubble': u'\U0001F5EF',
    'arrow_right_hook': u'\U000021AA',
    'ring': u'\U0001F48D',
    'sweet_potato': u'\U0001F360',
    'robot_face': u'\U0001F916',
    'rocket': u'\U0001F680',
    'rolled__up_newspaper': u'\U0001F5DE',
    'roller_coaster': u'\U0001F3A2',
    'rooster': u'\U0001F413',
    'rose': u'\U0001F339',
    'rosette': u'\U0001F3F5',
    'round_pushpin': u'\U0001F4CD',
    'rowboat': u'\U0001F6A3',
    'rugby_football': u'\U0001F3C9',
    'runner': u'\U0001F3C3',
    'running': u'\U0001F3C3',
    'running_shirt_with_sash': u'\U0001F3BD',
    'sagittarius': u'\U00002650',
    'boat': u'\U000026F5',
    'sailboat': u'\U000026F5',
    'sake': u'\U0001F376',
    'satellite': u'\U0001F4E1',
    'saxophone': u'\U0001F3B7',
    'scales': u'\U00002696',
    'school': u'\U0001F3EB',
    'school_satchel': u'\U0001F392',
    'scorpion': u'\U0001F982',
    'scorpius': u'\U0000264F',
    'scroll': u'\U0001F4DC',
    'seat': u'\U0001F4BA',
    'see_no_evil': u'\U0001F648',
    'seedling': u'\U0001F331',
    'shamrock': u'\U00002618',
    'shaved_ice': u'\U0001F367',
    'sheep': u'\U0001F411',
    'shield': u'\U0001F6E1',
    'shinto_shrine': u'\U000026E9',
    'ship': u'\U0001F6A2',
    'stars': u'\U0001F320',
    'shopping_bags': u'\U0001F6CD',
    'cake': u'\U0001F370',
    'shower': u'\U0001F6BF',
    'sign_of_the_horns': u'\U0001F918',
    'japan': u'\U0001F5FE',
    'six_pointed_star': u'\U0001F52F',
    'ski': u'\U0001F3BF',
    'skier': u'\U000026F7',
    'skull': u'\U0001F480',
    'skull_and_crossbones': u'\U00002620',
    'sleeping_accommodation': u'\U0001F6CC',
    'sleeping': u'\U0001F634',
    'zzz': u'\U0001F4A4',
    'sleepy': u'\U0001F62A',
    'sleuth_or_spy': u'\U0001F575',
    'pizza': u'\U0001F355',
    'slightly_frowning_face': u'\U0001F641',
    'slightly_smiling_face': u'\U0001F642',
    'slot_machine': u'\U0001F3B0',
    'small_airplane': u'\U0001F6E9',
    'small_blue_diamond': u'\U0001F539',
    'small_orange_diamond': u'\U0001F538',
    'heart_eyes_cat': u'\U0001F63B',
    'smiley_cat': u'\U0001F63A',
    'innocent': u'\U0001F607',
    'heart_eyes': u'\U0001F60D',
    'smiling_imp': u'\U0001F608',
    'smiley': u'\U0001F603',
    'sweat_smile': u'\U0001F605',
    'smile': u'\U0001F604',
    'laughing': u'\U0001F606',
    'satisfied': u'\U0001F606',
    'blush': u'\U0001F60A',
    'sunglasses': u'\U0001F60E',
    'smirk': u'\U0001F60F',
    'smoking': u'\U0001F6AC',
    'snail': u'\U0001F40C',
    'snake': u'\U0001F40D',
    'snow_capped_mountain': u'\U0001F3D4',
    'snowboarder': u'\U0001F3C2',
    'snowflake': u'\U00002744',
    'snowman': u'\U00002603',
    'soccer': u'\U000026BD',
    'icecream': u'\U0001F366',
    'soon': u'\U0001F51C',
    'arrow_lower_right': u'\U00002198',
    'arrow_lower_left': u'\U00002199',
    'spaghetti': u'\U0001F35D',
    'sparkle': u'\U00002747',
    'sparkles': u'\U00002728',
    'sparkling_heart': u'\U0001F496',
    'speak_no_evil': u'\U0001F64A',
    'speaker': u'\U0001F508',
    'mute': u'\U0001F507',
    'sound': u'\U0001F509',
    'loud_sound': u'\U0001F50A',
    'speaking_head_in_silhouette': u'\U0001F5E3',
    'speech_balloon': u'\U0001F4AC',
    'speedboat': u'\U0001F6A4',
    'spider': u'\U0001F577',
    'spider_web': u'\U0001F578',
    'spiral_calendar_pad': u'\U0001F5D3',
    'spiral_note_pad': u'\U0001F5D2',
    'shell': u'\U0001F41A',
    'sweat_drops': u'\U0001F4A6',
    'sports_medal': u'\U0001F3C5',
    'whale': u'\U0001F433',
    'u5272': u'\U0001F239',
    'u5408': u'\U0001F234',
    'u55b6': u'\U0001F23A',
    'u6307': u'\U0001F22F',
    'u6708': u'\U0001F237',
    'u6709': u'\U0001F236',
    'u6e80': u'\U0001F235',
    'u7121': u'\U0001F21A',
    'u7533': u'\U0001F238',
    'u7981': u'\U0001F232',
    'u7a7a': u'\U0001F233',
    'cl': u'\U0001F191',
    'cool': u'\U0001F192',
    'free': u'\U0001F193',
    'id': u'\U0001F194',
    'koko': u'\U0001F201',
    'sa': u'\U0001F202',
    'new': u'\U0001F195',
    'ng': u'\U0001F196',
    'ok': u'\U0001F197',
    'sos': u'\U0001F198',
    'up': u'\U0001F199',
    'vs': u'\U0001F19A',
    'stadium': u'\U0001F3DF',
    'star_and_crescent': u'\U0000262A',
    'star_of_david': u'\U00002721',
    'station': u'\U0001F689',
    'statue_of_liberty': u'\U0001F5FD',
    'steam_locomotive': u'\U0001F682',
    'ramen': u'\U0001F35C',
    'stopwatch': u'\U000023F1',
    'straight_ruler': u'\U0001F4CF',
    'strawberry': u'\U0001F353',
    'studio_microphone': u'\U0001F399',
    'partly_sunny': u'\U000026C5',
    'sun_with_face': u'\U0001F31E',
    'sunflower': u'\U0001F33B',
    'sunrise': u'\U0001F305',
    'sunrise_over_mountains': u'\U0001F304',
    'city_sunrise': u'\U0001F307',
    'surfer': u'\U0001F3C4',
    'sushi': u'\U0001F363',
    'suspension_railway': u'\U0001F69F',
    'swimmer': u'\U0001F3CA',
    'synagogue': u'\U0001F54D',
    'syringe': u'\U0001F489',
    'shirt': u'\U0001F455',
    'tshirt': u'\U0001F455',
    'table_tennis_paddle_and_ball': u'\U0001F3D3',
    'taco': u'\U0001F32E',
    'tanabata_tree': u'\U0001F38B',
    'tangerine': u'\U0001F34A',
    'taurus': u'\U00002649',
    'taxi': u'\U0001F695',
    'tea': u'\U0001F375',
    'calendar': u'\U0001F4C6',
    'telephone_receiver': u'\U0001F4DE',
    'telescope': u'\U0001F52D',
    'tv': u'\U0001F4FA',
    'tennis': u'\U0001F3BE',
    'tent': u'\U000026FA',
    'thermometer': u'\U0001F321',
    'thinking_face': u'\U0001F914',
    'thought_balloon': u'\U0001F4AD',
    'three_button_mouse': u'\U0001F5B1',
    '+1': u'\U0001F44D',
    'thumbsup': u'\U0001F44D',
    '__1': u'\U0001F44E',
    '-1': u'\U0001F44E',
    'thumbsdown': u'\U0001F44E',
    'thunder_cloud_and_rain': u'\U000026C8',
    'ticket': u'\U0001F3AB',
    'tiger2': u'\U0001F405',
    'tiger': u'\U0001F42F',
    'timer_clock': u'\U000023F2',
    'tired_face': u'\U0001F62B',
    'toilet': u'\U0001F6BD',
    'tokyo_tower': u'\U0001F5FC',
    'tomato': u'\U0001F345',
    'tongue': u'\U0001F445',
    'tophat': u'\U0001F3A9',
    'top': u'\U0001F51D',
    'trackball': u'\U0001F5B2',
    'tractor': u'\U0001F69C',
    'tm': u'\U00002122',
    'train2': u'\U0001F686',
    'tram': u'\U0001F68A',
    'train': u'\U0001F68B',
    'triangular_flag_on_post': u'\U0001F6A9',
    'triangular_ruler': u'\U0001F4D0',
    'trident': u'\U0001F531',
    'trolleybus': u'\U0001F68E',
    'trophy': u'\U0001F3C6',
    'tropical_drink': u'\U0001F379',
    'tropical_fish': u'\U0001F420',
    'trumpet': u'\U0001F3BA',
    'tulip': u'\U0001F337',
    'turkey': u'\U0001F983',
    'turtle': u'\U0001F422',
    'twisted_rightwards_arrows': u'\U0001F500',
    'two_hearts': u'\U0001F495',
    'two_men_holding_hands': u'\U0001F46C',
    'two_women_holding_hands': u'\U0001F46D',
    'umbrella': u'\U00002602',
    'umbrella_on_ground': u'\U000026F1',
    'unamused': u'\U0001F612',
    'unicorn_face': u'\U0001F984',
    'small_red_triangle': u'\U0001F53A',
    'arrow_up_small': u'\U0001F53C',
    'arrow_up_down': u'\U00002195',
    'upside__down_face': u'\U0001F643',
    'arrow_up': u'\U00002B06',
    'vertical_traffic_light': u'\U0001F6A6',
    'vibration_mode': u'\U0001F4F3',
    'v': u'\U0000270C',
    'video_camera': u'\U0001F4F9',
    'video_game': u'\U0001F3AE',
    'vhs': u'\U0001F4FC',
    'violin': u'\U0001F3BB',
    'virgo': u'\U0000264D',
    'volcano': u'\U0001F30B',
    'volleyball': u'\U0001F3D0',
    'waning_crescent_moon': u'\U0001F318',
    'waning_gibbous_moon': u'\U0001F316',
    'warning': u'\U000026A0',
    'wastebasket': u'\U0001F5D1',
    'watch': u'\U0000231A',
    'water_buffalo': u'\U0001F403',
    'wc': u'\U0001F6BE',
    'ocean': u'\U0001F30A',
    'watermelon': u'\U0001F349',
    'waving_black_flag': u'\U0001F3F4',
    'wave': u'\U0001F44B',
    'waving_white_flag': u'\U0001F3F3',
    'wavy_dash': u'\U00003030',
    'waxing_crescent_moon': u'\U0001F312',
    'moon': u'\U0001F314',
    'waxing_gibbous_moon': u'\U0001F314',
    'scream_cat': u'\U0001F640',
    'weary': u'\U0001F629',
    'wedding': u'\U0001F492',
    'weight_lifter': u'\U0001F3CB',
    'whale2': u'\U0001F40B',
    'wheel_of_dharma': u'\U00002638',
    'wheelchair': u'\U0000267F',
    'point_down': u'\U0001F447',
    'grey_exclamation': u'\U00002755',
    'white_flower': u'\U0001F4AE',
    'white_frowning_face': u'\U00002639',
    'white_check_mark': u'\U00002705',
    'white_large_square': u'\U00002B1C',
    'point_left': u'\U0001F448',
    'white_medium_small_square': u'\U000025FD',
    'white_medium_square': u'\U000025FB',
    'star': u'\U00002B50',
    'grey_question': u'\U00002754',
    'point_right': u'\U0001F449',
    'white_small_square': u'\U000025AB',
    'relaxed': u'\U0000263A',
    'white_square_button': u'\U0001F533',
    'white_sun_behind_cloud': u'\U0001F325',
    'white_sun_behind_cloud_with_rain': u'\U0001F326',
    'white_sun_with_small_cloud': u'\U0001F324',
    'point_up_2': u'\U0001F446',
    'point_up': u'\U0000261D',
    'wind_blowing_face': u'\U0001F32C',
    'wind_chime': u'\U0001F390',
    'wine_glass': u'\U0001F377',
    'wink': u'\U0001F609',
    'wolf': u'\U0001F43A',
    'woman': u'\U0001F469',
    'dancers': u'\U0001F46F',
    'boot': u'\U0001F462',
    'womans_clothes': u'\U0001F45A',
    'womans_hat': u'\U0001F452',
    'sandal': u'\U0001F461',
    'womens': u'\U0001F6BA',
    'world_map': u'\U0001F5FA',
    'worried': u'\U0001F61F',
    'gift': u'\U0001F381',
    'wrench': u'\U0001F527',
    'writing_hand': u'\U0000270D',
    'yellow_heart': u'\U0001F49B',
    'yin_yang': u'\U0000262F', 
    'zipper__mouth_face': u'\U0001F910',
    ####
    'bold': bold(),
    'dim': dim(),
    'italic': italic(),
    'underlined': underlined(),
    'hidden': hidden(),

    'reset': reset(),

    'black': black(),
    'black_': black_(),
    'white': white(),
    'white_': white_(),

    'red': red(),
    'red_': red_(),
    'green': green(),
    'green_': green_(),

    'yellow': yellow(),
    'yellow_': yellow_(),
    'blue': blue(),
    'blue_': blue_(),
    'magenta': magenta(),
    'magenta_': magenta_(),
    'cyan': cyan(),
    'cyan_': cyan_(),
    'light_gray': lgray(),
    'light_gray_': lgray_(),
    'lgray_': lgray_(),
    'gray': gray(),
    'gray_': gray_(),

    'light_red': lred(),
    'light_red_': lred_(),
    'lred_': lred_(),
    'light_green': lgreen(),
    'lgreen': lgreen(),
    'light_green_': lgreen_(),
    'lgreen_': lgreen_(),
    'light_yellow': lyellow(),
    'lyellow': lyellow(),
    'light_yellow_': lyellow_(),
    'lyellow_': lyellow_(),
    'light_blue': lblue(),
    'lblue': lblue(),
    'light_blue_': lblue_(),
    'lblue_': lblue_(),
    'light_magenta': lmagenta(),
    'lmagenta': lmagenta(),
    'light_magenta_': lmagenta_(),
    'lmagenta_': lmagenta_(),
    'light_cyan': lcyan(),
    'lcyan': lcyan(),
    'light_cyan_': lcyan_(),
    'lcyan_': lcyan_(),


    'rblack': rblack(),
    'rblack_': rblack_(),
    'reset_black': rblack(),
    'reset_black_': rblack_(),
    'rwhite': rwhite(),
    'rwhite_': rwhite_(),
    'reset_white': rwhite(),
    'reset_white_': rwhite_(),

    'rred': rred(),
    'rred_': rred_(),
    'rgreen': rgreen(),
    'rgreen_': rgreen_(),
    'ryellow': ryellow(),
    'ryellow_': ryellow_(),
    'rblue': rblue(),
    'rblue_': rblue_(),
    'rmagenta': rmagenta(),
    'rmagenta_': rmagenta_(),
    'rcyan': rcyan(),
    'rcyan_': rcyan_(),
    'rlight_gray': rlgray(),
    'rlight_gray_': rlgray_(),
    'rlgray_': rlgray_(),
    'rgray': rgray(),
    'rgray_': rgray_(),
    'rlight_red': rlred(),
    'rlight_red_': rlred_(),
    'rlred_': rlred_(),
    'rlight_green': rlgreen(),
    'rlgreen': rlgreen(),
    'rlight_green_': rlgreen_(),
    'rlgreen_': rlgreen_(),
    'rlight_yellow': rlyellow(),
    'rlyellow': rlyellow(),
    'rlight_yellow_': rlyellow_(),
    'rlyellow_': rlyellow_(),
    'rlight_blue': rlblue(),
    'rlblue': rlblue(),
    'rlight_blue_': rlblue_(),
    'rlblue_': rlblue_(),
    'rlight_magenta': rlmagenta(),
    'rlmagenta': rlmagenta(),
    'rlight_magenta_': rlmagenta_(),
    'rlmagenta_': rlmagenta_(),
    'rlight_cyan': rlcyan(),
    'rlcyan': rlcyan(),
    'rlight_cyan_': rlcyan_(),
    'rlcyan_': rlcyan_(),

    'reset_red': rred(),
    'reset_red_': rred_(),
    'reset_green': rgreen(),
    'reset_green_': rgreen_(),
    'reset_yellow': ryellow(),
    'reset_yellow_': ryellow_(),
    'reset_blue': rblue(),
    'reset_blue_': rblue_(),
    'reset_magenta': rmagenta(),
    'reset_magenta_': rmagenta_(),
    'reset_cyan': rcyan(),
    'reset_cyan_': rcyan_(),
    'reset_light_gray': rlgray(),
    'reset_light_gray_': rlgray_(),
    'reset_lgray_': rlgray_(),
    'reset_gray': rgray(),
    'reset_gray_': rgray_(),
    'reset_light_red': rlred(),
    'reset_light_red_': rlred_(),
    'reset_lred_': rlred_(),
    'reset_light_green': rlgreen(),
    'reset_lgreen': rlgreen(),
    'reset_light_green_': rlgreen_(),
    'reset_lgreen_': rlgreen_(),
    'reset_light_yellow': rlyellow(),
    'reset_lyellow': rlyellow(),
    'reset_light_yellow_': rlyellow_(),
    'reset_lyellow_': rlyellow_(),
    'reset_light_blue': rlblue(),
    'reset_lblue': rlblue(),
    'reset_light_blue_': rlblue_(),
    'reset_lblue_': rlblue_(),
    'reset_light_magenta': rlmagenta(),
    'reset_lmagenta': rlmagenta(),
    'reset_light_magenta_': rlmagenta_(),
    'reset_lmagenta_': rlmagenta_(),
    'reset_light_cyan': rlcyan(),
    'reset_lcyan': rlcyan(),
    'reset_light_cyan_': rlcyan_(),
    'reset_lcyan_': rlcyan_(),
}

TERMCC_UNICODE_REVERSE_KV = {v: k for k, v in TERMCC_UNICODE.items()}

if __name__ == '__main__':
    print(TERMCC_UNICODE.values())
    print(TERMCC_UNICODE.keys())
